pluginName=plugin:GetName()
importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"

-- to do
-- internationalization for new zones and cust annots

-- test with a map with >200 custom annotations for time to process

-- add time elapsed to mmexport process when in debug mode, output to chat

-- fix annotation tool to capture target name and description from player target when in interior locations
-- -- add 200+ annotations to Archet map. delete all TM_Cust files
-- -- run MMExport and see how long the process takes for arche map, breeland map and total

-- implement scalable fonts?? fontsupport.lua now has everything needed, just a LOT of work :(
-- foreign language support, need missing french and german translations of String.lua
-- overlays for travel routes?

locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
end
if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end
replaceStr={[128]="A",[129]="A",[130]="A",[131]="A",[132]="A",[133]="A",[134]="AE",[135]="C",[136]="E",[137]="E",[138]="E",[139]="E",[140]="I",[141]="I",[142]="I",[143]="I",[144]="",[145]="N",[146]="O",[147]="O",[148]="O",[149]="O",[150]="O",[151]="",[152]="O",[153]="U",[154]="U",[155]="U",[156]="U",[157]="Y",[158]="Y",[159]="sz",[160]="a",[161]="a",[162]="a",[163]="a",[164]="a",[165]="a",[166]="ae",[167]="c",[168]="e",[169]="e",[170]="e",[171]="e",[172]="i",[173]="i",[174]="i",[175]="i",[176]="o",[177]="n",[178]="o",[179]="o",[180]="o",[181]="o",[182]="o",[183]="",[184]="o",[185]="u",[186]="u",[187]="u",[188]="u",[189]="y",[190]="y",[191]="y"}
string.stripaccent=function(str)
	local ret = "";
	if str~=nil then
		ret=""
		local replace=false
		for i,v in ipairs({str:byte(1,-1)}) do
			if replace then
				replace=false
				if replaceStr[v]~=nil then
					ret=ret..replaceStr[v]
				end
			else
				if (v==195) then
					replace=true
				else
					ret = ret .. string.char(v);
				end
			end
		end
	end
	return ret;
end
string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	if str==nil then
		return nil
	else
		return (string.gsub(str, "^%s*(.-)", "%1"))
	end
end
string.rtrim=function(str)
	if str==nil then
		return nil
	else
		return (string.gsub(str, "^(.-)%s*$", "%1"))
	end
end
string.trim=function(str)
	if str==nil then
		return nil
	else
		return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
	end
end
string.encode=function(str)
	-- replace all non-alpha characters with a % escaped hex code
	local ret=""
	for i,v in ipairs({str:byte(1,-1)}) do
		if (v < 48) or (v>57 and v<65) or (v>90 and v<97) or (v > 125) then
			ret = ret .. "%" .. string.sub("00"..string.format("%x",tonumber(v)),-2)
		else
			ret = ret .. string.char(v)
		end
	end
	return ret
end
string.decode=function(str)
	local ret=""
	while string.len(str)~=0 do
		local char=string.sub(str,1,1)
		if char~="%" then
			ret=ret..char
			str=string.sub(str,2,-1)
		else
			local char=string.char(tonumber("0x"..string.sub(str,2,3)))
			ret=ret..char
			str = string.sub(str,4,-1)
		end
	end
	return ret;
end

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end
-- create a limited version of TerrainMap Grid for offsets
Grid={}
Grid[1]={}
Grid[2]={}
Grid[3]={}
Grid[4]={}
Grid[1].NSOffset=26
Grid[1].EWOffset=-110.75
Grid[2].NSOffset=47.62
Grid[2].EWOffset=-119.6
Grid[3].NSOffset=-15.6
Grid[3].EWOffset=-96.4
Grid[4].NSOffset=-15.6
Grid[4].EWOffset=-25.2

Grid[1].YOffSet=37400
Grid[1].XOffSet=9200
Grid[2].YOffSet=42800
Grid[2].XOffSet=7000
Grid[3].YOffSet=21200
Grid[3].XOffSet=12800
Grid[3].YOffSet=27000
Grid[3].XOffSet=12800
Grid[4].YOffSet=27000
Grid[4].XOffSet=30600

GetHVXYfromNSEW=function(region,ns,ew)
	local ns2=(Grid[region].NSOffset-ns)*1.25
	local ew2=(ew-Grid[region].EWOffset)*1.25
	local h=math.floor(ew2)
	local v=math.floor(ns2)
	local x=math.floor((ew2-h)*200+.5)
	local y=math.floor((ns2-v)*200+.5)
	return {["H"]=h,["V"]=v,["X"]=x,["Y"]=y}
end
startTime=Turbine.Engine.GetLocalTime() -- used to determine if saved custom annotations are already synched

import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
cmds=Turbine.Shell.GetCommands()
displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()
Settings=PatchDataLoad(Turbine.DataScope.Character, "MoorMapSettings");
if Settings==nil then
	Settings=PatchDataLoad(Turbine.DataScope.Account, "MoorMapSettings");
	if Settings==nil then Settings={} end
end
if tostring(type(Settings))=="table" then
	if Settings[1]~=nil then
		local tmpSettings={}
		-- convert old format to new format
		for index,data in ipairs(Settings) do
			tmpSettings[data[1]]=Table.Copy(data[2]);
			tmpSettings[index]=nil;
		end
		Settings=tmpSettings
	end
end
if Settings.MapTopPercent==nil then
	if Settings.MapTop==nil then
		Settings.MapTopPercent=0
	else
		Settings.MapTopPercent=tonumber(Settings.MapTop)/displayHeight
	end
else
	Settings.MapTopPercent=euroNormalize(Settings.MapTopPercent);
end
if Settings.MapLeftPercent==nil then
	if Settings.MapLeft==nil then
		Settings.MapLeftPercent=0
	else
		Settings.MapLeftPercent=tonumber(Settings.MapLeft)/displayWidth
	end
else
	Settings.MapLeftPercent=euroNormalize(Settings.MapLeftPercent);
end
if Settings.MapHeightPercent==nil then
	if Settings.MapHeight==nil then
		Settings.MapHeightPercent=1
	else
		Settings.MapHeightPercent=tonumber(Settings.MapHeight)/displayHeight
	end
else
	Settings.MapHeightPercent=euroNormalize(Settings.MapHeightPercent);
end

debug=false;
debugSetting=PatchDataLoad( Turbine.DataScope.Account, "MM_Debug");
if debugSetting~=nil then
	debug=debugSetting;
end
if Settings.MapWidthPercent==nil then
	if Settings.MapWidth==nil then
		Settings.MapWidthPercent=1
	else
		Settings.MapWidthPercent=tonumber(Settings.MapWidth)/displayWidth
	end
else
	Settings.MapWidthPercent=euroNormalize(Settings.MapWidthPercent);
end
if Settings.MapHeightPercent>1 then Settings.MapHeightPercent=1 end;
if Settings.MapWidthPercent>1 then Settings.MapWidthPercent=1 end;
-- only force the map to be 32 pixels on screen
if Settings.MapTopPercent>(1-32/displayHeight) then Settings.MapTopPercent=1-32/displayHeight end;
if Settings.MapTopPercent<0-(Settings.MapHeightPercent-32/displayHeight) then Settings.MapTopPercent=0-(Settings.MapHeightPercent-32/displayHeight) end;
if Settings.MapLeftPercent>(1-32/displayWidth) then Settings.MapLeftPercent=1-32/displayWidth end;
if Settings.MapLeftPercent<0-(Settings.MapWidthPercent-32/displayWidth) then Settings.MapLeftPercent=0-(Settings.MapWidthPercent-32/displayWidth) end;
if Settings.BDDFont==nil then
	Settings.BDDFont=Turbine.UI.Lotro.Font.Verdana20
end
if Settings.BDDFontSize==nil then
	Settings.BDDFontSize=20
end
if Settings.BDDLegendTopPercent==nil then
	Settings.BDDLegendTopPercent=0
else
	Settings.BDDLegendTopPercent=euroNormalize(Settings.BDDLegendTopPercent)
end
if Settings.BDDLegendLeftPercent==nil then
	Settings.BDDLegendLeftPercent=0
else
	Settings.BDDLegendLeftPercent=euroNormalize(Settings.BDDLegendLeftPercent)
end
if Settings.EnableWaypoint==nil then Settings.EnableWaypoint=false end
if Settings.MapOpacity==nil then
	Settings.MapOpacity=1
else
	Settings.MapOpacity=euroNormalize(Settings.MapOpacity)
end
if Settings.trimColor==nil then
	Settings.trimColor=Turbine.UI.Color(.2,.5,.9);
else
	Settings.trimColor=Turbine.UI.Color(euroNormalize(Settings.trimColor.R),euroNormalize(Settings.trimColor.G),euroNormalize(Settings.trimColor.B));
end
if Settings.fontColor==nil then
	Settings.fontColor=Turbine.UI.Color(1,.9,.5)
else
	Settings.fontColor=Turbine.UI.Color(euroNormalize(Settings.fontColor.R),euroNormalize(Settings.fontColor.G),euroNormalize(Settings.fontColor.B));
end
if Settings.breadcrumbColor==nil then
	Settings.breadcrumbColor=Turbine.UI.Color(1,0,0);
else
	Settings.breadcrumbColor=Turbine.UI.Color(euroNormalize(Settings.breadcrumbColor.R),euroNormalize(Settings.breadcrumbColor.G),euroNormalize(Settings.breadcrumbColor.B));
end
if Settings.backColor==nil then
	Settings.backColor=Turbine.UI.Color(.05,.05,.05)
else
	Settings.backColor=Turbine.UI.Color(euroNormalize(Settings.backColor.R),euroNormalize(Settings.backColor.G),euroNormalize(Settings.backColor.B));
end
if Settings.headingsColor==nil then
	Settings.headingsColor=Turbine.UI.Color(1,1,1)
else
	Settings.headingsColor=Turbine.UI.Color(euroNormalize(Settings.headingsColor.R),euroNormalize(Settings.headingsColor.G),euroNormalize(Settings.headingsColor.B));
end
if Settings.listTextColor==nil then
	Settings.listTextColor=Turbine.UI.Color(1,1,1)
else
	Settings.listTextColor=Turbine.UI.Color(euroNormalize(Settings.listTextColor.R),euroNormalize(Settings.listTextColor.G),euroNormalize(Settings.listTextColor.B));
end
if Settings.defaultMap==nil then Settings.defaultMap=-2 end
if Settings.loadMinimized==nil then Settings.loadMinimized=true end
if Settings.lockAspect==nil then Settings.lockAspect=false end

if Settings.useClientLanguage==nil then
	if Settings.language==nil then
		Settings.useClientLanguage=true -- new user, default to client
	else
		Settings.useClientLanguage=false -- prior user, preserve old behaviour
	end
end
if Settings.language==nil or Settings.useClientLanguage then
	Settings.useClientLanguage=true
	if locale=="de" then
		Settings.language=3
	elseif locale=="fr" then
		Settings.language=2
	else
		Settings.language=1
	end
else
	Settings.language=tonumber(Settings.language)
end
if Settings.showIconWhenMinimized==nil then Settings.showIconWhenMinimized=true end
priorDataVersion=Settings.DataVersion
if Settings.refreshing==nil then Settings.refreshing=false end
if Settings.filterAllegianceCreep==nil then Settings.filterAllegianceCreep=true end
if Settings.filterAllegianceFreep==nil then Settings.filterAllegianceFreep=true end
if Settings.filterAllegianceDelving==nil then Settings.filterAllegianceDelving=true end

if Settings.filterOreNodeTier==nil then Settings.filterOreNodeTier=0 end
if Settings.filterWoodNodeTier==nil then Settings.filterWoodNodeTier=0 end
if Settings.filterScholarNodeTier==nil then Settings.filterScholarNodeTier=0 end

if Settings.worldName==nil then Settings.worldName="Landroval" end
if Settings.ExternalPing==nil then Settings.ExternalPing=false end
if Settings.quickWindowTopPercent==nil then
	if Settings["quickWindow.TopPercent"]==nil then
		if Settings["quickWindow.Top"]==nil then
			Settings.quickWindowTopPercent=(Turbine.UI.Display:GetHeight()-32)/displayHeight
		else
			Settings.quickWindowTopPercent=euroNormalize(Settings["quickWindow.Top"])/displayHeight
		end
	else
		Settings.quickWindowTopPercent=euroNormalize(Settings["quickWindow.TopPercent"])/displayHeight
	end
else
	Settings.quickWindowTopPercent=euroNormalize(Settings.quickWindowTopPercent)
end
if Settings.quickWindowLeftPercent==nil then
	if Settings["quickWindow.LeftPercent"]==nil then
		if Settings["quickWindow.Left"]==nil then
			Settings.quickWindowLeftPercent=32/displayWidth
		else
			Settings.quickWindowLeftPercent=euroNormalize(Settings["quickWindow.Left"])/displayWidth
		end
	else
		Settings.quickWindowLeftPercent=euroNormalize(Settings["quickWindow.LeftPercent"])/displayWidth
	end
else
	Settings.quickWindowLeftPercent=euroNormalize(Settings.quickWindowLeftPercent)
end
if Settings.quickWindowOpacity==nil then
	if Settings["quickWindow.Opacity"]==nil then
		Settings.quickWindowOpacity=.15
	else
		Settings.quickWindowOpacity=Settings["quickWindow.Opacity"]
	end
end
if Settings.quickWindowDisplayed==nil then
	if Settings["quickWindow.Displayed"]==nil then
		Settings.quickWindowDisplayed=true
	else
		Settings.quickWindowDisplayed=Settings["quickWindow.Displayed"]
	end
end
if Settings.currentMapID==nil then
	-- assign the default map since either we loaded an older version or the user never set the option
	if Settings.defaultMap==-2 then
		Settings.currentMapID=3;
	else
		Settings.currentMapID=Settings.defaultMap;
	end
end
if Settings.TMSynchInitialized==nil then Settings.TMSynchInitialized=false end
if Settings.EnableCustomSharing==nil then Settings.EnableCustomSharing=true end
if Settings.popUpTop==nil then Settings.popUpTop=-1 end
if Settings.popUpLeft==nil then Settings.popUpLeft=-1 end
if Settings.popUpPinned==nil then Settings.popUpPinned=false end
if Settings.playerNS~=nil and Settings.playerEW~=nil then Settings.showPlayerLoc=true end
if Settings.playerHeading==nil then Settings.playerHeading=0 end
-- import controls
import (importPath.."DropDownList");
import (importPath.."RadioButtonGroup");
import (importPath.."ColorPicker");
import (importPath.."FontSupport");

WaypointInstalled=false;
WaypointRunning=false;
-- check for MoorMap
local tmpPlugins=Turbine.PluginManager.GetAvailablePlugins();
local pluginIndex;
TerrainMapVersion=0
for pluginIndex=1,#tmpPlugins do
	if tmpPlugins[pluginIndex].Name=="TerrainMap" then
		TerrainMapVersion=tmpPlugins[pluginIndex].Version
		break;
	end
end

--debug=false;
--debugSetting=PatchDataLoad( Turbine.DataScope.Account, "MM_Debug");
--if debugSetting~=nil then
--	debug=debugSetting;
--end
NumCustomAnnot=0;
NumDefaultAnnot=0;
LoadedMapID=1;
HUDVisible=true;
PopUpVis=false
MapVis=false;
MinVis=false;
QuickVis=false;
OverlayVis=false;
BDDVis=false;
DebugVis=false
BreadcrumbVis=false;
SearchVis=false;

saveOverlays=true;

colorGold=Turbine.UI.Color(.80,.60,.1);
colorSilver=Turbine.UI.Color(.75,.75,.75);
colorDarkGrey=Turbine.UI.Color(.1,.1,.1);

fontFace=Turbine.UI.Lotro.Font.Verdana14;
dataLoadError=false;
saveSettings=true;
resolutionKey=tostring(displayWidth).."x"..tostring(displayHeight)

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");
undefinedCategoryIndex=1;

annotations={};
mapStrings={};
-- all annotations have the form:{Map ID, X, Y, Z, H, V, Icon (either resourceID or path), Type, TextID, Description}
-- Annotation Type follows the Map Filter types plus the Creep specific "Map In"
-- TextID is only valid for the defaults and will allow using the appropriately translated text value from Resource
mapInfo={};
-- mapInfo is in the form {MapName,Height,Width,HFactor,HOffset,WFactor,WOffset}
-- HFactor and HOffset are used in the conversion from map coordinates to pixels: X=Height*HFactor+HOffset will convert coordinate "Height" to pixel "X"
overlays={};
-- overlays are in the format:{mapID,overlayName,path,width,height,left,top,shown,layer,opacity} where mapID is the id of one of the built-in maps, overlayName is the displayed name of the overlay and path is the path relative to the "GaranStuff/MoorMap/Overlays" folder

import (importPath.."OverlayWindow");

iconInfo={};

function UnloadPlugin()
	local curLanguage=Settings.language -- need to preserve language for 'unload' message (if set to use "clientlanguage" the language gets wiped in save data
	mapWindow:SetPluginUnloading(true);
	if saveSettings then -- if there were errors loading data, the user can choose to abort saving as it would destroy their prior data
		SaveData();
	end

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mapWindow:RemoveShellCommands();
	mapWindow.MouseDoubleClick=nil;
	mapWindow.MouseClick=nil;

	if not mapWindow.PreserveMapID then
		Turbine.Shell.WriteLine("MoorMap "..Plugins["MoorMap"]:GetVersion()..Resource[curLanguage][10]);
	end
	if mapWindow~=nil and mapWindow.chatListener~=nil then
		RemoveCallback(Turbine.Chat, "Received", mapWindow.chatListener);
	end
end

function SaveData()

	PatchDataSave( Turbine.DataScope.Account, "MM_Debug", debug );
	local tmpIndex;
	local tmpCustAnnot1={};
	local tmpCustAnnot2={};
	local resolution=tostring(displayWidth).."x"..tostring(displayHeight)

	-- update the display width and height incase user changed resolution while playing
	displayWidth=Turbine.UI.Display.GetWidth()
	displayHeight=Turbine.UI.Display.GetHeight()
	Settings.MapTopPercent=mapWindow:GetTop()/displayHeight;
	Settings.MapLeftPercent=mapWindow:GetLeft()/displayWidth;
	Settings.MapHeightPercent=mapWindow:GetHeight()/displayHeight;
	Settings.MapWidthPercent=mapWindow:GetWidth()/displayWidth;

	Settings.SearchTopPercent=searchWindow:GetTop()/displayHeight;
	Settings.SearchLeftPercent=searchWindow:GetLeft()/displayWidth;

	Settings.MapOpacity=mapWindow.Map:GetOpacity();
	Settings.DataVersion=tostring(Plugins["MoorMap"]:GetVersion());

	Settings.IconTopPercent=minWindow:GetTop()/displayHeight;
	Settings.IconLeftPercent=minWindow:GetLeft()/displayWidth;
	Settings.UseMiniIcon=minWindow:GetUseMiniIcon();
	Settings.MiniIconOpaque=minWindow:GetMiniIconOpaque();

	Settings.quickWindowTopPercent=quickWindow:GetTop()/displayHeight;
	Settings.quickWindowLeftPercent=quickWindow:GetLeft()/displayWidth;
	Settings.quickWindowDisplayed=quickWindow.Displayed;
	Settings.quickWindowOpacity=quickWindow.Opacity;
	if BDDLegend~=nil then
		Settings.BDDLegendTopPercent=BDDLegend:GetTop()/displayHeight
		Settings.BDDLegendLeftPercent=BDDLegend:GetLeft()/displayWidth
	end

	Settings.popUpPinned=mapWindow.PopUpPinned
	Settings.currentMapID=nil
	Settings.refreshing=false
	Settings.playerNS=nil
	Settings.playerEW=nil
	Settings.playerHeading=nil
--	Settings.filterAllegianceCreep=nil
--	Settings.filterAllegianceFreep=nil
--	Settings.filterAllegianceDelving=nil
		Settings.filterAllegianceCreep= mapWindow.FilterPanel.AllegianceCreep:IsChecked();
		Settings.filterAllegianceFreep= mapWindow.FilterPanel.AllegianceFreep:IsChecked();
		Settings.filterAllegianceDelving= mapWindow.FilterPanel.AllegianceDelving:IsChecked();

-- clear all filters to remove any no longer used filters
	for k,v in pairs(Settings.Filters) do
		v[1]=nil
	end
-- only set the filters for currently existing filters
		for k,v in pairs(mapWindow.FilterPanel.Filters) do
			Settings.Filters[k][1]=v.CB:IsChecked()
		end
--	Settings.filterOreNodeTier=nil
--	Settings.filterWoodNodeTier=nil
--	Settings.filterScholarNodeTier=nil
		Settings.filterOreNodeTier= mapWindow.FilterPanel.TypeOreNodeTier:GetValue();
		Settings.filterWoodNodeTier= mapWindow.FilterPanel.TypeWoodNodeTier:GetValue();
		Settings.filterScholarNodeTier= mapWindow.FilterPanel.TypeScholarNodeTier:GetValue();
	if mapWindow.PreserveMapID==true then
		-- we're changing maps, save the new mapID and the search/filter settings
		Settings.refreshing=true;
		if mapWindow.showLocOnReload~=nil then
			Settings.playerNS=mapWindow.playerNS
			Settings.playerEW=mapWindow.playerEW
			Settings.playerHeading=mapWindow.Heading
		end
		if mapWindow.CurrentMapID~=nil then
			Settings.currentMapID= mapWindow.CurrentMapID;
		end
		if mapWindow.PopUp~=nil then
			Settings.popUpTop= mapWindow.PopUp:GetTop();
			Settings.popUpLeft= mapWindow.PopUp:GetLeft();
			Settings.popUpPinned=mapWindow.PopUp:IsPinned();
		end
--		Settings.filterAllegianceCreep= mapWindow.FilterPanel.AllegianceCreep:IsChecked();
--		Settings.filterAllegianceFreep= mapWindow.FilterPanel.AllegianceFreep:IsChecked();
--		Settings.filterAllegianceDelving= mapWindow.FilterPanel.AllegianceDelving:IsChecked();
--		for k,v in pairs(mapWindow.FilterPanel.Filters) do
--			Settings.Filters[k][1]=v.CB:IsChecked()
--		end
--		Settings.filterOreNodeTier= mapWindow.FilterPanel.TypeOreNodeTier:GetValue();
--		Settings.filterWoodNodeTier= mapWindow.FilterPanel.TypeWoodNodeTier:GetValue();
--		Settings.filterScholarNodeTier= mapWindow.FilterPanel.TypeScholarNodeTier:GetValue();
	elseif Settings.defaultMap==-2 then
		-- the user wants to redisplay the most recently viewed map on startup
		if mapWindow.CurrentMapID~=nil then
			Settings.currentMapID= mapWindow.CurrentMapID;
		end
	end
	if Settings.ExternalPing then
		-- if this is really an internal ping from the search window then preserve the search results
		if searchWindow:IsVisible() then
			Settings.searchText=searchWindow.searchText:GetText()
			Settings.searchResult={}
			for tmpIndex=1,searchWindow.resultList:GetItemCount() do
				local tmpItem=searchWindow.resultList:GetItem(tmpIndex)
				table.insert(Settings.searchResult,{["mapID"]=tmpItem.mapID,["ns"]=tmpItem.ns,["ew"]=tmpItem.ew,["name"]=tmpItem.name,["description"]=tmpItem.description})
			end
		else
			Settings.searchText=nil
			Settings.searchResult=nil
		end
	else
		Settings.pingNS=nil
		Settings.pingEW=nil
		Settings.pingName=nil
		Settings.pingDesc=nil
		Settings.searchText=nil
		Settings.searchResult=nil		
	end
	if Settings.useClientLanguage then
		Settings.language=0
	end

	PatchDataSave( Turbine.DataScope.Account, "MoorMapSettings", Settings);
	PatchDataSave( Turbine.DataScope.Character, "MoorMapSettings", Settings);

--[[ -- disable the old mechanism for saving custom annotations
	if LoadedMapID~=nil then
		for k,v in ipairs(annotations) do
			if v[6]==nil then
				if v[1]==LoadedMapID then
					table.insert(tmpCustAnnot1,Table.Copy(v))
				else
					table.insert(tmpCustAnnot2,Table.Copy(v))
				end
			end
		end
		if #tmpCustAnnot1>0 then
			PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(LoadedMapID), tmpCustAnnot1);
		else
			PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(LoadedMapID), nil);
		end
		-- the "MM_CustomAnotations" are for annotations added via the QuickAnnotation tool that did not land within the current map
		-- the typo in "MM_CustomAnotations" is a very old carry over and is just best left alone
		if #tmpCustAnnot2>0 then
			PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnotations", tmpCustAnnot2);
		else
			PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnotations", nil);
		end
		PatchDataSave( Turbine.DataScope.Account, "MM_Breadcrumbs_"..tostring(LoadedMapID), mapWindow.Breadcrumbs);
	end
--]]
	if defAnnWindow~=nil then
		if defAnnWindow.AnnotationText~=nil then
			local tmpAnnotText=defAnnWindow.AnnotationText:GetText();
			local tmpResourceText=defAnnWindow.ResourceText:GetText();
			if tmpAnnotText~=nil and tmpAnnotText~="" then
				-- the admin window had unsaved text, preserve it incase this is an accidental shutdown
				PatchDataSave( Turbine.DataScope.Account, "MoorMapAnnotText", tmpAnnotText);
			end
			if tmpResourceText~=nil and tmpResourceText~="" then
				PatchDataSave( Turbine.DataScope.Account, "MoorMapResourceText", tmpResourceText);
			end
		end
	end
	if saveOverlays then
		PatchDataSave( Turbine.DataScope.Account, "MM_Overlays", overlays);
	end
	PatchDataSave( Turbine.DataScope.Account, "MM_IconInfo", iconInfo);
	PatchDataSave( Turbine.DataScope.Account, "MM_MapInfo", mapInfo);
end

function LoadData()
	-- try to load saved annotations
	iconInfo=PatchDataLoad( Turbine.DataScope.Account, "MM_IconInfo"); -- this is a .plugindata file to support custom icons
	annotations=PatchDataLoad( Turbine.DataScope.Account, "MM_CustomAnotations");
	mapInfo=PatchDataLoad( Turbine.DataScope.Account, "MM_MapInfo"); -- also uses .plugindata file to allow custom map support... someday
	overlays=PatchDataLoad( Turbine.DataScope.Account, "MM_Overlays");
	if overlays==nil then overlays={} end
	for k,v in pairs(overlays) do
		if v[10]==nil then overlays[k][10]=1 end
	end
	if priorDataVersion==nil or priorDataVersion~=tostring(plugin:GetVersion()) or iconInfo==nil or iconInfo[1]==nil or iconInfo[1][7]==nil or mapInfo==nil then
		-- import defaults.lua
		-- call CreateDefaults(iconInfo,mapInfo) -- since tables are passed by reference they get updated
		-- need to preload old defaults so that the constructor can run, I need to revisit this and fix it so that it can run without these defaults
		if iconInfo==nil then iconInfo={} end
		mapInfo={}
		import (importPath.."Defaults");
		LoadDefaults(iconInfo,mapInfo)
	end
	if annotations==nil then annotations={} end
	-- I need to load the strings for each ore/wood/scholar node and their tier
	-- I use this table to derive the tier from "add" target arguments
end
nodeTier={};
import (importPath.."NodeTier")
LoadData()
if Settings.Filters==nil then
	import (importPath.."DefaultFilters")
	SetDefaultFilters(Settings)
end
for k,v in pairs(Settings.Filters) do
	if v[2]==nil then v[2]=true end
	if v[1]==nil then v[1]=v[2] end
end
-- import aux windows
import (importPath.."AnnotationsWindow");
import (importPath.."MinimizedWindow");
import (importPath.."PopUpDialog");
import (importPath.."DebugWindow");
import (importPath.."Search");
import (importPath.."IconMaint");

function AddDefaultOverlays()
	if overlays==nil then overlays={} end

	-- need to close any "holes" in overlays table
	local tmpOverlays={}
	for k,v in pairs(overlays) do
		table.insert(tmpOverlays,Table.Copy(v))
	end
	overlays=tmpOverlays

	-- overlays are in the format:{mapID,overlayName,path,width,height,left,top,shown,layer,opacity} where mapID is the id of one of the built-in maps, overlayName is the displayed name of the overlay and path is the path relative to the "GaranStuff/MoorMap/Overlays" folder
	local tmpOverlays={}
	for k,v in ipairs(overlays) do
		tmpOverlays[tostring(v[1])..":"..v[2]]=k;
	end
	if tmpOverlays["90:Path to boss"]==nil then
		table.insert(overlays,{90,"Path to boss","Isengraf/PathToBoss.tga",1600,1200,0,0,true,1,1})
	else
		overlays[tmpOverlays["90:Path to boss"]]={90,"Path to boss","TheAncientTomb/PathToBoss.tga",1600,1200,0,0,overlays[tmpOverlays["90:Path to boss"]][8],1,1}
	end
	if tmpOverlays["94:Path to boss"]==nil then
		table.insert(overlays,{94,"Path to boss","TheAncientTomb/PathToBoss.tga",1600,1200,0,0,true,1,1})
	else
		overlays[tmpOverlays["94:Path to boss"]]={94,"Path to boss","TheAncientTomb/PathToBoss.tga",1600,1200,0,0,overlays[tmpOverlays["94:Path to boss"]][8],1,1}
	end
	if tmpOverlays["122:Matalan's quest start locations"]==nil then
		table.insert(overlays,{122,"Matalan's quest start locations","Matalan/ForestWithoutFrontiers.tga",1024,768,0,0,false,1,.7})
	else
		overlays[tmpOverlays["122:Matalan's quest start locations"]]={122,"Matalan's quest start locations","Matalan/ForestWithoutFrontiers.tga",1024,768,0,0,overlays[tmpOverlays["122:Matalan's quest start locations"]][8],1,overlays[tmpOverlays["122:Matalan's quest start locations"]][10]}
	end
	-- BDD, index=mapID, value=path to map overlay - default is "BDD/Blank.tga" but if the map has tinted regions it will have it's own tga file
	tmpBDD={}
	tmpBDD[4]="BDD/Blank.tga"
	tmpBDD[5]="BDD/Blank.tga"
	tmpBDD[7]="BDD/Blank.tga"
	tmpBDD[8]="BDD/Blank.tga"
	tmpBDD[11]="BDD/Blank.tga"
	tmpBDD[12]="BDD/Blank.tga"
	tmpBDD[13]="BDD/Blank.tga"
	tmpBDD[17]="BDD/Blank.tga"
	tmpBDD[19]="BDD/Blank.tga"
	tmpBDD[20]="BDD/Blank.tga"
	tmpBDD[21]="BDD/Blank.tga"
	tmpBDD[23]="BDD/Blank.tga"
	tmpBDD[24]="BDD/Blank.tga"
	tmpBDD[25]="BDD/Blank.tga"
	tmpBDD[26]="BDD/Blank.tga"
	tmpBDD[28]="BDD/Blank.tga"
	tmpBDD[31]="BDD/Blank.tga"
	tmpBDD[32]="BDD/Blank.tga"
	tmpBDD[33]="BDD/Blank.tga"
	tmpBDD[34]="BDD/Blank.tga"
	tmpBDD[35]="BDD/Blank.tga"
	tmpBDD[36]="BDD/Blank.tga"
	tmpBDD[37]="BDD/Blank.tga"
	tmpBDD[38]="BDD/Blank.tga"
	tmpBDD[39]="BDD/Blank.tga"
	tmpBDD[41]="BDD/Blank.tga"
	tmpBDD[42]="BDD/Blank.tga"
	tmpBDD[43]="BDD/Blank.tga"
	tmpBDD[44]="BDD/Blank.tga"
	tmpBDD[45]="BDD/Blank.tga"
	tmpBDD[61]="BDD/Blank.tga"
	tmpBDD[62]="BDD/Blank.tga"
	tmpBDD[63]="BDD/Blank.tga"
	tmpBDD[67]="BDD/Blank.tga"
	tmpBDD[68]="BDD/Blank.tga"
	tmpBDD[71]="BDD/Blank.tga"
	tmpBDD[72]="BDD/Blank.tga"
	tmpBDD[73]="BDD/Blank.tga"
	tmpBDD[74]="BDD/Blank.tga"
	tmpBDD[75]="BDD/Blank.tga"
	tmpBDD[76]="BDD/Blank.tga"
	tmpBDD[77]="BDD/Blank.tga"
	tmpBDD[112]="BDD/Blank.tga"
	tmpBDD[113]="BDD/Blank.tga"

	for k,v in pairs(tmpBDD) do
		local tmpOL=tmpOverlays[tostring(k)..":Berry's Deed Data"]
		if tmpOL==nil then
			-- default visibility to false
			table.insert(overlays,{k,"Berry's Deed Data",v,1024,768,0,0,false,1,1})
		else
			-- allow updating map file but preserve visibility flag
			overlays[tmpOL]={k,"Berry's Deed Data",v,1024,768,0,0,overlays[tmpOL][8],1,overlays[tmpOL][10]}
		end
	end
end
 
-- I create the quickslot window here so that it exists prior to setting it's position, etc
	quickWindow = Turbine.UI.Window();
	quickWindow:SetSize(34,34);
	quickWindow:SetPosition(Settings.quickWindowLeftPercent*displayWidth,Settings.quickWindowTopPercent*displayHeight);
	quickWindow:SetBackground(resourcePath.."ClearBorder.tga");
	quickWindow:SetBackColor(Settings.trimColor);
	quickWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
	quickWindow.Container=Turbine.UI.Control();
	quickWindow.Container:SetParent(quickWindow);
	quickWindow.Container:SetSize(26,26);
	quickWindow.Container:SetPosition(4,4);
	quickWindow.Container:SetMouseVisible(false);
	quickWindow.Quickslot=Turbine.UI.Lotro.Quickslot();
	quickWindow.Quickslot:SetParent(quickWindow.Container);
	quickWindow.Quickslot:SetSize(66,66);
	quickWindow.Quickslot:SetPosition(-34,-34);
	quickWindow.Quickslot:SetAllowDrop(false);
	quickWindow.Quickslot.Update=function()
		-- even though drag drop is disabled, the event fires if we drag over ourselves and it causes the quickslot to get wiped out
		local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
		if locale=="fr" then
			sc:SetData("/MoorMap add ;loc:55:FR:;cible");
		elseif locale=="de" then
			sc:SetData("/MoorMap add ;pos:55:DE:;ziel");
		else
			sc:SetData("/MoorMap add ;loc:55::;target");
		end
		quickWindow.Quickslot:SetShortcut(sc);
		quickWindow.Quickslot:SetWantsUpdates(false);
	end
	quickWindow.Quickslot.DragDrop=function()
		quickWindow.Quickslot:SetWantsUpdates(true);
	end

	quickWindow.Displayed=Settings.quickWindowDisplayed;
	quickWindow.Icon=Turbine.UI.Control();
	quickWindow.Icon:SetParent(quickWindow);
	quickWindow.Icon:SetPosition(1,1);
	quickWindow.Icon:SetSize(32,32);
	quickWindow.Icon:SetBackground(resourcePath.."QuickPOI.tga");
	quickWindow.Icon:SetMouseVisible(false);
	quickWindow.Icon:SetVisible(true);
	quickWindow.Opacity=Settings.quickWindowOpacity;
	quickWindow:SetOpacity(Settings.quickWindowOpacity);
	quickWindow:SetVisible(true);
	quickWindow:SetZOrder(quickWindow:GetZOrder()+1);

	quickWindow.MouseEnter=function()
		quickWindow:SetOpacity(1);
		-- note, devs broke IsControlKeyDown so we allow Shift or Alt as well
		if quickWindow:IsControlKeyDown() or quickWindow:IsShiftKeyDown() or quickWindow:IsAltKeyDown() then
			quickWindow:SetBackground(resourcePath.."MovingBorder.tga");
			quickWindow.Quickslot:SetVisible(false);
		end
	end
	quickWindow.MouseLeave=function()
		quickWindow:SetOpacity(quickWindow.Opacity);
		quickWindow:SetBackground(resourcePath.."ClearBorder.tga");
		quickWindow.Quickslot:SetVisible(true);
	end
	quickWindow.MoveX=-1;
	quickWindow.MoveY=0;
	quickWindow.Moving=false;

	quickWindow.MouseClick = function(sender,args)
		quickWindow:SetBackground(resourcePath.."ClearBorder.tga");
		if quickWindow.Moving then
			quickWindow.Moving=false;
			quickWindow.MoveX=-1;
		end
	end
	quickWindow.MouseDown=function(sender,args)
		if quickWindow:IsControlKeyDown() or quickWindow:IsShiftKeyDown() or quickWindow:IsAltKeyDown() then
				quickWindow:SetBackground(resourcePath.."MovingBorder.tga");
				quickWindow.MoveX=args.X;
				quickWindow.MoveY=args.Y;
		end
	end
	quickWindow.MouseUp=function(sender,args)
		quickWindow:SetBackground(resourcePath.."ClearBorder.tga");
		quickWindow.MoveX=-1;
		quickWindow.MoveY=0;
		-- reestablish the quickslot incase the user dragged it out...
		if locale=="fr" then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:55:FR:;cible"))
		elseif locale=="de" then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:55:DE:;ziel"))
		else
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:55::;target"))
		end
		quickWindow.Quickslot:SetVisible(true);
	end

	quickWindow.MouseMove=function(sender,args)
		if quickWindow.MoveX~=-1 and (args.X~=quickWindow.MoveX or args.Y~= quickWindow.MoveY) then
			quickWindow:SetBackground(resourcePath.."MovingBorder.tga");
			quickWindow.Moving=true;
			local newLeft=quickWindow:GetLeft()-(quickWindow.MoveX-args.X)
			local newTop=quickWindow:GetTop()-(quickWindow.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(displayWidth-quickWindow:GetWidth()) then newLeft=displayWidth-quickWindow:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(displayHeight-quickWindow:GetHeight()) then newTop=displayHeight-quickWindow:GetHeight() end;
			quickWindow:SetPosition(newLeft,newTop);
			optionsCanvas.AnnotLeftValue:SetText(tostring(quickWindow:GetLeft()))
			optionsCanvas.AnnotTopValue:SetText(tostring(quickWindow:GetTop()))
		end
	end
--***
	quickWindow.cmdList={} -- table of chat commands for MMCust
	quickWindow.Update=function()
		-- used as handler for "/moormap add" call to MMCust
		-- used to wait for MMCust to complete and then kill it
		if Turbine.Shell.IsCommand("0MMCC") then
			Turbine.PluginManager.UnloadScriptState("MMCust")
			quickWindow:SetWantsUpdates(false)
			for k,v in ipairs(quickWindow.cmdList) do
				Turbine.Shell.RemoveCommand(v); -- remove prior cmd
			end
			quickWindow.cmdList={}
		end
	end

CreateMapList=function()
	local tmpIndex;
	-- first, sort mapInfo alphabetically (use the current language)
--	table.sort(mapInfo,function(arg1,arg2) if Resource[Settings.language][arg1[2]]<Resource[Settings.language][arg2[2]] then return(true) end end);
	table.sort(mapInfo,function(arg1,arg2) local str1=tostring(Resource[Settings.language][arg1[2]]);local str2=tostring(Resource[Settings.language][arg2[2]]);if str1<str2 then return(true) end end);
	-- then call AddMapListChildren(0,0)
	AddMapListChildren(0,0);
	-- resort mapInfo by first element (index)
	table.sort(mapInfo,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end);

	-- now, set the list element default height based on the map type
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue]~=nil and mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][11]==3 then
			mapInfo[mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][10]].hasChildren=true
			mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetForeColor(Turbine.UI.Color(.7,.7,0));
			mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetHeight(0);
		end		
	end

	if mapWindow.CurrentMapID~=nil then
		for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
			if mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue==mapWindow.CurrentMapID then
				mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetHeight(20);
				mapWindow.MapSelect:SetSelectedIndex(tmpIndex);
				break;
			end
		end
	else
		if Settings.defaultMap==-2 then
			mapWindow.MapSelect:SetSelectedIndex(3);
		else
			mapWindow.MapSelect:SetSelectedIndex(Settings.defaultMap);
		end
	end

	-- this isn't perfect, but it allows the "interior" maps to show up only after the parent has been moused over, keeping the map list limitted.
	-- the biggest issue is it causes the map list to "jump" under the cursor when child maps above the currently hovered over map get hidden. it would be better if I could get the list to scroll the correct number of entries to keep the current entry under the mouse
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		mapWindow.MapSelect.ListData:GetItem(tmpIndex).MouseHover = function(sender)
			local tmpIndex2
			for tmpIndex2=1,mapWindow.MapSelect.ListData:GetItemCount() do
				if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][10]==sender.DataValue or mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][10]==mapInfo[sender.DataValue][10] then
					mapWindow.MapSelect.ListData:GetItem(tmpIndex2):SetHeight(20);
				else
					if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][11]==3 then
-- having them re-hide was causing scrolling issues making it very hard to select certain maps
--						mapWindow.MapSelect.ListData:GetItem(tmpIndex2):SetHeight(0);
					end		
				end		
			end
		end		
	end
end
AddMapListChildren=function(parent,indent)
	local tmpIndex;
	for tmpIndex=1,#mapInfo do
		if mapInfo[tmpIndex][10]==parent then
			if mapInfo[tmpIndex].hasChildren~=null and mapInfo[tmpIndex].hasChildren then
				mapWindow.MapSelect:AddItem("*"..string.rep(" ", indent*4)..tostring(Resource[Settings.language][mapInfo[tmpIndex][2]]),mapInfo[tmpIndex][1]);
			else
				mapWindow.MapSelect:AddItem(" "..string.rep(" ", indent*4)..tostring(Resource[Settings.language][mapInfo[tmpIndex][2]]),mapInfo[tmpIndex][1]);
			end
			AddMapListChildren(mapInfo[tmpIndex][1],indent+1);
		end
	end
end
ResolveMap=function(region,NS,EW,unique)
-- this function returns a table with all of the map IDs that match the region and coordinates
	if unique==nil then
		unique=false
	end
	local tmpMap={};
	local tmpIndex;
	region=tonumber(region);
	NS=tonumber(NS);
	EW=tonumber(EW);
	local bestMap=nil
	local bestDelta=nil
	local bestZoom=nil
	for tmpIndex=1,#mapInfo do
		if mapInfo[tmpIndex][12]==region then -- same region
			if debug then
				Turbine.Shell.WriteLine("tmpIndex="..tonumber(tmpIndex)..", NS="..tostring(NS)..", EW="..tostring(EW))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][13]="..tonumber(mapInfo[tmpIndex][13]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][15]="..tonumber(mapInfo[tmpIndex][15]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][14]="..tonumber(mapInfo[tmpIndex][14]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][16]="..tonumber(mapInfo[tmpIndex][16]))
			end
			if mapInfo[tmpIndex][13]>=NS and mapInfo[tmpIndex][15]<=NS and mapInfo[tmpIndex][14]<=EW and mapInfo[tmpIndex][16]>=EW then
				if unique then
					-- determine distance from center of valid portion of map
					local tmpDY=(mapInfo[tmpIndex][13]-NS)/(mapInfo[tmpIndex][13]-mapInfo[tmpIndex][15])-.5
					local tmpDX=(mapInfo[tmpIndex][16]-EW)/(mapInfo[tmpIndex][16]-mapInfo[tmpIndex][14])-.5
					local tmpDelta=(tmpDX*tmpDX+tmpDY*tmpDY)^.5
					if debug then
						Turbine.Shell.WriteLine("tmpDX:"..tostring(tmpDX))
						Turbine.Shell.WriteLine("tmpDY:"..tostring(tmpDY))
						Turbine.Shell.WriteLine("tmpDelta:"..tostring(tmpDelta))
					end
					if bestZoom==nil or mapInfo[tmpIndex][17]>bestZoom then
						bestZoom=mapInfo[tmpIndex][17]
						bestMap=tmpIndex
						bestDelta=tmpDelta
					else
						if mapInfo[tmpIndex][17]==bestZoom and tmpDelta<bestDelta then
							bestDelta=tmpDelta
							bestMap=tmpIndex
						end
					end
				end
				-- coordinates fall on this map
				table.insert(tmpMap,tmpIndex);
			end
		end
	end
	if unique then
		if bestMap~=nil then
			tmpMap={bestMap}
		end
	end
	return tmpMap;
end

if Settings.pingDesc~=nil then
	-- Settings.pingDesc=data;
	Settings.ExternalPing=true;
	if Settings.searchText~=nil then
		searchWindow.searchText:SetText(Settings.searchText)
		if Settings.searchResult~=nil then
			for index,result in ipairs(Settings.searchResult) do
				searchWindow.AddSearchResult(result.mapID,result.ns,result.ew,result.name,Resource[Settings.language][mapInfo[result.mapID][2]],result.description)
			end
		end
		if Settings.SearchTopPercent~=nil then
			searchWindow:SetTop(Settings.SearchTopPercent*displayHeight);
		end
		if Settings.SearchLeftPercent~=nil then
			searchWindow:SetLeft(Settings.SearchLeftPercent*displayWidth);
		end
		searchWindow:SetVisible(true)
	end
end

mapWindow=Turbine.UI.Window();
mapWindow.OldWidth=mapWindow:GetWidth()
mapWindow.OldHeight=mapWindow:GetHeight()
--mapWindow:SetSize(1024,768);
mapWindow.Loaded=false;

local tmpIndex;

mapWindow.PreserveMapID=false;
mapWindow.NeedsRefresh=false;
mapWindow.PopUp=nil;
mapWindow.PopUpTop=Settings.popUpTop
mapWindow.PopUpLeft=Settings.popUpLeft
mapWindow.PopUpPinned=Settings.popUpPinned
mapWindow.playerNS=Settings.playerNS
mapWindow.playerEW=Settings.playerEW

mapWindow.CurrentMapID=Settings.currentMapID

mapWindow.PluginUnloading=false;
mapWindow.Resizing=false;
mapWindow.MoveX=-1;
mapWindow.MoveY=-1;

if locale=="fr" then
	quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:55:FR:;cible"))
elseif locale=="de" then
	quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:55:DE:;ziel"))
else
	quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:55::;target"))
end
if quickWindow:GetTop()+32>Turbine.UI.Display:GetHeight() then quickWindow:SetTop(Turbine.UI.Display:GetHeight()-32) end
if quickWindow:GetLeft()+32>Turbine.UI.Display:GetWidth() then quickWindow:SetLeft(Turbine.UI.Display:GetWidth()-32) end
	quickWindow.Quickslot:SetVisible(true);
	-- we have to force client decimal formats since we don't know what format they were saved in, iterate through annotations to fix Coordinates and mapInfo to fix Factors
for tmpIndex=1,#annotations do
	if euroFormat then
		annotations[tmpIndex][2]=euroNormalize(annotations[tmpIndex][2])
		annotations[tmpIndex][3]=euroNormalize(annotations[tmpIndex][3])
	else
		annotations[tmpIndex][2]=euroNormalize(annotations[tmpIndex][2])
		annotations[tmpIndex][3]=euroNormalize(annotations[tmpIndex][3])
	end
end
for tmpIndex=1,#mapInfo do
	if mapInfo[tmpIndex]==nil then
		mapInfo[tmpIndex]={tmpIndex,1,0,0,0,0,0,0,0,0,0,0,-0,-0,0,0,0} -- bogus map entry
	else
		mapInfo[tmpIndex][6]=euroNormalize(mapInfo[tmpIndex][6])
		mapInfo[tmpIndex][7]=euroNormalize(mapInfo[tmpIndex][7])
		mapInfo[tmpIndex][8]=euroNormalize(mapInfo[tmpIndex][8])
		mapInfo[tmpIndex][9]=euroNormalize(mapInfo[tmpIndex][9])
		if mapInfo[tmpIndex][13]~=nil then
			mapInfo[tmpIndex][13]=euroNormalize(mapInfo[tmpIndex][13])
			mapInfo[tmpIndex][14]=euroNormalize(mapInfo[tmpIndex][14])
			mapInfo[tmpIndex][15]=euroNormalize(mapInfo[tmpIndex][15])
			mapInfo[tmpIndex][16]=euroNormalize(mapInfo[tmpIndex][16])
		else
			mapInfo[tmpIndex][13]=0;
			mapInfo[tmpIndex][14]=0;
			mapInfo[tmpIndex][15]=0;
			mapInfo[tmpIndex][16]=0;
		end
	end
end

local tmpAnn={}
LoadedMapID=mapWindow.CurrentMapID;
tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(mapWindow.CurrentMapID));
if tmpAnn~=nil and type(tmpAnn)=="table" then
	NumCustomAnnot=#tmpAnn;
	for tmpIndex=1,#tmpAnn do
		-- verify coords are within bounds - some annotations get accidentally added to unbounded maps
		if debug then
			Turbine.Shell.WriteLine("N Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][13]))
			Turbine.Shell.WriteLine("S Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][15]))
			Turbine.Shell.WriteLine("W Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][14]))
			Turbine.Shell.WriteLine("E Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][16]))
			Turbine.Shell.WriteLine("NS:"..tostring(tmpAnn[tmpIndex][2]))
			Turbine.Shell.WriteLine("EW:"..tostring(tmpAnn[tmpIndex][3]))
		end
		-- force conversion of fields 2 and 3 to match current euroFormat setting
		tmpAnn[tmpIndex][2]=euroNormalize(tmpAnn[tmpIndex][2])
		tmpAnn[tmpIndex][3]=euroNormalize(tmpAnn[tmpIndex][3])
		if mapInfo[mapWindow.CurrentMapID][13]==nil or mapInfo[mapWindow.CurrentMapID][14]==nil or mapInfo[mapWindow.CurrentMapID][15]==nil or mapInfo[mapWindow.CurrentMapID][16]==nil or (tmpAnn[tmpIndex][2]<=mapInfo[mapWindow.CurrentMapID][13] and tmpAnn[tmpIndex][2]>=mapInfo[mapWindow.CurrentMapID][15] and tmpAnn[tmpIndex][3]>=mapInfo[mapWindow.CurrentMapID][14] and tmpAnn[tmpIndex][3]<=mapInfo[mapWindow.CurrentMapID][16]) then
			-- convert POI icon to custom POI icon
			if tmpAnn[tmpIndex][4]==5 then tmpAnn[tmpIndex][4]=55 end
			table.insert(annotations,{tmpAnn[tmpIndex][1],tmpAnn[tmpIndex][2],tmpAnn[tmpIndex][3],tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]});
		end
	end
end

_G.tmpAnnotations={}
--import (importPath.."Data.MapData_"..tostring(mapWindow.CurrentMapID));
pcall(import, importPath.."Data.MapData_"..tostring(mapWindow.CurrentMapID));

if _G.tmpAnnotations~=nil and type(_G.tmpAnnotations)=="table" then
	for tmpIndex=1,#_G.tmpAnnotations do
		-- force conversion of fields 2 and 3 to match current euroFormat setting
		table.insert(annotations,{_G.tmpAnnotations[tmpIndex][1],euroNormalize(_G.tmpAnnotations[tmpIndex][2]),euroNormalize(_G.tmpAnnotations[tmpIndex][3]),_G.tmpAnnotations[tmpIndex][4],_G.tmpAnnotations[tmpIndex][5],_G.tmpAnnotations[tmpIndex][6],_G.tmpAnnotations[tmpIndex][7],_G.tmpAnnotations[tmpIndex][8],_G.tmpAnnotations[tmpIndex][9],_G.tmpAnnotations[tmpIndex][10],_G.tmpAnnotations[tmpIndex][11]});
	end
end
mapStrings=Table.Copy(_G.tmpMapString)
if mapStrings==nil or type(mapStrings)~="table" then
	mapStrings={};
	for tmpLanguage in pairs(Resource) do
		mapStrings[tmpLanguage]={};
	end
end
NumDefaultStrings=#mapStrings[1]
if mapStrings[Settings.language]==nil or type(mapStrings[Settings.language])~="table" then
	mapStrings[Settings.language]={};
end
if mapWindow.CurrentMapID==1 then
	local stringOffset=#mapStrings[Settings.language];
	-- load any server specific annotations and strings and append them to the defaults
	import (importPath.."Data.MapData_1_"..Settings.worldName);
	if _G.tmpAnnotations~=nil and type(_G.tmpAnnotations)=="table" then
		for tmpIndex=1,#_G.tmpAnnotations do
			-- force conversion of fields 2 and 3 to match current euroFormat setting
			table.insert(annotations,{_G.tmpAnnotations[tmpIndex][1],euroNormalize(_G.tmpAnnotations[tmpIndex][2]),euroNormalize(_G.tmpAnnotations[tmpIndex][3]),_G.tmpAnnotations[tmpIndex][4],_G.tmpAnnotations[tmpIndex][5],stringOffset+_G.tmpAnnotations[tmpIndex][6],_G.tmpAnnotations[tmpIndex][7],_G.tmpAnnotations[tmpIndex][8],_G.tmpAnnotations[tmpIndex][9],_G.tmpAnnotations[tmpIndex][10],_G.tmpAnnotations[tmpIndex][11]});
		end
	end
	local tmpLang;
	if _G.tmpMapString~=nil and type(_G.tmpMapString)=="table" and _G.tmpMapString[Settings.language]~=nil then
--	if _G.tmpMapString~=nil and type(_G.tmpMapString)=="table" then
		-- only really need the language specific values - if the user changes languages, the plugin reloads anyway...
		for tmpIndex,tmpEntry in pairs(_G.tmpMapString[Settings.language]) do
			table.insert(mapStrings[Settings.language],tmpEntry);
		end
	end
end
if annotations==nil then
	NumDefaultAnnot=0;
else
	NumDefaultAnnot=#annotations-NumCustomAnnot;
end		
if debug then
	Turbine.Shell.WriteLine("NumCustomAnnot="..tostring(NumCustomAnnot));
	Turbine.Shell.WriteLine("NumDefaultAnnot="..tostring(NumDefaultAnnot));
end
_G.tmpAnnotations=nil
_G.tmpMapString=nil

if priorDataVersion==nil or priorDataVersion~=tostring(plugin:GetVersion()) then
	if debug then
		Turbine.Shell.WriteLine("data version changed, adding default Overlays")
	end
	AddDefaultOverlays()
end

mapWindow:SetTop(Settings.MapTopPercent*displayHeight);
mapWindow:SetLeft(Settings.MapLeftPercent*displayWidth)

mapWindow:SetHeight(math.floor(Settings.MapHeightPercent*displayHeight+.5));
mapWindow:SetWidth(math.floor(Settings.MapWidthPercent*displayWidth+.5));
if debug then Turbine.Shell.WriteLine("calling mapWindow:SetVisible(false)") end
mapWindow:SetVisible(false);

mapWindow.Map=Turbine.UI.Control();
mapWindow.Map:SetParent(mapWindow);
mapWindow.Map:SetMouseVisible(false);
mapWindow.Map:SetOpacity(Settings.MapOpacity);

mapWindow.Map.Overlays={};
BDDHotSpotHover=function(sender)
	local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
	if width<100 then width=100 end
	mapWindow.Map.HoverWindow:SetWidth(width+10);							
	mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
	mapWindow.Map.HoverWindow.MapID=nil;
	mapWindow.Map.HoverWindow.Name.MouseClick=nil;
	mapWindow.Map.HoverWindow.Coord:SetText(sender.Coords);
	mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
	mapWindow.Map.HoverWindow.Edit:SetVisible(false);
	mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
	mapWindow.Map.HoverWindow:SetVisible(true);
	mapWindow.Map.HoverWindow:SetWantsUpdates(true);
end
mapWindow.LoadOverlays=function()
	local tmpOLIndex;
	tmpOLIndex=#mapWindow.Map.Overlays
	while tmpOLIndex>0 do
		if mapWindow.Map.Overlays[tmpOLIndex].HotSpots~=nil then
			for tmpIndex,tmpSpot in pairs(mapWindow.Map.Overlays[tmpOLIndex].HotSpots) do
				tmpSpot:SetVisible(false)
				mapWindow.Map.Overlays[tmpOLIndex].HotSpots[tmpIndex]=nil
			end
			mapWindow.Map.Overlays[tmpOLIndex].HotSpots=nil
		end

		mapWindow.Map.Overlays[tmpOLIndex]:SetVisible(false);
		mapWindow.Map.Overlays[tmpOLIndex]=nil;
		tmpOLIndex=tmpOLIndex-1;
	end
	if BDDLegend~=nil then
		BDDLegend:SetVisible(false)
	end
	local count=mapWindow.OverlaySelect:GetItemCount();
	while count>1 do
		mapWindow.OverlaySelect:RemoveItemAt(count)
		count=count-1
	end
	if mapWindow.Map.Overlays~=nil then
		-- need to clear out BDD stuff
		for k,v in ipairs(mapWindow.Map.Overlays) do
			if v.HotSpots~=nil then
				for tmpIndex,tmpSpot in pairs(v.HotSpots) do
					tmpSpot:SetVisible(false)
					v.Hotspots[tmpIndex]=nil
				end
				v.HotSpots=nil
			end
		end
	end
	mapWindow.Map.Overlays={};
	local tmpOverlays={};
	for tmpOLIndex,tmpData in ipairs(overlays) do
		if tmpData[1]==mapWindow.CurrentMapID then
			table.insert(tmpOverlays,{tmpData[1],tmpData[2],tmpData[3],tmpData[4],tmpData[5],tmpData[6],tmpData[7],tmpData[8],tmpData[9],tmpData[10],tmpOLIndex})
		end
	end
	-- sort by layer order
	table.sort(tmpOverlays,function(arg1,arg2) if arg1[9]==nil then return false elseif arg2[9]==nil or arg1[9]<arg2[9] then return true end end)
	for tmpOLIndex,tmpData in ipairs(tmpOverlays) do
		mapWindow.Map.Overlays[tmpOLIndex]=Turbine.UI.Control();
		mapWindow.Map.Overlays[tmpOLIndex]:SetParent(mapWindow.Map);

		mapWindow.Map.Overlays[tmpOLIndex]:SetMouseVisible(false);
		local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.Map.Overlays[tmpOLIndex],"GaranStuff/MoorMap/Overlays/"..tmpData[3]);
		local tmpRow=Turbine.UI.Lotro.CheckBox();
		tmpRow:SetParent(mapWindow.OverlaySelect);
		tmpRow:SetSize(mapWindow.OverlaySelect:GetWidth(),20);
		tmpRow:SetText(tmpData[2]);
		tmpRow.OLIndex=tmpData[11];
-- 		add annotations if this is a BDD overlay
		
		if tmpData[2]=="Berry's Deed Data" then
			local success,result
			local topmost=100+#mapWindow.Map.Icons
			local isvisible=tmpData[8]
			local bddWidth=320
			local bddHeight=420
			if (BDD==nil or BDD[1]==nil) then
				BDD={}
				success,result=pcall(import,importPath.."Overlays.BDD.Data"..tostring(mapWindow.CurrentMapID));
				if BDDLegend==nil then
					BDDLegend=Turbine.UI.Window()
					BDDLegend:SetPosition(Settings.BDDLegendLeftPercent*displayWidth,Settings.BDDLegendTopPercent*displayHeight)

					BDDLegend:SetSize(bddWidth,bddHeight)
					BDDLegend:SetZOrder(mapWindow:GetZOrder()+1)
					BDDLegend:SetOpacity(.95)
					BDDLegend:SetZOrder(2)
					BDDLegend:SetStretchMode(3);
					BDDVis=isvisible
					BDDLegend:SetVisible(isvisible and mapWindow:IsVisible())
					BDDLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
					BDDLegend.Border=Turbine.UI.Control()
					BDDLegend.Border:SetParent(BDDLegend)
					BDDLegend.Border:SetSize(bddWidth-2,bddHeight-2)
					BDDLegend.Border:SetPosition(1,1)
					BDDLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
					BDDLegend.TitleBack=Turbine.UI.Control()
					BDDLegend.TitleBack:SetParent(BDDLegend.Border)
					BDDLegend.TitleBack:SetSize(bddWidth,65)
					BDDLegend.Title=Turbine.UI.Control()
					BDDLegend.Title:SetParent(BDDLegend.TitleBack)
					BDDLegend.Title:SetSize(250,65)
					BDDLegend.Title:SetPosition((bddWidth-252)/2,1)
					BDDLegend.Title:SetBlendMode(Turbine.UI.BlendMode.Overlay)
					BDDLegend.Title:SetBackground(resourcePath.."BDDCaption.tga")
					BDDLegend.Title:SetMouseVisible(false)
					BDDLegend.TitleBack.MouseDown=function(sender,args)
						BDDLegend.Border:SetBackColor(Turbine.UI.Color(.8,.85,.85,.75))
						BDDLegend.X=args.X
						BDDLegend.Y=args.Y
						BDDLegend.Moving=true
					end
					BDDLegend.TitleBack.MouseMove=function(sender,args)
						if BDDLegend.Moving then
							BDDLegend:SetPosition(BDDLegend:GetLeft()-(BDDLegend.X-args.X),BDDLegend:GetTop()-(BDDLegend.Y-args.Y))
						end
					end
					BDDLegend.TitleBack.MouseUp=function(sender,args)
						BDDLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
						BDDLegend.Moving=false
					end
					BDDLegend.TitleBack.MouseLeave=function(sender,args)
						BDDLegend:SetBackground(nil); -- cheesy way to generate a checkerboard background
						BDDLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
					end
					BDDLegend.TitleBack.MouseEnter=function(sender,args)
						BDDLegend:SetBackground(0); -- cheesy way to generate a checkerboard background
						BDDLegend:SetBackColor(nil)
					end
					BDDLegend.FontCaption=Turbine.UI.Label()
					BDDLegend.FontCaption:SetParent(BDDLegend.Border)
					BDDLegend.FontCaption:SetSize(100,20)
					BDDLegend.FontCaption:SetPosition(2,72)
					BDDLegend.FontCaption:SetForeColor(Turbine.UI.Color(.2,.5,.2))
					BDDLegend.FontCaption:SetText(Resource[Settings.language][345]..":")
					if Settings.BDDFontSize<23 then
						BDDLegend.FontIncrease=Turbine.UI.Label()
						BDDLegend.FontIncrease:SetParent(BDDLegend.Border)
						BDDLegend.FontIncrease:SetSize(20,20)
						BDDLegend.FontIncrease:SetPosition(107,72)
						BDDLegend.FontIncrease:SetForeColor(Turbine.UI.Color(.2,.5,.2))
						BDDLegend.FontIncrease:SetText("+")
						BDDLegend.FontIncrease.MouseClick=function(sender,args)
							local tmpFont=GetLargerFont(Settings.BDDFont)
							if tmpFont~=nil then
								Settings.BDDFont=tmpFont
								Settings.BDDFontSize=Turbine.UI.Lotro.FontInfo[Settings.BDDFont].size
								mapWindow.PreserveMapID=true;
								Turbine.PluginManager.LoadPlugin("MoorMapLoader");
							end
						end
					end
					BDDLegend.FontSizeCaption=Turbine.UI.Label()
					BDDLegend.FontSizeCaption:SetParent(BDDLegend.Border)
					BDDLegend.FontSizeCaption:SetSize(40,20)
					BDDLegend.FontSizeCaption:SetPosition(127,72)
					BDDLegend.FontSizeCaption:SetForeColor(Turbine.UI.Color(.2,.5,.2))
					BDDLegend.FontSizeCaption:SetText(Settings.BDDFontSize)
					if Settings.BDDFontSize>10 then
						BDDLegend.FontDecrease=Turbine.UI.Label()
						BDDLegend.FontDecrease:SetParent(BDDLegend.Border)
						BDDLegend.FontDecrease:SetSize(20,20)
						BDDLegend.FontDecrease:SetPosition(167,72)
						BDDLegend.FontDecrease:SetForeColor(Turbine.UI.Color(.2,.5,.2))
						BDDLegend.FontDecrease:SetText("-")
						BDDLegend.FontDecrease.MouseClick=function(sender,args)
							local tmpFont=GetSmallerFont(Settings.BDDFont)
							if tmpFont~=nil then
								Settings.BDDFont=tmpFont
								Settings.BDDFontSize=Turbine.UI.Lotro.FontInfo[Settings.BDDFont].size
								mapWindow.PreserveMapID=true;
								Turbine.PluginManager.LoadPlugin("MoorMapLoader");
							end
						end
					end

					BDDLegend.DeedList=Turbine.UI.TreeView()
					BDDLegend.DeedList:SetParent(BDDLegend.Border)
					BDDLegend.DeedList:SetSize(bddWidth-24,bddHeight-92)
					BDDLegend.DeedList:SetPosition(5,90)
					BDDVScroll=Turbine.UI.Lotro.ScrollBar()
					BDDVScroll:SetParent(BDDLegend.Border)
					BDDVScroll:SetSize(10,bddHeight-32);
					BDDVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
					BDDVScroll:SetPosition(bddWidth-12,25);
					BDDLegend.DeedList:SetVerticalScrollBar(BDDVScroll)
					BDDPing=Turbine.UI.Control();
					BDDPing:SetParent(mapWindow.Map);
					BDDPing:SetZOrder(topmost+1);
					BDDPing.State=0;
					BDDPing:SetVisible(false);
					BDDPing:SetSize(23,23);
					BDDPing:SetPosition(512,512);
					BDDPing:SetWantsUpdates(false);
					BDDPing.Counter=1;
					BDDPing.MaxCounter=2;
					BDDPing:SetBlendMode(Turbine.UI.BlendMode.Overlay)
					BDDPing:SetBackground(resourcePath.."Ping1.tga");
					BDDPing.MouseClick=function(sender,args)
						BDDPing.State=0; -- it will auto hide itmapWindow on next tick
					end
					BDDPing.Update=function(sender)
						if BDDPing.State==0 then
							BDDPing:SetWantsUpdates(false);
							BDDPing:SetVisible(false);
							BDDPing.Counter=0;
							BDDPing:SetBackground(resourcePath.."Ping1.tga");
						elseif BDDPing.State==7 then
							BDDPing.Counter=BDDPing.Counter+1;
							if BDDPing.Counter>BDDPing.MaxCounter then
								BDDPing.Counter=0;
								BDDPing.State=3;
								BDDPing:SetBackground(resourcePath.."Ping3.tga");
							end
						else
							BDDPing.Counter=BDDPing.Counter+1;
							if BDDPing.Counter>BDDPing.MaxCounter then
								BDDPing.Counter=0;
								BDDPing.State=BDDPing.State+1;
								BDDPing:SetBackground(resourcePath.."Ping"..tostring(BDDPing.State)..".tga");
							end
						end
					end
					local root=BDDLegend.DeedList:GetNodes()
					for groupIndex,groupData in ipairs(BDD) do
						local tmpNode=Turbine.UI.TreeNode()
						tmpNode:SetParent(BDDLegend.DeedList)
						tmpNode:SetSize(bddWidth-24,18)
						tmpNode.Icon=Turbine.UI.Control()
						tmpNode.Icon:SetParent(tmpNode)
						tmpNode.Icon:SetMouseVisible(false)
						tmpNode.Icon:SetSize(16,16)
						tmpNode.Icon:SetBackground(0x41007E27) -- expand
						tmpNode.Title=Turbine.UI.Label()
						tmpNode.Title:SetParent(tmpNode)
						tmpNode.Title:SetSize(bddWidth-42,18)
						tmpNode.Title:SetLeft(18)
						tmpNode.Title:SetForeColor(groupData[2])
						tmpNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16)
						tmpNode.Title:SetFontStyle(Turbine.UI.FontStyle.Outline)
						tmpNode.Title:SetOutlineColor(Turbine.UI.Color(.3,.3,.3))
						tmpNode.Title:SetText(groupData[1])
						tmpNode.Title:SetMouseVisible(false)
						tmpNode.MouseDown=function(sender)
							if sender:IsExpanded() then
								sender.Icon:SetBackground(0x41007E27)
							else
								sender.Icon:SetBackground(0x41007E26)
							end
						end
						root:Add(tmpNode)
						for itemIndex,itemData in ipairs(BDD[groupData[1]]) do
							-- only add node if name isn't already in tree
							local childNodes=tmpNode:GetChildNodes()
							local exists=false
							local tmpLabel
							if itemData[1]~=nil then
								tmpLabel=tostring(itemData[1]).." "..itemData[2]
								if itemData[1]<10 then tmpLabel="0"..tmpLabel end
							else
								tmpLabel=itemData[2]
							end
							local tmpLen=string.len(tmpLabel)
							-- not sure how I feel about this feature. if not exists then don't show duplicate entry in legend...
--							for tmpindex=1,childNodes:GetCount() do
--								if string.sub(childNodes:Get(tmpindex).Title:GetText(),1,tmpLen)==tmpLabel then
--									exists=true
--									break
	--							end
--							end
							if itemData[3]~=nil and itemData[4]~=nil then
								if itemData[3]<0 then
									tmpLabel=tmpLabel.." ("..tostring(0-itemData[3]).."S,"
								else
									tmpLabel=tmpLabel.." ("..tostring(itemData[3]).."N,"
								end
								if itemData[4]<0 then
									tmpLabel=tmpLabel..tostring(0-itemData[4]).."W)"
								else
									tmpLabel=tmpLabel..tostring(itemData[4]).."E)"
								end
							end
							if not exists then
								local tmpItemNode=Turbine.UI.TreeNode()
								tmpItemNode:SetParent(tmpNode)
								tmpItemNode:SetSize(bddWidth-24,16)
								tmpItemNode.Title=Turbine.UI.Label()
								tmpItemNode.Title:SetParent(tmpItemNode)
								tmpItemNode.Title:SetSize(bddWidth-44,16)
								tmpItemNode.Title:SetLeft(20)
								tmpItemNode.Title:SetForeColor(Turbine.UI.Color.DarkOliveGreen)
								tmpItemNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana14)
								tmpItemNode.Title:SetText(tmpLabel)
								tmpItemNode.Title:SetMouseVisible(false)
								if itemData[1]==nil and itemData[3]~=nil then
									-- map node
									tmpItemNode.MapID=itemData[3]
									tmpItemNode.MouseClick=function(sender)
										RefreshMap(sender.MapID)
									end
								end
								if itemData[1]~=nil and itemData[3]~=nil and itemData[4]~=nil then
									-- ping node
									if itemData[6]~=nil then
										tmpItemNode.X=math.floor(itemData[6]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
									else
										tmpItemNode.X=math.floor(itemData[4]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
									end
									if itemData[5]~=nil then
										tmpItemNode.Y=math.floor(itemData[5]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
									else
										tmpItemNode.Y=math.floor(itemData[3]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
									end
									tmpItemNode.MouseClick=function(sender)
										BDDPing:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
										BDDPing.State=1;
										BDDPing:SetVisible(true);
										BDDPing:SetWantsUpdates(true);
									end
								end
								childNodes:Add(tmpItemNode)
							end
						end
					end
				end
			end
			mapWindow.Map.Overlays[tmpOLIndex].HotSpots={}
			for groupIndex,groupData in ipairs(BDD) do
				for itemIndex,itemData in ipairs(BDD[groupData[1]]) do
					-- add the hotspot to the overlay
					if itemData[1]~=nil and itemData[3]~=nil and itemData[4]~=nil then
						local NS,EW=itemData[3],itemData[4]
						local X,Y
						if itemData[6]~=nil then
							X=math.floor(itemData[6]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
						else
							X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
						end
						if itemData[5]~=nil then
							Y=math.floor(itemData[5]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
						else
							Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
						end
						local tmpHotSpot=Turbine.UI.Control()
						-- if the hotspots are on the overlay we don't get mouse events :(
						tmpHotSpot:SetParent(mapWindow.Map)
						tmpHotSpot:SetVisible(isvisible)
						tmpHotSpot:SetZOrder(topmost)
						tmpHotSpot:SetSize(Settings.BDDFontSize*1.5,Settings.BDDFontSize)
						tmpHotSpot:SetPosition(X-15,Y-10)
						-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
						tmpHotSpot.Text=Turbine.UI.Label()
						tmpHotSpot.Text:SetParent(tmpHotSpot)
						tmpHotSpot.Text:SetSize(tmpHotSpot:GetSize())
						tmpHotSpot.Text:SetFont(Settings.BDDFont)
						tmpHotSpot.Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
						tmpHotSpot.Text:SetOutlineColor(Turbine.UI.Color.Black)
						tmpHotSpot.Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
						tmpHotSpot.Text:SetForeColor(groupData[2])
						tmpHotSpot.Text:SetMouseVisible(false)
						if itemData[1]<10 then
							tmpHotSpot.Text:SetText("0"..tostring(itemData[1]))
						else
							tmpHotSpot.Text:SetText(itemData[1])
						end
						tmpHotSpot.Text:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
						tmpHotSpot.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
						tmpHotSpot.ShortDescription=itemData[2]
						if NS<0 then
							tmpHotSpot.Coords=tostring(0-NS).."S, "
						else
							tmpHotSpot.Coords=tostring(NS).."N, "
						end
						if EW<0 then
							tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
						else
							tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
						end
						tmpHotSpot.MouseEnter=function(sender)
							sender.Text:SetBackColor(Turbine.UI.Color(.9,.9,.9))
						end
						tmpHotSpot.MouseLeave=function(sender)
							sender.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
						end
						tmpHotSpot.MouseHover=function(sender)
							BDDHotSpotHover(sender)
						end
							table.insert(mapWindow.Map.Overlays[tmpOLIndex].HotSpots,tmpHotSpot)
					end
				end
			end
		end
		tmpRow.Data={tmpOLIndex,tmpData[4],tmpData[5],tmpData[6],tmpData[7],tmpData[10]}
		tmpRow.CheckedChanged=function(sender)
			if sender:IsChecked() then
				overlays[sender.OLIndex][8]=true;
				mapWindow.Map.Overlays[sender.Data[1]]:SetVisible(true);
				mapWindow.Map.Overlays[sender.Data[1]]:SetSize(sender.Data[2],sender.Data[3]);
				mapWindow.Map.Overlays[sender.Data[1]]:SetStretchMode(2);
				mapWindow.Map.Overlays[sender.Data[1]]:SetSize(mapWindow.Map:GetSize());
				mapWindow.Map.Overlays[sender.Data[1]]:SetOpacity(sender.Data[6]);
				if sender.Data[4]~=nil then mapWindow.Map.Overlays[sender.Data[1]]:SetLeft(sender.Data[4]) end
				if sender.Data[5]~=nil then mapWindow.Map.Overlays[sender.Data[1]]:SetTop(sender.Data[5]) end
			else
				overlays[sender.OLIndex][8]=false;
				mapWindow.Map.Overlays[sender.Data[1]]:SetVisible(false);
			end
			if overlays[sender.OLIndex][2]=="Berry's Deed Data" and BDDLegend~=nil then
				local isvisible=overlays[sender.OLIndex][8]
				for k,v in ipairs(mapWindow.Map.Overlays[sender.Data[1]].HotSpots) do
					v:SetVisible(isvisible)
				end
				BDDVis=isvisible
				BDDLegend:SetVisible(isvisible and mapWindow:IsVisible())
			end
			if overlayWindow~=nil and overlayWindow.refreshOLList~=nil then
				overlayWindow.refreshOLList()
			end
		end
		if tmpData[8]==true then
			tmpRow:SetChecked(true)
			mapWindow.Map.Overlays[tmpOLIndex]:SetVisible(true);
			mapWindow.Map.Overlays[tmpOLIndex]:SetSize(tmpData[4],tmpData[5]);
			mapWindow.Map.Overlays[tmpOLIndex]:SetStretchMode(2);
			mapWindow.Map.Overlays[tmpOLIndex]:SetSize(mapWindow.Map:GetSize());
			mapWindow.Map.Overlays[tmpOLIndex]:SetOpacity(tmpData[10]);
			if tmpData[6]~=nil then mapWindow.Map.Overlays[tmpOLIndex]:SetLeft(tmpData[6]) end
			if tmpData[7]~=nil then mapWindow.Map.Overlays[tmpOLIndex]:SetTop(tmpData[7]) end
		else
			tmpRow:SetChecked(false)
			mapWindow.Map.Overlays[tmpOLIndex]:SetVisible(false);
		end
		mapWindow.OverlaySelect:AddItem(tmpRow);
	end
	if mapWindow.OverlaySelect:GetItemCount()>1 then
		mapWindow.OverlaySelect:SetVisible(true);
	else
		mapWindow.OverlaySelect:SetVisible(false);
	end
end
mapWindow.LoadBreadcrumbs=function()
	mapWindow.Breadcrumbs=PatchDataLoad( Turbine.DataScope.Account, "MM_Breadcrumbs_"..tostring(mapWindow.CurrentMapID));
	if mapWindow.Breadcrumbs==nil then mapWindow.Breadcrumbs={} end;
end

mapWindow.ControlPanel=Turbine.UI.Control();
mapWindow.ControlPanel:SetParent(mapWindow);
mapWindow.ControlPanel:SetSize(mapWindow:GetWidth(),32);
mapWindow.ControlPanel:SetTop(4);
mapWindow.ControlPanel:SetStretchMode(3);
mapWindow.ControlPanel:SetMouseVisible(false);

mapWindow.ControlPanel.OptionsButton=Turbine.UI.Control();
mapWindow.ControlPanel.OptionsButton:SetParent(mapWindow.ControlPanel);
mapWindow.ControlPanel.OptionsButton:SetBackground(resourcePath.."options.tga");
mapWindow.ControlPanel.OptionsButton:SetSize(32,32);
mapWindow.ControlPanel.OptionsButton:SetLeft(18);

mapWindow.ControlPanel.OptionsButton.MouseEnter=function()
	mapWindow.ControlPanel.OptionsButton:SetBackground(resourcePath.."options_hover.tga");
end
mapWindow.ControlPanel.OptionsButton.MouseLeave = function()
	mapWindow.ControlPanel.OptionsButton:SetBackground(resourcePath.."options.tga");
	mapWindow.OptionsHover:Close();
end
mapWindow.ControlPanel.OptionsButton.MouseClick=function()
	optionsWindow:SetText(Resource[Settings.language][3]);
	optionsWindow.RefreshOptions();
	optionsWindow:SetVisible(true);
end
mapWindow.OptionsHover=Turbine.UI.ContextMenu();
mapWindow.OptionsHover:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][3]));
mapWindow.ControlPanel.OptionsButton.MouseHover=function(sender,args)
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.OptionsHover:ShowMenuAt(x+2,y+15);
end

mapWindow.ControlPanel.AnnotationsButton=Turbine.UI.Control();
mapWindow.ControlPanel.AnnotationsButton:SetParent(mapWindow.ControlPanel);
mapWindow.ControlPanel.AnnotationsButton:SetBackground(resourcePath.."annotations.tga");
mapWindow.ControlPanel.AnnotationsButton:SetSize(32,32);
if mapWindow.ControlPanel.OptionsButton~=nil then
	mapWindow.ControlPanel.AnnotationsButton:SetLeft(mapWindow.ControlPanel.OptionsButton:GetLeft()+mapWindow.ControlPanel.OptionsButton:GetWidth()+5);
else
	mapWindow.ControlPanel.AnnotationsButton:SetLeft(18);
end
mapWindow.ControlPanel.AnnotationsButton.MouseEnter=function()
	mapWindow.ControlPanel.AnnotationsButton:SetBackground(resourcePath.."annotations_hover.tga");
end
mapWindow.ControlPanel.AnnotationsButton.MouseLeave = function()
	mapWindow.ControlPanel.AnnotationsButton:SetBackground(resourcePath.."annotations.tga");
	mapWindow.AnnotationsHover:Close();
end
mapWindow.ControlPanel.AnnotationsButton.MouseClick=function()
	annotWindow:SetVisible(true);
end
mapWindow.AnnotationsHover=Turbine.UI.ContextMenu();
mapWindow.AnnotationsHover:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][72]));
mapWindow.ControlPanel.AnnotationsButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.AnnotationsHover:ShowMenuAt(x+2,y+15);
end

mapWindow.FilterButton=Turbine.UI.Control();
mapWindow.FilterButton:SetParent(mapWindow.ControlPanel);
mapWindow.FilterButton:SetBackground(resourcePath.."Filter.tga");
mapWindow.FilterButton:SetSize(32,32);
mapWindow.FilterButton:SetLeft(mapWindow.ControlPanel.AnnotationsButton:GetLeft()+mapWindow.ControlPanel.AnnotationsButton:GetWidth()+5);
mapWindow.FilterButton.MouseEnter=function()
	mapWindow.FilterButton:SetBackground(resourcePath.."Filter_hover.tga");
end
mapWindow.FilterButton.MouseLeave=function()
	mapWindow.FilterButton:SetBackground(resourcePath.."Filter.tga");
	mapWindow.FilterHover:Close();
end
mapWindow.FilterButton.MouseClick=function()
	mapWindow.FilterPanel:SetVisible(not mapWindow.FilterPanel:IsVisible());
end
mapWindow.FilterHover=Turbine.UI.ContextMenu();
mapWindow.FilterHover:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][65]));
mapWindow.FilterButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.FilterHover:ShowMenuAt(x+2,y+15);
end

mapWindow.SearchButton=Turbine.UI.Control();
mapWindow.SearchButton:SetParent(mapWindow.ControlPanel);
mapWindow.SearchButton:SetBackground(resourcePath.."Search.tga");
mapWindow.SearchButton:SetSize(32,32);
mapWindow.SearchButton:SetLeft(mapWindow.FilterButton:GetLeft()+mapWindow.FilterButton:GetWidth()+5);
mapWindow.SearchButton.MouseEnter=function()
	mapWindow.SearchButton:SetBackground(resourcePath.."Search_hover.tga");
end
mapWindow.SearchButton.MouseLeave=function()
	mapWindow.SearchButton:SetBackground(resourcePath.."Search.tga");
	mapWindow.SearchHover:Close();
end
mapWindow.SearchButton.MouseClick=function()
	mapWindow.SearchPanel:SetVisible(not mapWindow.SearchPanel:IsVisible());
	mapWindow.Map.IconSearch:SetWantsUpdates(mapWindow.SearchPanel:IsVisible());
	if not mapWindow.SearchPanel:IsVisible() then
		-- search closed, refresh map to reapply filters without the filter text
		RefreshMap();
		if debug then
			Turbine.Shell.WriteLine("search closed")
		end
	end
end
mapWindow.SearchHover=Turbine.UI.ContextMenu();
mapWindow.SearchHover:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][220]));
mapWindow.SearchButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.SearchHover:ShowMenuAt(x+2,y+15);
end


mapWindow.SearchButton2=Turbine.UI.Control();
mapWindow.SearchButton2:SetParent(mapWindow.ControlPanel);
mapWindow.SearchButton2:SetBackground(resourcePath.."Search2.tga");
mapWindow.SearchButton2:SetSize(32,32);
mapWindow.SearchButton2:SetLeft(mapWindow.SearchButton:GetLeft()+mapWindow.SearchButton:GetWidth()+5);
mapWindow.SearchButton2.MouseEnter=function()
	mapWindow.SearchButton2:SetBackground(resourcePath.."Search2_hover.tga");
end
mapWindow.SearchButton2.MouseLeave=function()
	mapWindow.SearchButton2:SetBackground(resourcePath.."Search2.tga");
	mapWindow.SearchHover2:Close();
end
mapWindow.SearchButton2.MouseClick=function()
	searchWindow:SetVisible(true);
end
mapWindow.SearchHover2=Turbine.UI.ContextMenu();
mapWindow.SearchHover2:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][220]));
mapWindow.SearchButton2.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.SearchHover2:ShowMenuAt(x+2,y+15);
end

mapWindow.PlayerIconVisible=false;

mapWindow.LocationContainer=Turbine.UI.Control();
mapWindow.LocationContainer:SetParent(mapWindow.ControlPanel);
mapWindow.LocationContainer:SetSize(22,22);
mapWindow.LocationContainer:SetPosition(mapWindow.SearchButton2:GetLeft()+mapWindow.SearchButton2:GetWidth()+10,9);

mapWindow.LocationQuickSlot=Turbine.UI.Lotro.Quickslot();
mapWindow.LocationQuickSlot:SetParent(mapWindow.LocationContainer);
mapWindow.LocationQuickSlot:SetSize(66,66);
mapWindow.LocationQuickSlot:SetPosition(-34,-34);
mapWindow.LocationQuickSlot:SetAllowDrop(false);
local locSC=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
if locale=="en" then
	locSC:SetData("/loc"); -- resource[1][210]
elseif locale=="fr" then
	locSC:SetData("/emp");
elseif locale=="de" then
	locSC:SetData("/pos");
end
mapWindow.LocationQuickSlot:SetShortcut(locSC);
mapWindow.LocationQuickSlot:SetVisible(true);
mapWindow.LocationQuickSlot.DragDrop=function()
	-- reestablish the shortcut if the user accidentally drags it onto itmapWindow which wipes it out
	local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
	sc:SetData(Resource[Settings.language][210]);
	mapWindow.LocationQuickSlot:SetShortcut(sc);
end

mapWindow.LocationButton=Turbine.UI.Control();
mapWindow.LocationButton:SetParent(mapWindow.ControlPanel);
mapWindow.LocationButton:SetSize(32,32);
mapWindow.LocationButton:SetBackground(resourcePath.."Location.tga");
mapWindow.LocationButton:SetPosition(mapWindow.SearchButton2:GetLeft()+mapWindow.SearchButton2:GetWidth()+5,0);
mapWindow.LocationButton:SetMouseVisible(false);

mapWindow.OverlayButton=Turbine.UI.Control();
mapWindow.OverlayButton:SetParent(mapWindow.ControlPanel);
mapWindow.OverlayButton:SetSize(32,32);
mapWindow.OverlayButton:SetPosition(mapWindow.LocationButton:GetLeft()+mapWindow.LocationButton:GetWidth()+5,0);
mapWindow.OverlayButton:SetBackground(resourcePath.."Overlay.tga")
mapWindow.OverlayHover=Turbine.UI.ContextMenu();
mapWindow.OverlayHover:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][219]));

mapWindow.OverlayButton.MouseEnter=function()
	mapWindow.OverlayButton:SetBackground(resourcePath.."Overlay_hover.tga")
end
mapWindow.OverlayButton.MouseLeave=function()
	mapWindow.OverlayButton:SetBackground(resourcePath.."Overlay.tga")
	mapWindow.OverlayHover:Close();
end
mapWindow.OverlayButton.MouseClick=function()
	overlayWindow:SetVisible(not overlayWindow:IsVisible());
end
mapWindow.OverlayButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.OverlayHover:ShowMenuAt(x+2,y+15)
end

mapWindow.BreadcrumbButton=Turbine.UI.Control();
mapWindow.BreadcrumbButton:SetParent(mapWindow.ControlPanel);
mapWindow.BreadcrumbButton:SetSize(32,32);
mapWindow.BreadcrumbButton:SetPosition(mapWindow.OverlayButton:GetLeft()+mapWindow.OverlayButton:GetWidth()+5,0);
mapWindow.BreadcrumbButton:SetBackground(resourcePath.."BreadcrumbButton.tga")
mapWindow.BreadcrumbHover=Turbine.UI.ContextMenu();
mapWindow.BreadcrumbHover:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][238]));

mapWindow.BreadcrumbButton.MouseEnter=function()
	mapWindow.BreadcrumbButton:SetBackground(resourcePath.."BreadcrumbButton_hover.tga")
end
mapWindow.BreadcrumbButton.MouseLeave=function()
	mapWindow.BreadcrumbButton:SetBackground(resourcePath.."BreadcrumbButton.tga")
	mapWindow.BreadcrumbHover:Close();
end
mapWindow.BreadcrumbButton.MouseClick=function()
	breadcrumbWindow:SetVisible(not breadcrumbWindow:IsVisible());
end
mapWindow.BreadcrumbButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.BreadcrumbHover:ShowMenuAt(x+2,y+15)
end

mapWindow.LocationContainer.MouseEnter=function()
	mapWindow.LocationButton:SetBackground(resourcePath.."Location_hover.tga");
end
mapWindow.LocationContainer.MouseLeave=function()
	mapWindow.LocationButton:SetBackground(resourcePath.."Location.tga");
end

mapWindow.LocationContainer.MouseUp=function(sender,args)
	-- reestablish the quickslot incase the user dragged it out...
	if locale=="fr" then
		mapWindow.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
	elseif locale=="de" then
		mapWindow.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;pos"))
	else
		mapWindow.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
	end
	mapWindow.LocationQuickSlot:SetVisible(true);
end
-- create Chat listener for the /loc command

mapWindow.chatListener=function(sender, args)
	-- check message for standard channel matching "You are at: r.* lx.* ly.* ox.* oy.* oz.* h.*"
--Votre emplacement est: r1 lx941 ly948 ox104.77 oy82.95 oz389.86 h300.9
--Ihr befindet Euch hier: r1 lx938 ly948 ox53.66 oy85.26 oz388.50 h300.9
	local locationString,headingString,patternString1,patternString2,patternString3,patternString4;
	if locale=="en" then
		locationString="You are at: r.*"
		headingString="You are at: r.* h.*"
		patternString1="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	elseif locale=="fr" then
		locationString="Votre emplacement .*: r.*"
		headingString="Votre emplacement .*: r.* h.*"
		patternString1="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	else
		locationString="Ihr befindet Euch hier: r.*"
		headingString="Ihr befindet Euch hier: r.* h.*"
		patternString1="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	end
	if (args.ChatType==Turbine.ChatType.Standard or (debug and args.ChatType==Turbine.ChatType.Tell)) and string.find(args.Message,locationString)~=nil then
		local region, lx, ly, ox, oy, oz, heading;
		if string.find(args.Message,headingString)==nil then
			-- there is a carriage return at the end of the message :(
			heading=0;
			region, lx, ly, ox, oy, oz = string.match(args.Message,patternString1);
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2);
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3);
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4);
					end
				end
			end
		else
			region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString1.." h(%d+%.?%d*)");
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2.." h(%d+%.?%d*)");
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3.." h(%d+%.?%d*)");
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4.." h(%d+%.?%d*).*");
					end
				end
			end
		end
		if debug then
			Turbine.Shell.WriteLine("/loc values")
			Turbine.Shell.WriteLine("region:"..tostring(region))
			Turbine.Shell.WriteLine("lx:"..tostring(lx))
			Turbine.Shell.WriteLine("ly:"..tostring(ly))
			Turbine.Shell.WriteLine("c:"..tostring(c))
			Turbine.Shell.WriteLine("i:"..tostring(i))
			Turbine.Shell.WriteLine("ox:"..tostring(ox))
			Turbine.Shell.WriteLine("oy:"..tostring(oy))
			Turbine.Shell.WriteLine("oz:"..tostring(oz))
			Turbine.Shell.WriteLine("heading:"..tostring(heading))
		end
		if region ~= nil then
			if heading ==nil then
				-- when facing north the heading value is not present
				heading=0
			end
			region=tonumber(region);
			ox=euroNormalize(ox);
			oy=euroNormalize(oy);
			oz=euroNormalize(oz);
			heading=euroNormalize(heading);
			mapWindow.PlayerIconVisible=false;
			local ew,ns=(( math.floor( lx / 8 ) * 160 + ox ) - 29360) / 200,(( math.floor( ly / 8 ) * 160 + oy ) - 24880) / 200;

			-- check if the coordinates are on the current map
			if mapInfo[mapWindow.CurrentMapID][12]==region then -- same region
				if mapInfo[mapWindow.CurrentMapID][13]>=ns and mapInfo[mapWindow.CurrentMapID][15]<=ns and mapInfo[mapWindow.CurrentMapID][14]<=ew and mapInfo[mapWindow.CurrentMapID][16]>=ew then
					if debug then
						Turbine.Shell.WriteLine("on current map")
					end
					-- coordinates fall on current map
					mapWindow.Heading=heading;
					mapWindow.PlayerIconVisible=true;
					-- move the icon to the correct coordinates
					local X=math.floor(ew*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
					local Y=math.floor(ns*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
					if debug then
						Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
					end
					mapWindow.LocationIcon.X=X;
					mapWindow.LocationIcon.Y=Y;
					-- if Control or Alt is down then add breadcrumb
					if mapWindow:IsControlKeyDown() or quickWindow:IsAltKeyDown() then
						local tmpIconIndex;
						if mapWindow.Breadcrumbs==nil or #mapWindow.Breadcrumbs==0 then
							mapWindow.Breadcrumbs={};
							mapWindow.mapbreadcrumbImage={};
						end
						tmpIconIndex=#mapWindow.Breadcrumbs+1;

						mapWindow.Breadcrumbs[tmpIconIndex]={ew,ns};
						if mapWindow.Map.breadcrumbImage==nil then mapWindow.Map.breadcrumbImage={} end;
						mapWindow.Map.breadcrumbImage[tmpIconIndex]=Turbine.UI.Control();
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetParent(mapWindow.Map);
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetSize(5,5);
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetPosition(math.floor(X-2.5),math.floor(Y-2.5));
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColor(Settings.breadcrumbColor);
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
						if mapWindow.Map.breadcrumbImage[1].Update==nil then
							mapWindow.Map.breadcrumbImage[1].Update=function()
								RefreshBreadcrumbs();
							end
							mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(true)
						end
					end
					-- need to adjust for the stretching
					X=X*mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4]-14
					Y=Y*mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5]-14
					mapWindow.LocationIcon:SetPosition(X,Y);
					if mapWindow:IsVisible() then
						mapWindow.LocationIcon:SetVisible(true);
						mapWindow.LocationIcon:SetRotation({x=0,y=0,z=0-(mapWindow.Heading-90)});
					end
					mapWindow.LocationIcon:SetZOrder(101+#mapWindow.Map.Icons);
					-- and activate a "ping" for it
					mapWindow.Map.Ping:SetZOrder(mapWindow.LocationIcon:GetZOrder()+1);
					mapWindow.Map.Ping:SetPosition(math.floor(mapWindow.LocationIcon.X-11.5),math.floor(mapWindow.LocationIcon.Y-11.5));
					mapWindow.Map.Ping.State=1;
					mapWindow.Map.Ping:SetVisible(true);
					mapWindow.Map.Ping:SetWantsUpdates(true);
				else
					if defAnnWindow==nil or not defAnnWindow:IsVisible() then
						local bestMap=ResolveMap(region,ns,ew,true)[1]
						-- now to reload the map and force a ping at location
						mapWindow.playerNS=ns
						mapWindow.playerEW=ew
						mapWindow.Heading=heading
						mapWindow.showLocOnReload=true
						RefreshMap(bestMap)
						if debug then
							Turbine.Shell.WriteLine("NOT on current map")
							Turbine.Shell.WriteLine("Best Map="..tostring(bestMap))
							local X=math.floor(ew*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
							local Y=math.floor(ns*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
							Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
						end
					end
				end
			else
				local bestMap=ResolveMap(region,ns,ew,true)[1]
				mapWindow.playerNS=ns
				mapWindow.playerEW=ew
				mapWindow.Heading=heading
				mapWindow.showLocOnReload=true
				RefreshMap(bestMap)
				if debug then
					Turbine.Shell.WriteLine("NOT on current map")
					Turbine.Shell.WriteLine("Best Map="..tostring(bestMap))
					local X=math.floor(ew*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
					local Y=math.floor(ns*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
					Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
				end
			end
			if defAnnWindow~=nil and defAnnWindow.EWButtons~=nil then
				-- update the defAnnWindow with the more precise coords
				if ew<0 then
					ew=0-ew
					defAnnWindow.EWButtons:SetSelectedChoice(2);
				else
					defAnnWindow.EWButtons:SetSelectedChoice(1);
				end
				if ns<0 then
					ns=0-ns
					defAnnWindow.NSButtons:SetSelectedChoice(2);
				else
					defAnnWindow.NSButtons:SetSelectedChoice(1);
				end
				defAnnWindow.EWCoordText:SetText(math.floor(ew*100+.5)/100);
				defAnnWindow.NSCoordText:SetText(math.floor(ns*100+.5)/100);
			end
		end
	elseif (args.ChatType==Turbine.ChatType.Standard or (debug and args.ChatType==Turbine.ChatType.Tell)) and string.find(args.Message,"moormap ping_r")~=nil then
		-- we got a ping_r command via the standard channel, probably from TerrainMap, send it to the shellCmd
		mapWindow.shellCmd:Execute("moormap", string.sub(args.Message,9))
	end
end

AddCallback(Turbine.Chat, "Received", mapWindow.chatListener)
mapWindow.LocationIcon=Turbine.UI.Window();
mapWindow.LocationIcon:SetParent(mapWindow);
mapWindow.LocationIcon:SetSize(28,28)
mapWindow.LocationIcon:SetBackground(0x41007f4c);
mapWindow.LocationIcon:SetVisible(false);
mapWindow.LocationIcon:SetMouseVisible(false);
mapWindow.LocationIcon.X=0;
mapWindow.LocationIcon.Y=0;
mapWindow.Heading=Settings.playerHeading

mapWindow.NSCoord=Turbine.UI.Label();
mapWindow.NSCoord:SetParent(mapWindow.ControlPanel);
mapWindow.NSCoord:SetSize(45,18);
mapWindow.NSCoord:SetPosition(mapWindow.BreadcrumbButton:GetLeft()+mapWindow.BreadcrumbButton:GetWidth()+5,6);
mapWindow.NSCoord:SetForeColor(Settings.fontColor);
mapWindow.NSCoord:SetBackColor(Settings.backColor);
mapWindow.NSCoord:SetFont(fontFace);
mapWindow.NSCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.NSCoord:SetText("");

mapWindow.EWCoord=Turbine.UI.Label();
mapWindow.EWCoord:SetParent(mapWindow.ControlPanel);
mapWindow.EWCoord:SetSize(45,18);
mapWindow.EWCoord:SetPosition(mapWindow.NSCoord:GetLeft()+mapWindow.NSCoord:GetWidth()+5,6);
mapWindow.EWCoord:SetForeColor(Settings.fontColor);
mapWindow.EWCoord:SetBackColor(Settings.backColor);
mapWindow.EWCoord:SetFont(fontFace);
mapWindow.EWCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.EWCoord:SetText("");

if mapWindow.CurrentMapID==2 then
	-- we don't show coords on world map since they are meaningless (and erroneous)
	mapWindow.NSCoord:SetVisible(false);
	mapWindow.EWCoord:SetVisible(false);
end

mapWindow.MapSelect=DropDownList()
-- override default handler so we can strip the asterisk
mapWindow.MapSelect.ListData.SelectedIndexChanged=function()
	if mapWindow.MapSelect.ListData:GetSelectedIndex()>0 then
		-- strip asterisk and leading spaces from displayed value
		local txt=mapWindow.MapSelect.ListData:GetItem(mapWindow.MapSelect.ListData:GetSelectedIndex()):GetText()
		if string.sub(txt,1,1)=='*' then txt=string.sub(txt,2) end
		mapWindow.MapSelect.CurrentValue:SetText(string.ltrim(txt))
		mapWindow.MapSelect.DataValue=mapWindow.MapSelect.ListData:GetItem(mapWindow.MapSelect.ListData:GetSelectedIndex()):GetValue();
	end
end
mapWindow.MapSelect:SetParent(mapWindow);
mapWindow.MapSelect:SetSize(280,20); -- the excess space is used in German and French map names
mapWindow.MapSelect:SetPosition(mapWindow.EWCoord:GetLeft()+mapWindow.EWCoord:GetWidth()+5,9);
mapWindow.MapSelect:SetFont(Turbine.UI.Lotro.Font.Verdana18)
mapWindow.MapSelect:SetStretchMode(3);
mapWindow.MapSelect:SetBorderColor(Settings.trimColor);
mapWindow.MapSelect:SetBackColor(Settings.backColor);
mapWindow.MapSelect.CurrentValue:SetBackColor(Settings.backColor);
mapWindow.MapSelect:SetTextColor(Settings.listTextColor);
mapWindow.MapSelect:SetDropRows(15);
--mapWindow.MapSelect.AddItem=function(sender,name,value)
--	local newItem=DropDownList.AddItem(sender,name,value)
--	if newItem~=null then
--		newItem:SetForeColor(Turbine.UI.Color.Green); -- nice, we have a way to add a plus sign if there are children
--	end
--end

mapWindow.MapSelect:SetSelectedIndex(1);
mapWindow.MapSelect.SelectedIndexChanged=function()
	mapWindow.PreserveMapID=true;
	if debug then Turbine.Shell.WriteLine("mapWindow.MapSelect:GetValue()="..tostring(mapWindow.MapSelect:GetValue())) end
	RefreshMap(mapWindow.MapSelect:GetValue());
end

mapWindow.OverlaySelect=Turbine.UI.ListBox();
mapWindow.OverlaySelect:SetParent(mapWindow);
mapWindow.OverlaySelect:SetSize(280,20);

if mapWindow:GetWidth()<mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth()+mapWindow.OverlaySelect:GetWidth() then
	mapWindow.OverlaySelect:SetPosition(mapWindow.ControlPanel:GetLeft(),mapWindow.ControlPanel:GetTop()+mapWindow.ControlPanel:GetHeight()+2)
else
	mapWindow.OverlaySelect:SetPosition(mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth(),mapWindow.MapSelect:GetTop())
end

mapWindow.OverlaySelect:SetStretchMode(3);
mapWindow.OverlayVScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.OverlayVScroll:SetSize(10,20);
mapWindow.OverlayVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.OverlayVScroll:SetPosition(mapWindow.OverlaySelect:GetLeft()+mapWindow.OverlaySelect:GetWidth(),9);
mapWindow.OverlayVScroll:SetStretchMode(3);
mapWindow.OverlayVScroll:SetBackColor(Turbine.UI.Color.Black);
mapWindow.OverlayVScroll:SetVisible(false);

local tmpRow=Turbine.UI.Label();
tmpRow:SetSize(280,20);
tmpRow:SetText(Resource[Settings.language][295]);
tmpRow:SetFont(Turbine.UI.Lotro.Font.Verdana18);
tmpRow:SetForeColor(Turbine.UI.Color(.8,.8,1));
tmpRow:SetOutlineColor(Turbine.UI.Color(0,0,1));
tmpRow:SetFontStyle(Turbine.UI.FontStyle.Outline);
tmpRow:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
tmpRow:SetParent(mapWindow.OverlaySelect);
tmpRow.MouseHover=function(sender)
	sender.MouseClick(sender);
end
tmpRow.MouseClick=function(sender)
	local height=20*mapWindow.OverlaySelect:GetItemCount();
	if height>mapWindow:GetHeight()-18 then
		height=mapWindow:GetHeight()-18;
		mapWindow.OverlayVScroll:SetHeight(height);
		mapWindow.OverlaySelect:SetVerticalScrollBar(mapWindow.OverlayVScroll);
		mapWindow.OverlayVScroll:SetParent(mapWindow);
		mapWindow.OverlayVScroll:SetVisible(true);
	else
		mapWindow.OverlayVScroll:SetParent(nil);
		mapWindow.OverlaySelect:SetVerticalScrollBar(nil);
	end
	mapWindow.OverlaySelect:SetBackColor(Turbine.UI.Color.Black);
	mapWindow.OverlaySelect:SetHeight(height);
end
mapWindow.OverlaySelect:AddItem(tmpRow);

mapWindow.XCoord=Turbine.UI.Label();
mapWindow.XCoord:SetParent(mapWindow.ControlPanel);
mapWindow.XCoord:SetSize(45,18);
mapWindow.XCoord:SetPosition(mapWindow.OverlaySelect:GetLeft()+mapWindow.OverlaySelect:GetWidth()+15,6);
mapWindow.XCoord:SetForeColor(Settings.fontColor);
mapWindow.XCoord:SetBackColor(Settings.backColor);
mapWindow.XCoord:SetFont(fontFace);
mapWindow.XCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.XCoord:SetText("");
mapWindow.XCoord:SetVisible(debug)

mapWindow.YCoord=Turbine.UI.Label();
mapWindow.YCoord:SetParent(mapWindow.ControlPanel);
mapWindow.YCoord:SetSize(45,18);
mapWindow.YCoord:SetPosition(mapWindow.XCoord:GetLeft()+mapWindow.XCoord:GetWidth()+5,6);
mapWindow.YCoord:SetForeColor(Settings.fontColor);
mapWindow.YCoord:SetBackColor(Settings.backColor);
mapWindow.YCoord:SetFont(fontFace);
mapWindow.YCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.YCoord:SetText("");
mapWindow.YCoord:SetVisible(debug)

mapWindow.CloseButton=Turbine.UI.Control();
mapWindow.CloseButton:SetParent(mapWindow);
mapWindow.CloseButton:SetStretchMode(3);
mapWindow.CloseButton:SetBackground(resourcePath.."Close.tga");
mapWindow.CloseButton:SetSize(16,16);
mapWindow.CloseButton:SetLeft(mapWindow.Map:GetWidth()-20);
mapWindow.CloseButton.MouseEnter = function()
	mapWindow.CloseButton:SetBackground(resourcePath.."Close_hover.tga");
end
mapWindow.CloseButton.MouseLeave = function()
	mapWindow.CloseButton:SetBackground(resourcePath.."Close.tga");
end
mapWindow.CloseButton.MouseClick=function()
	mapWindow:SetVisible(false);
	if mapWindow.PopUp~=nil and not mapWindow.PopUp:IsPinned() then
		mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
		mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
		mapWindow.PopUp:SetVisible(false);
		mapWindow.PopUp=nil; -- dismiss the dialog
	end
	if BDDLegend~=nil then
		BDDLegend:SetVisible(false)
	end
end

mapWindow.Map.Icons={};
mapWindow.Map.MapPoints={};
mapWindow.Map.MapPoints.Item={};

mapWindow.SearchPanel=Turbine.UI.Control();
mapWindow.SearchPanel:SetParent(mapWindow);
mapWindow.SearchPanel:SetPosition(mapWindow:GetWidth()-400,35);
mapWindow.SearchPanel:SetSize(380,mapWindow:GetHeight()-50);
mapWindow.SearchPanel:SetBackColor(Turbine.UI.Color(.05,.07,.12));
mapWindow.SearchPanel:SetVisible(false);
mapWindow.SearchPanel:SetStretchMode(3);
mapWindow.Map.SearchFilterCaption=Turbine.UI.Label();
mapWindow.Map.SearchFilterCaption:SetParent(mapWindow.SearchPanel);
mapWindow.Map.SearchFilterCaption:SetPosition(0,4);
mapWindow.Map.SearchFilterCaption:SetSize(55,18);
mapWindow.Map.SearchFilterCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.SearchFilterCaption:SetForeColor(Settings.fontColor);
mapWindow.Map.SearchFilterCaption:SetText(Resource[Settings.language][65]..":");

mapWindow.Map.IconSearch=Turbine.UI.Lotro.TextBox();
mapWindow.Map.IconSearch:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconSearch:SetSize(mapWindow.SearchPanel:GetWidth()-57,20);
mapWindow.Map.IconSearch:SetFont(fontFace);
mapWindow.Map.IconSearch:SetPosition(56,0);
mapWindow.Map.IconSearch:SetText("");
mapWindow.Map.IconSearch.OldText="";
mapWindow.Map.IconSearch.OldAllegianceCreep=true;
mapWindow.Map.IconSearch.OldAllegianceFreep=true;
mapWindow.Map.IconSearch.OldAllegianceDelving=true;
function filterBySearchText()
	-- assumes that the annotation filters have already been applied
	-- filter the results by search string and checkboxes ...
	local tmpIndex;
	local tmpHeight;
	local tmpAnnotationIndex;
	local tmpIconIndex;
	local tmpSearchText=string.lower(string.stripaccent(mapWindow.Map.IconSearch:GetText()))
	for tmpIndex=1,mapWindow.Map.IconList:GetItemCount() do
		tmpHeight=mapWindow.Map.IconList:GetItem(tmpIndex).NormalHeight
		tmpAnnotationIndex=mapWindow.Map.IconList:GetItem(tmpIndex).AnnotationIndex
		tmpIconIndex=mapWindow.Map.IconList:GetItem(tmpIndex).IconIndex
		if tmpAnnotationIndex~=nil and tmpAnnotationIndex~=0 then
			if annotations[tmpAnnotationIndex][5]==2 then
				if not mapWindow.Map.IconCreepCB:IsChecked() then tmpHeight=0 end
			elseif annotations[tmpAnnotationIndex][5]==3 then
				if not mapWindow.Map.IconFreepCB:IsChecked() then tmpHeight=0 end
			elseif annotations[tmpAnnotationIndex][5]==4 then
				if not mapWindow.Map.IconDelvingCB:IsChecked() then tmpHeight=0 end
			end

			if tmpHeight>0 and mapWindow.Map.IconSearch:GetText()~="" then
				if string.find(string.lower(string.stripaccent(mapWindow.Map.IconList:GetItem(tmpIndex):GetText())),tmpSearchText,nil,true)==nil then
					tmpHeight=0;
				end
			end
			-- now apply height to visibility
			if tmpIconIndex~=nil and tmpIconIndex>0 then
				mapWindow.Map.Icons[tmpIconIndex]:SetVisible(tmpHeight~=0 and mapWindow.Map.Icons[tmpIconIndex].FilterVisible)
			else
				mapWindow.Map.Icons[tmpIconIndex]:SetVisible(mapWindow.Map.Icons[tmpIconIndex].FilterVisible)
			end
		end
		mapWindow.Map.IconList:GetItem(tmpIndex):SetHeight(tmpHeight);
	end
end
mapWindow.Map.IconSearch.Update=function(sender)
	if mapWindow.Map.IconSearch:GetText()~=mapWindow.Map.IconSearch.OldText or mapWindow.Map.IconSearch.OldAllegianceCreep~=mapWindow.Map.IconCreepCB:IsChecked() or mapWindow.Map.IconSearch.OldAllegianceFreep~=mapWindow.Map.IconFreepCB:IsChecked() or mapWindow.Map.IconSearch.OldAllegianceDelving~=mapWindow.Map.IconDelvingCB:IsChecked() then
		mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
		mapWindow.Map.IconSearch.OldAllegianceCreep=mapWindow.Map.IconCreepCB:IsChecked();
		mapWindow.Map.IconSearch.OldAllegianceFreep=mapWindow.Map.IconFreepCB:IsChecked();
		mapWindow.Map.IconSearch.OldAllegianceDelving=mapWindow.Map.IconDelvingCB:IsChecked();

		filterBySearchText();
	end
end

mapWindow.Map.IconCreepCB=Turbine.UI.Lotro.CheckBox();
mapWindow.Map.IconCreepCB:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconCreepCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.IconCreepCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.IconCreepCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.IconCreepCB:SetForeColor(Turbine.UI.Color(1,0,0));
mapWindow.Map.IconCreepCB:SetSize(mapWindow.SearchPanel:GetWidth()/3-1,18);
mapWindow.Map.IconCreepCB:SetPosition(2,24);
mapWindow.Map.IconCreepCB:SetText(Resource[Settings.language][68]);
mapWindow.Map.IconCreepCB:SetChecked(true);
mapWindow.Map.IconCreepCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.Map.IconCreepCBHS:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconCreepCBHS:SetSize(mapWindow.Map.IconCreepCB:GetSize());
mapWindow.Map.IconCreepCBHS:SetPosition(mapWindow.Map.IconCreepCB:GetPosition());
mapWindow.Map.IconCreepCBHS.MouseClick=function()
	mapWindow.Map.IconCreepCB:SetChecked(not mapWindow.Map.IconCreepCB:IsChecked());
end
mapWindow.Map.IconCreepCBHS:SetZOrder(mapWindow.Map.IconCreepCB:GetZOrder()+1);

mapWindow.Map.IconFreepCB=Turbine.UI.Lotro.CheckBox();
mapWindow.Map.IconFreepCB:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconFreepCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.IconFreepCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.IconFreepCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.IconFreepCB:SetForeColor(Turbine.UI.Color(.35,.35,1));
mapWindow.Map.IconFreepCB:SetSize(mapWindow.SearchPanel:GetWidth()/3-1,18);
mapWindow.Map.IconFreepCB:SetPosition(mapWindow.SearchPanel:GetWidth()/3+2,24);
mapWindow.Map.IconFreepCB:SetText(Resource[Settings.language][69]);
mapWindow.Map.IconFreepCB:SetChecked(true);
mapWindow.Map.IconFreepCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.Map.IconFreepCBHS:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconFreepCBHS:SetSize(mapWindow.Map.IconFreepCB:GetSize());
mapWindow.Map.IconFreepCBHS:SetPosition(mapWindow.Map.IconFreepCB:GetPosition());
mapWindow.Map.IconFreepCBHS.MouseClick=function()
	mapWindow.Map.IconFreepCB:SetChecked(not mapWindow.Map.IconFreepCB:IsChecked());
end
mapWindow.Map.IconFreepCBHS:SetZOrder(mapWindow.Map.IconFreepCB:GetZOrder()+1);

mapWindow.Map.IconDelvingCB=Turbine.UI.Lotro.CheckBox();
mapWindow.Map.IconDelvingCB:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconDelvingCB:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.IconDelvingCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.IconDelvingCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.IconDelvingCB:SetForeColor(Turbine.UI.Color(.5,.35,.7));
mapWindow.Map.IconDelvingCB:SetSize(mapWindow.SearchPanel:GetWidth()/3-1,18);
mapWindow.Map.IconDelvingCB:SetPosition(mapWindow.SearchPanel:GetWidth()*2/3+2,24);
mapWindow.Map.IconDelvingCB:SetText(Resource[Settings.language][70]);
mapWindow.Map.IconDelvingCB:SetChecked(true);
mapWindow.Map.IconDelvingCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.Map.IconDelvingCBHS:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconDelvingCBHS:SetSize(mapWindow.Map.IconDelvingCB:GetSize());
mapWindow.Map.IconDelvingCBHS:SetPosition(mapWindow.Map.IconDelvingCB:GetPosition());
mapWindow.Map.IconDelvingCBHS.MouseClick=function()
	mapWindow.Map.IconDelvingCB:SetChecked(not mapWindow.Map.IconDelvingCB:IsChecked());
end
mapWindow.Map.IconDelvingCBHS:SetZOrder(mapWindow.Map.IconDelvingCB:GetZOrder()+1);

mapWindow.Map.IconList=Turbine.UI.ListBox();
mapWindow.Map.IconList:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconList:SetSize(mapWindow.SearchPanel:GetWidth(),mapWindow.SearchPanel:GetHeight()-46);
mapWindow.Map.IconList:SetPosition(0,46);
mapWindow.Map.IconList:SetBackColor(Turbine.UI.Color(.05,.07,.12));

mapWindow.Map.IconSearch:SetWantsUpdates(false);
mapWindow.Map.IconList.VScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.Map.IconList.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.Map.IconList.VScroll:SetParent(mapWindow.Map.IconList);
mapWindow.Map.IconList.VScroll:SetBackColor(Settings.backColor);
mapWindow.Map.IconList.VScroll:SetPosition(mapWindow.Map.IconList:GetWidth()-12,0);
mapWindow.Map.IconList.VScroll:SetWidth(12);
mapWindow.Map.IconList.VScroll:SetHeight(mapWindow.Map.IconList:GetHeight());
mapWindow.Map.IconList:SetVerticalScrollBar(mapWindow.Map.IconList.VScroll);
mapWindow.Map.IconList.VScroll:SetVisible(false);

mapWindow.FilterPanel=Turbine.UI.Control();
mapWindow.FilterPanel:SetParent(mapWindow);
mapWindow.FilterPanel:SetPosition(20,35);
mapWindow.FilterPanel:SetSize(390,mapWindow:GetHeight()-50);
mapWindow.FilterPanel:SetStretchMode(3);
mapWindow.FilterPanel:SetBackColor(Turbine.UI.Color(.10,.07,.05));
mapWindow.FilterPanel:SetVisible(false);

mapWindow.FilterPanelMenu=Turbine.UI.ContextMenu();
mapWindow.FilterPanelMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][330]));
mapWindow.FilterPanelMenu:GetItems():Get(1).Click=function(sender,args)
	iconMaint:EditIcon(mapWindow.FilterPanelMenu.iconID,true)
--	iconMaint:SetVisible(true)
end

mapWindow.FilterPanel.CloseButton=Turbine.UI.Control();
mapWindow.FilterPanel.CloseButton:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
mapWindow.FilterPanel.CloseButton:SetBackground(resourcePath.."Close.tga");
mapWindow.FilterPanel.CloseButton:SetSize(16,16);
mapWindow.FilterPanel.CloseButton:SetTop(4);
mapWindow.FilterPanel.CloseButton:SetLeft(mapWindow.FilterPanel:GetWidth()-20);
mapWindow.FilterPanel.CloseButton.MouseEnter = function()
	mapWindow.FilterPanel.CloseButton:SetBackground(resourcePath.."Close_hover.tga");
end
mapWindow.FilterPanel.CloseButton.MouseLeave = function()
	mapWindow.FilterPanel.CloseButton:SetBackground(resourcePath.."Close.tga");
end
mapWindow.FilterPanel.CloseButton.MouseClick=function()
	mapWindow.FilterPanel:SetVisible(false);
end
mapWindow.FilterPanel.Title=Turbine.UI.Label()
mapWindow.FilterPanel.Title:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.Title:SetSize(mapWindow.FilterPanel:GetWidth()-45,18);
mapWindow.FilterPanel.Title:SetPosition((mapWindow.FilterPanel:GetWidth()-mapWindow.FilterPanel.Title:GetWidth())/2,1);
mapWindow.FilterPanel.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16);
mapWindow.FilterPanel.Title:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.FilterPanel.Title:SetText(Resource[Settings.language][66]);

mapWindow.FilterPanel.Separator1=Turbine.UI.Control();
mapWindow.FilterPanel.Separator1:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.Separator1:SetPosition(5,mapWindow.FilterPanel.Title:GetTop()+21);
mapWindow.FilterPanel.Separator1:SetSize(mapWindow.FilterPanel:GetWidth()-10,1);
mapWindow.FilterPanel.Separator1:SetBackColor(Settings.trimColor);

mapWindow.FilterPanel.ViewPane=Turbine.UI.Control()
mapWindow.FilterPanel.ViewPane:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.ViewPane:SetPosition(0,mapWindow.FilterPanel.Separator1:GetTop()+3);
mapWindow.FilterPanel.ViewPane:SetSize(380,mapWindow.FilterPanel:GetHeight()-mapWindow.FilterPanel.Separator1:GetTop()-3);
mapWindow.FilterPanel.ViewPane:SetBackColor(Turbine.UI.Color(.10,.07,.05));

mapWindow.FilterPanel.ScrollPanel=Turbine.UI.Control();
mapWindow.FilterPanel.ScrollPanel:SetParent(mapWindow.FilterPanel.ViewPane);
mapWindow.FilterPanel.ScrollPanel:SetPosition(0,0);
local filterCount=0
for k in pairs(Settings.Filters) do filterCount=filterCount+1 end
mapWindow.FilterPanel.ScrollPanel:SetSize(380,filterCount*20+116);
mapWindow.FilterPanel.ScrollPanel:SetBackColor(Turbine.UI.Color(.10,.07,.05));
mapWindow.FilterPanel.VScroll=Turbine.UI.Lotro.ScrollBar();

mapWindow.FilterPanel.VScroll:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.FilterPanel.VScroll:SetPosition(380,mapWindow.FilterPanel.ViewPane:GetTop());
mapWindow.FilterPanel.VScroll:SetSize(10,mapWindow.FilterPanel.ViewPane:GetHeight());

mapWindow.FilterPanel.VScroll.ValueChanged=function(sender,args)
	local lValue=mapWindow.FilterPanel.VScroll:GetValue();
	mapWindow.FilterPanel.ScrollPanel:SetTop(0-lValue);
end
mapWindow.FilterPanel.VScroll:SetMaximum(mapWindow.FilterPanel.ScrollPanel:GetHeight()-mapWindow.FilterPanel.ViewPane:GetHeight());
mapWindow.FilterPanel.VScroll:SetVisible(mapWindow.FilterPanel.ViewPane:GetHeight()<mapWindow.FilterPanel.ScrollPanel:GetHeight());

mapWindow.FilterPanel.AllegianceCaption=Turbine.UI.Label();
mapWindow.FilterPanel.AllegianceCaption:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceCaption:SetPosition(5,0);
mapWindow.FilterPanel.AllegianceCaption:SetSize(95,18);
mapWindow.FilterPanel.AllegianceCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.FilterPanel.AllegianceCaption:SetForeColor(Settings.fontColor);
mapWindow.FilterPanel.AllegianceCaption:SetText(Resource[Settings.language][67]..":");

mapWindow.FilterPanel.AllegianceCreep=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.AllegianceCreep:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceCreep:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.FilterPanel.AllegianceCreep:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.FilterPanel.AllegianceCreep:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.FilterPanel.AllegianceCreep:SetForeColor(Turbine.UI.Color(1,0,0));
mapWindow.FilterPanel.AllegianceCreep:SetSize((mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.AllegianceCaption:GetWidth()-10),18);
mapWindow.FilterPanel.AllegianceCreep:SetPosition(mapWindow.FilterPanel.AllegianceCaption:GetLeft()+mapWindow.FilterPanel.AllegianceCaption:GetWidth(),mapWindow.FilterPanel.AllegianceCaption:GetTop());
mapWindow.FilterPanel.AllegianceCreep:SetText(Resource[Settings.language][68]);
mapWindow.FilterPanel.AllegianceCreep:SetChecked(Settings.filterAllegianceCreep);
mapWindow.FilterPanel.AllegianceCreepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.FilterPanel.AllegianceCreepHS:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceCreepHS:SetSize(mapWindow.FilterPanel.AllegianceCreep:GetSize());
mapWindow.FilterPanel.AllegianceCreepHS:SetPosition(mapWindow.FilterPanel.AllegianceCreep:GetPosition());
mapWindow.FilterPanel.AllegianceCreepHS.MouseClick=function()
	mapWindow.FilterPanel.AllegianceCreep:SetChecked(not mapWindow.FilterPanel.AllegianceCreep:IsChecked());
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.AllegianceCreepHS:SetZOrder(mapWindow.FilterPanel.AllegianceCreep:GetZOrder()+1);

mapWindow.FilterPanel.AllegianceFreep=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.AllegianceFreep:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceFreep:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.FilterPanel.AllegianceFreep:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.FilterPanel.AllegianceFreep:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.FilterPanel.AllegianceFreep:SetForeColor(Turbine.UI.Color(.35,.35,1));
mapWindow.FilterPanel.AllegianceFreep:SetSize((mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.AllegianceCaption:GetWidth()-10),18);
mapWindow.FilterPanel.AllegianceFreep:SetPosition(mapWindow.FilterPanel.AllegianceCreep:GetLeft(),mapWindow.FilterPanel.AllegianceCreep:GetTop()+20);
mapWindow.FilterPanel.AllegianceFreep:SetText(Resource[Settings.language][69]);
mapWindow.FilterPanel.AllegianceFreep:SetChecked(Settings.filterAllegianceFreep);
mapWindow.FilterPanel.AllegianceFreepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.FilterPanel.AllegianceFreepHS:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceFreepHS:SetSize(mapWindow.FilterPanel.AllegianceFreep:GetSize());
mapWindow.FilterPanel.AllegianceFreepHS:SetPosition(mapWindow.FilterPanel.AllegianceFreep:GetPosition());
mapWindow.FilterPanel.AllegianceFreepHS.MouseClick=function()
	mapWindow.FilterPanel.AllegianceFreep:SetChecked(not mapWindow.FilterPanel.AllegianceFreep:IsChecked());
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.AllegianceFreepHS:SetZOrder(mapWindow.FilterPanel.AllegianceFreep:GetZOrder()+1);

mapWindow.FilterPanel.AllegianceDelving=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.AllegianceDelving:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceDelving:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.FilterPanel.AllegianceDelving:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.FilterPanel.AllegianceDelving:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.FilterPanel.AllegianceDelving:SetForeColor(Turbine.UI.Color(.5,.35,.7));
mapWindow.FilterPanel.AllegianceDelving:SetSize((mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.AllegianceCaption:GetWidth()-10),18);
mapWindow.FilterPanel.AllegianceDelving:SetPosition(mapWindow.FilterPanel.AllegianceCreep:GetLeft(),mapWindow.FilterPanel.AllegianceFreep:GetTop()+20);
mapWindow.FilterPanel.AllegianceDelving:SetText(Resource[Settings.language][70]);
mapWindow.FilterPanel.AllegianceDelving:SetChecked(Settings.filterAllegianceDelving);
mapWindow.FilterPanel.AllegianceDelvingHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.FilterPanel.AllegianceDelvingHS:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceDelvingHS:SetSize(mapWindow.FilterPanel.AllegianceDelving:GetSize());
mapWindow.FilterPanel.AllegianceDelvingHS:SetPosition(mapWindow.FilterPanel.AllegianceDelving:GetPosition());
mapWindow.FilterPanel.AllegianceDelvingHS.MouseClick=function()
	mapWindow.FilterPanel.AllegianceDelving:SetChecked(not mapWindow.FilterPanel.AllegianceDelving:IsChecked());
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.AllegianceDelvingHS:SetZOrder(mapWindow.FilterPanel.AllegianceDelving:GetZOrder()+1);

mapWindow.FilterPanel.Separator2=Turbine.UI.Control();
mapWindow.FilterPanel.Separator2:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.Separator2:SetPosition(5,mapWindow.FilterPanel.AllegianceDelving:GetTop()+22);
mapWindow.FilterPanel.Separator2:SetSize(mapWindow.FilterPanel.ScrollPanel:GetWidth()-10,1);
mapWindow.FilterPanel.Separator2:SetBackColor(Settings.trimColor);

mapWindow.FilterPanel.SelectAllButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.SelectAllButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.SelectAllButton:SetSize(140,18);
mapWindow.FilterPanel.SelectAllButton:SetTop(mapWindow.FilterPanel.Separator2:GetTop()+6);
mapWindow.FilterPanel.SelectAllButton:SetFont(Turbine.UI.Lotro.Font.Verdana16)
mapWindow.FilterPanel.SelectAllButton:SetLeft(5);
mapWindow.FilterPanel.SelectAllButton:SetText(Resource[Settings.language][348]);
mapWindow.FilterPanel.SelectAllButton.MouseClick=function()
	-- we don't currently include allegiance in "select all"
	--mapWindow.FilterPanel.AllegianceCreep:SetChecked(true);
	--mapWindow.FilterPanel.AllegianceFreep:SetChecked(true);
	--mapWindow.FilterPanel.AllegianceDelving:SetChecked(true);
	-- set all Type filter options on
	for k,v in pairs(mapWindow.FilterPanel.Filters) do
		v.CB:SetChecked(true)
	end

	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.ClearAllButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.ClearAllButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.ClearAllButton:SetSize(140,18);
mapWindow.FilterPanel.ClearAllButton:SetFont(Turbine.UI.Lotro.Font.Verdana16)
mapWindow.FilterPanel.ClearAllButton:SetTop(mapWindow.FilterPanel.SelectAllButton:GetTop());
mapWindow.FilterPanel.ClearAllButton:SetLeft(mapWindow.FilterPanel.ScrollPanel:GetWidth()-145);
mapWindow.FilterPanel.ClearAllButton:SetText(Resource[Settings.language][349]);
mapWindow.FilterPanel.ClearAllButton.MouseClick=function()
	--mapWindow.FilterPanel.AllegianceCreep:SetChecked(false);
	--mapWindow.FilterPanel.AllegianceFreep:SetChecked(false);
	--mapWindow.FilterPanel.AllegianceDelving:SetChecked(false);
	-- set all Type filter options off
	for k,v in pairs(mapWindow.FilterPanel.Filters) do
		v.CB:SetChecked(false)
	end

	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.SetDefaultButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.SetDefaultButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.SetDefaultButton:SetSize(140,18);
mapWindow.FilterPanel.SetDefaultButton:SetFont(Turbine.UI.Lotro.Font.Verdana16)
mapWindow.FilterPanel.SetDefaultButton:SetTop(mapWindow.FilterPanel.SelectAllButton:GetTop()+20);
mapWindow.FilterPanel.SetDefaultButton:SetLeft(5);
mapWindow.FilterPanel.SetDefaultButton:SetText(Resource[Settings.language][350]);
mapWindow.FilterPanel.SetDefaultButton.MouseClick=function()

	for k,v in pairs(mapWindow.FilterPanel.Filters) do
		v.CB:SetChecked(Settings.Filters[k][2])
	end

	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.SaveDefaultButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.SaveDefaultButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.SaveDefaultButton:SetSize(140,18);
mapWindow.FilterPanel.SaveDefaultButton:SetFont(Turbine.UI.Lotro.Font.Verdana16)
mapWindow.FilterPanel.SaveDefaultButton:SetTop(mapWindow.FilterPanel.SelectAllButton:GetTop()+20);
mapWindow.FilterPanel.SaveDefaultButton:SetLeft(mapWindow.FilterPanel.ScrollPanel:GetWidth()-145);
mapWindow.FilterPanel.SaveDefaultButton:SetText(Resource[Settings.language][351]);
mapWindow.FilterPanel.SaveDefaultButton.MouseClick=function()
	for k,v in pairs(mapWindow.FilterPanel.Filters) do
		Settings.Filters[k][2]=v.CB:IsChecked()
	end
end

mapWindow.FilterPanel.TypeCaption=Turbine.UI.Label();
mapWindow.FilterPanel.TypeCaption:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCaption:SetPosition(5,mapWindow.FilterPanel.SetDefaultButton:GetTop()+22);
mapWindow.FilterPanel.TypeCaption:SetSize(80,18);
mapWindow.FilterPanel.TypeCaption:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.FilterPanel.TypeCaption:SetForeColor(Settings.fontColor);
mapWindow.FilterPanel.TypeCaption:SetText(Resource[Settings.language][74]..":");

mapWindow.FilterPanel.Filters={}
local cbWidth=mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.TypeCaption:GetWidth()-10
local cbLeft=mapWindow.FilterPanel.TypeCaption:GetLeft()+mapWindow.FilterPanel.TypeCaption:GetWidth()
local cbTop=mapWindow.FilterPanel.SetDefaultButton:GetTop()+2
for k,v in ipairs(iconInfo) do
	if v[7]~=nil then
		local tmpCB=Turbine.UI.Lotro.CheckBox()
		local tmpIcon=Turbine.UI.Control()
		tmpCB:SetParent(mapWindow.FilterPanel.ScrollPanel)
		tmpCB:SetFont(Turbine.UI.Lotro.Font.Verdana14)
		tmpCB:SetForeColor(Settings.fontColor)
		tmpCB:SetSize(cbWidth,18)
		tmpCB:SetPosition(cbLeft,cbTop+20*v[7])
		if v[1]==115 then
			tmpCB:SetText(Resource[Settings.language][224])
			tmpCB:SetChecked(Settings.Filters["Map"][1])
		elseif v[1]==248 then
			tmpCB:SetText(Resource[Settings.language][273])
			tmpCB:SetChecked(Settings.Filters["Stair"][1])
		else
			tmpCB:SetText(Resource[Settings.language][v[1]])
			tmpCB:SetChecked(Settings.Filters[Resource[1][v[1]]][1])
		end
		tmpCB.MouseClick=function(sender,args)
			if args.Button==2 then
				local x,y=Turbine.UI.Display:GetMousePosition()
				mapWindow.FilterPanelMenu.iconID=k
				mapWindow.FilterPanelMenu:ShowMenuAt(x+2,y-5);
			end
		end
		tmpCB.CheckedChanged=function()
			mapWindow.NeedsRefresh=true
			mapWindow:SetWantsUpdates(true)
		end
		tmpIcon=Turbine.UI.Control()
		tmpIcon:SetParent(mapWindow.FilterPanel.ScrollPanel)
		tmpIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay)
		if v[6]~=nil then
			if tonumber(v[6])~=nil then
				local success,result=pcall(Turbine.UI.Control.SetBackground,tmpIcon,tonumber(v[6]));
			else
				local success,result=pcall(Turbine.UI.Control.SetBackground,tmpIcon,resourcePath..v[6]);
			end
		end
		tmpIcon:SetStretchMode(2)
		tmpIcon:SetSize(tmpIcon:GetWidth(),tmpIcon:GetHeight())
		tmpIcon:SetStretchMode(0)
		tmpIcon:SetPosition(tmpCB:GetLeft()-20,tmpCB:GetTop())
		if v[1]==115 then
			-- override "Good Map" with just "Map" since it represents all map-ins
			mapWindow.FilterPanel.Filters["Map"]={icon=tmpIcon,CB=tmpCB,iconIndex=k}
		elseif v[1]==248 then
			-- override "Stair Up" with "Stair"
			mapWindow.FilterPanel.Filters["Stair"]={icon=tmpIcon,CB=tmpCB,iconIndex=k}
		else
			mapWindow.FilterPanel.Filters[Resource[1][v[1]]]={icon=tmpIcon,CB=tmpCB,iconIndex=k}
		end
	end
end
mapWindow.FilterPanel.TypeOreNodeTier=DropDownList();
mapWindow.FilterPanel.TypeOreNodeTier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeOreNodeTier:SetSize(65,20);
mapWindow.FilterPanel.TypeOreNodeTier:SetFont(Turbine.UI.Lotro.Font.Verdana16);
mapWindow.FilterPanel.TypeOreNodeTier:SetPosition(mapWindow.FilterPanel.ScrollPanel:GetWidth()-75,mapWindow.FilterPanel.Filters[Resource[1][155]].CB:GetTop());
mapWindow.FilterPanel.TypeOreNodeTier:SetBorderColor(Settings.trimColor);
mapWindow.FilterPanel.TypeOreNodeTier:SetBackColor(Settings.backColor);
mapWindow.FilterPanel.TypeOreNodeTier.CurrentValue:SetBackColor(Settings.backColor);
mapWindow.FilterPanel.TypeOreNodeTier:SetTextColor(Settings.listTextColor);
mapWindow.FilterPanel.TypeOreNodeTier:SetDropRows(7);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][158],0);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 1",1);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 2",2);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 3",3);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 4",4);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 5",5);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 6",6);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 7",7);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 8",8);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 9",9);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 10",10);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[Settings.language][159].." 11",11);
mapWindow.FilterPanel.TypeOreNodeTier:SetSelectedIndex(Settings.filterOreNodeTier+1);
mapWindow.FilterPanel.TypeOreNodeTier.SelectedIndexChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeWoodNodeTier=DropDownList();
mapWindow.FilterPanel.TypeWoodNodeTier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeWoodNodeTier:SetSize(65,20);
mapWindow.FilterPanel.TypeWoodNodeTier:SetFont(Turbine.UI.Lotro.Font.Verdana16);
mapWindow.FilterPanel.TypeWoodNodeTier:SetPosition(mapWindow.FilterPanel.ScrollPanel:GetWidth()-75,mapWindow.FilterPanel.Filters[Resource[1][156]].CB:GetTop());
mapWindow.FilterPanel.TypeWoodNodeTier:SetBorderColor(Settings.trimColor);
mapWindow.FilterPanel.TypeWoodNodeTier:SetBackColor(Settings.backColor);
mapWindow.FilterPanel.TypeWoodNodeTier.CurrentValue:SetBackColor(Settings.backColor);
mapWindow.FilterPanel.TypeWoodNodeTier:SetTextColor(Settings.listTextColor);
mapWindow.FilterPanel.TypeWoodNodeTier:SetDropRows(7);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][158],0);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 1",1);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 2",2);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 3",3);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 4",4);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 5",5);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 6",6);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 7",7);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 8",8);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 9",9);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 10",10);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[Settings.language][159].." 11",11);
mapWindow.FilterPanel.TypeWoodNodeTier:SetSelectedIndex(Settings.filterWoodNodeTier+1);
mapWindow.FilterPanel.TypeWoodNodeTier.SelectedIndexChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeScholarNodeTier=DropDownList();
mapWindow.FilterPanel.TypeScholarNodeTier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeScholarNodeTier:SetSize(65,20);
mapWindow.FilterPanel.TypeScholarNodeTier:SetFont(Turbine.UI.Lotro.Font.Verdana16);
mapWindow.FilterPanel.TypeScholarNodeTier:SetPosition(mapWindow.FilterPanel.ScrollPanel:GetWidth()-75,mapWindow.FilterPanel.Filters[Resource[1][157]].CB:GetTop());
mapWindow.FilterPanel.TypeScholarNodeTier:SetBorderColor(Settings.trimColor);
mapWindow.FilterPanel.TypeScholarNodeTier:SetBackColor(Settings.backColor);
mapWindow.FilterPanel.TypeScholarNodeTier.CurrentValue:SetBackColor(Settings.backColor);
mapWindow.FilterPanel.TypeScholarNodeTier:SetTextColor(Settings.listTextColor);
mapWindow.FilterPanel.TypeScholarNodeTier:SetDropRows(7);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][158],0);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 1",1);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 2",2);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 3",3);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 4",4);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 5",5);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 6",6);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 7",7);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 8",8);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 9",9);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[Settings.language][159].." 11",11);
mapWindow.FilterPanel.TypeScholarNodeTier:SetSelectedIndex(Settings.filterScholarNodeTier+1);
mapWindow.FilterPanel.TypeScholarNodeTier.SelectedIndexChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.TypeScholarNodeTier:SetZOrder(mapWindow.FilterPanel.Filters[Resource[1][154]].icon:GetZOrder()+1);
mapWindow.FilterPanel.TypeWoodNodeTier:SetZOrder(mapWindow.FilterPanel.TypeScholarNodeTier:GetZOrder()+1);
mapWindow.FilterPanel.TypeOreNodeTier:SetZOrder(mapWindow.FilterPanel.TypeWoodNodeTier:GetZOrder()+1);

mapWindow.Map.Ping=Turbine.UI.Control();
mapWindow.Map.Ping:SetParent(mapWindow.Map);
mapWindow.Map.Ping.State=0;
mapWindow.Map.Ping:SetVisible(false);
mapWindow.Map.Ping:SetSize(23,23);
mapWindow.Map.Ping:SetPosition(512,512);
mapWindow.Map.Ping:SetWantsUpdates(false);
mapWindow.Map.Ping.Counter=1;
mapWindow.Map.Ping.MaxCounter=2;
mapWindow.Map.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
mapWindow.Map.Ping:SetBackground(resourcePath.."Ping1.tga");
mapWindow.Map.Ping.MouseClick=function(sender,args)
	mapWindow.Map.Ping.State=0; -- it will auto hide itmapWindow on next tick
end
mapWindow.Map.Ping.Update=function(sender)
	if mapWindow.Map.Ping.State==0 then
		mapWindow.Map.Ping:SetWantsUpdates(false);
		mapWindow.Map.Ping:SetVisible(false);
		mapWindow.Map.Ping.Counter=0;
		mapWindow.Map.Ping:SetBackground(resourcePath.."Ping1.tga");
	elseif mapWindow.Map.Ping.State==7 then
		mapWindow.Map.Ping.Counter=mapWindow.Map.Ping.Counter+1;
		if mapWindow.Map.Ping.Counter>mapWindow.Map.Ping.MaxCounter then
			mapWindow.Map.Ping.Counter=0;
			mapWindow.Map.Ping.State=3;
			mapWindow.Map.Ping:SetBackground(resourcePath.."Ping3.tga");
		end

	else
		mapWindow.Map.Ping.Counter=mapWindow.Map.Ping.Counter+1;
		if mapWindow.Map.Ping.Counter>mapWindow.Map.Ping.MaxCounter then
			mapWindow.Map.Ping.Counter=0;
			mapWindow.Map.Ping.State=mapWindow.Map.Ping.State+1;
			mapWindow.Map.Ping:SetBackground(resourcePath.."Ping"..tostring(mapWindow.Map.Ping.State)..".tga");
		end
	end
end

mapWindow.FontMetric=FontMetric();
mapWindow.FontMetric:SetFont(Turbine.UI.Lotro.Font.Verdana14);

mapWindow.Map.HoverWindow=Turbine.UI.Window();
mapWindow.Map.HoverWindow:SetZOrder(2);
mapWindow.Map.HoverWindow:SetVisible(false);
mapWindow.Map.HoverWindow:SetPosition(0,0);
mapWindow.Map.HoverWindow:SetBackColor(Turbine.UI.Color(.7,.05,.05,.05));
mapWindow.Map.HoverWindow.Name=Turbine.UI.Label();
mapWindow.Map.HoverWindow.Name:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Name:SetSize(100,16);
mapWindow.Map.HoverWindow.Name:SetPosition(0,0);
mapWindow.Map.HoverWindow.Name:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.HoverWindow.Name:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.HoverWindow.Name:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.HoverWindow.Name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.Map.HoverWindow.Name:SetText("");
mapWindow.Map.HoverWindow.Waypoint=Turbine.UI.Lotro.Quickslot();
mapWindow.Map.HoverWindow.Waypoint:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Waypoint:SetSize(100,16);
mapWindow.Map.HoverWindow.Waypoint:SetPosition(5,18);
mapWindow.Map.HoverWindow.Waypoint:SetAllowDrop(false);
mapWindow.Map.HoverWindow.Waypoint.DragDrop=function()
	if mapWindow.Map.HoverWindow.Waypoint.Alias~=nil and mapWindow.Map.HoverWindow.Waypoint.Alias~="" then
		local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
		sc:SetData(mapWindow.Map.HoverWindow.Waypoint.Alias);
		mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
	end
end
mapWindow.Map.HoverWindow.Coord=Turbine.UI.Label();
mapWindow.Map.HoverWindow.Coord:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Coord:SetSize(100,16);
mapWindow.Map.HoverWindow.Coord:SetPosition(5,18);
mapWindow.Map.HoverWindow.Coord:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.HoverWindow.Coord:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.HoverWindow.Coord:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.HoverWindow.Coord:SetForeColor(Turbine.UI.Color(.8,.8,.9));
mapWindow.Map.HoverWindow.Coord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.Map.HoverWindow.Coord:SetText("");
mapWindow.Map.HoverWindow.Coord:SetMouseVisible(false);
mapWindow.Map.HoverWindow.Edit=Turbine.UI.Label();
mapWindow.Map.HoverWindow.Edit:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Edit:SetSize(100,16);
mapWindow.Map.HoverWindow.Edit:SetPosition(5,36);
mapWindow.Map.HoverWindow.Edit:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.HoverWindow.Edit:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.HoverWindow.Edit:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.HoverWindow.Edit:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.Map.HoverWindow.Edit:SetText("Edit");
mapWindow.Map.HoverWindow.Edit.MouseClick=function()
	annotWindow:SetVisible(true);
	mapWindow.Map.HoverWindow:SetVisible(false);
end
mapWindow.Map.HoverWindow.XY=Turbine.UI.Label();
mapWindow.Map.HoverWindow.XY:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.XY:SetMouseVisible(false);
mapWindow.Map.HoverWindow.HideCount=0;
if debug then
	mapWindow.Map.HoverWindow.XY=Turbine.UI.Label();
	mapWindow.Map.HoverWindow.XY:SetParent(mapWindow.Map.HoverWindow);
	mapWindow.Map.HoverWindow.XY:SetSize(100,16);
	mapWindow.Map.HoverWindow.XY:SetPosition(5,54);
	mapWindow.Map.HoverWindow.XY:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	mapWindow.Map.HoverWindow.XY:SetText("X:Y");
	mapWindow.Map.HoverWindow.XY:SetVisible(true);
	mapWindow.Map.HoverWindow:SetSize(100,72);
else
	mapWindow.Map.HoverWindow.XY:SetVisible(false);
	mapWindow.Map.HoverWindow:SetSize(100,56);
end
mapWindow.Map.HoverWindow.SizeChanged=function(sender,args)
	local newWidth=mapWindow.Map.HoverWindow:GetWidth();
	mapWindow.Map.HoverWindow.Name:SetWidth(newWidth);
	mapWindow.Map.HoverWindow.Waypoint:SetWidth(newWidth-10);
	mapWindow.Map.HoverWindow.Coord:SetWidth(newWidth-10);
	mapWindow.Map.HoverWindow.Edit:SetWidth(newWidth-10);
	mapWindow.Map.HoverWindow.XY:SetWidth(newWidth-10);
end
mapWindow.Map.HoverWindow.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Name.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.Name.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Edit.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.Edit.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Waypoint.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.Waypoint.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Update=function()
	if mapWindow.Map.HoverWindow.Hide then
		mapWindow.Map.HoverWindow.HideCount=mapWindow.Map.HoverWindow.HideCount+1;
	end
	if mapWindow.Map.HoverWindow.HideCount>5 then
		mapWindow.Map.HoverWindow:SetWantsUpdates(false);
		mapWindow.Map.HoverWindow:SetVisible(false);
	end
end

mapWindow:SetText(Resource[Settings.language][2]);

mapWindow.SetPluginUnloading = function(value)
	mapWindow.PluginUnloading=value;
end
mapWindow.VisibleChanged=function()
	if quickWindow:GetTop()+32>Turbine.UI.Display:GetHeight() then quickWindow:SetTop(Turbine.UI.Display:GetHeight()-32) end
	if quickWindow:GetLeft()+32>Turbine.UI.Display:GetWidth() then quickWindow:SetLeft(Turbine.UI.Display:GetWidth()-32) end
	if minWindow:GetTop()+32>Turbine.UI.Display:GetHeight() then minWindow:SetTop(Turbine.UI.Display:GetHeight()-32) end
	if minWindow:GetLeft()+32>Turbine.UI.Display:GetWidth() then minWindow:SetLeft(Turbine.UI.Display:GetWidth()-32) end
	if mapWindow:GetHeight()>Turbine.UI.Display:GetHeight() then mapWindow:SetHeight(Turbine.UI.Display:GetHeight()) end
	if mapWindow:GetWidth()>Turbine.UI.Display:GetWidth() then
if debug then
Turbine.Shell.WriteLine("SetWidth:Turbine.UI.Display:GetWidth():"..tostring(Turbine.UI.Display:GetWidth()))
end
		mapWindow:SetWidth(Turbine.UI.Display:GetWidth())
	end
--	if mapWindow:GetTop()+mapWindow:GetHeight()>Turbine.UI.Display:GetHeight() then mapWindow:SetTop(Turbine.UI.Display:GetHeight()-mapWindow:GetHeight()) end
--	if mapWindow:GetLeft()+mapWindow:GetWidth()>Turbine.UI.Display:GetWidth() then mapWindow:SetLeft(Turbine.UI.Display:GetWidth()-mapWindow:GetWidth()) end

	if (not mapWindow.PluginUnloading) then
		if not mapWindow:IsVisible() then
			minWindow:SetVisible(Settings.showIconWhenMinimized);
			quickWindow:SetVisible(quickWindow.Displayed);
			if optWindow~=nil then optWindow:SetVisible(false) end;
			if annotWindow~=nil then annotWindow:SetVisible(false) end;
		else
			minWindow:SetVisible(false)
			-- refresh anything that needs refreshing when map is visible
			RefreshMap();
			if mapWindow.LocationIcon~=nil then
				if mapWindow.PlayerIconVisible==true then
					mapWindow.LocationIcon:SetVisible(true);
					mapWindow.LocationIcon:SetRotation({x=0,y=0,z=0-(mapWindow.Heading-90)});
				end
			end
		end
	end
end

mapWindow.AddAnnotationMenu=Turbine.UI.ContextMenu();
if mapWindow.CurrentMapID~=2 then
	mapWindow.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][410]));
	mapWindow.AddAnnotationMenu:GetItems():Get(1):SetEnabled(mapInfo[mapWindow.CurrentMapID][11]==1)
	mapWindow.AddAnnotationMenu:GetItems():Get(1).Click=function()

		-- check if terrainmap ver 1.39 or newer is installed
		if TerrainMapVersion==0 then
			if mapWindow.PopUp~=nil then
				mapWindow.PopUp:SetVisible(false)
				mapWindow.PopUp=nil
			end
			mapWindow.PopUp=PopUpDialog("TerrainMap Error","This feature requires TerrainMap plugin version 1.24 or newer. TerrainMap does not appear to be installed.",4,"OK")
			mapWindow.PopUp:SetZOrder(mapWindow:GetZOrder()+1)
			Turbine.Shell.WriteLine("This feature requires TerrainMap plugin version 1.24 or newer. TerrainMap does not appear to be installed.")
		else
			if tonumber(TerrainMapVersion)==nil or tonumber(TerrainMapVersion)<1.24 then
				if mapWindow.PopUp~=nil then
					mapWindow.PopUp:SetVisible(false)
					mapWindow.PopUp=nil
				end
				mapWindow.PopUp=PopUpDialog("TerrainMap Error","This feature requires TerrainMap plugin version 1.24 or newer. The installed TerrainMap version is:"..tostring(TerrainMapVersion),4,"OK")
				mapWindow.PopUp:SetZOrder(mapWindow:GetZOrder()+1)
				Turbine.Shell.WriteLine("This feature requires TerrainMap plugin version 1.24 or newer. The installed TerrainMap version is:"..tostring(TerrainMapVersion))
			else
				local TerrainMapRunning=false
				tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
				for pluginIndex=1,#tmpPlugins do
					if tmpPlugins[pluginIndex].Name=="TerrainMap" then
						TerrainMapRunning=true;
						break;
					end
				end
				if not TerrainMapRunning then
					Turbine.PluginManager.LoadPlugin("TerrainMap");
				end

				-- show in TerrainMap
				Turbine.Shell.WriteLine("terrainmap ping "..tostring(mapInfo[mapWindow.CurrentMapID][12])..":"..tostring(mapWindow.mouseNS)..":"..tostring(mapWindow.mouseEW))
				-- now hide MoorMap
				mapWindow:SetVisible(false);
				minWindow:SetVisible(true);
				quickWindow:SetVisible(quickWindow.Displayed);
				if BDDLegend~=nil then
					BDDLegend:SetVisible(false)
				end
			end
		end
	end
	mapWindow.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][82]));
	mapWindow.AddAnnotationMenu:GetItems():Get(2).Click=function()
		annotWindow.AnnotationList:SetSelectedIndex(1);
		annotWindow:EditAnnotation(0);
		annotWindow.TypeList:SetSelectedIndex(1);
		annotWindow.NameText:SetText("");
		annotWindow.DescriptionText:SetText("");
		annotWindow:SetVisible(true);
	end
	mapWindow.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[Settings.language][148]));
	mapWindow.AddAnnotationMenu:GetItems():Get(3).Click=function()
		RefreshMap(mapInfo[mapWindow.CurrentMapID][10]);
	end
end

mapWindow.MovingIcon=Turbine.UI.Control();
mapWindow.MovingIcon:SetParent(mapWindow);
mapWindow.MovingIcon:SetSize(32,32);
mapWindow.MovingIcon:SetStretchMode(1); -- allows it to display past the parent's bounds
mapWindow.MovingIcon:SetBackground(0x410081c0)
-- for some reason, when StretchMode=1, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
mapWindow.MovingIcon:SetPosition(mapWindow:GetWidth()/2-15,mapWindow:GetHeight()-21);
mapWindow.MovingIcon:SetVisible(false);

mapWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		mapWindow:SetVisible(false);
		minWindow:SetVisible(true);

		quickWindow:SetVisible(quickWindow.Displayed);
		if defAnnWindow~=nil then
			defAnnWindow:SetVisible(false);
		end
		mapWindow.Map.HoverWindow:SetVisible(false);
		overlayWindow:SetVisible(false);
		optionsWindow:SetVisible(false);
		breadcrumbWindow:SetVisible(false);
		searchWindow:SetVisible(false);
		if BDDLegend~=nil then
			BDDLegend:SetVisible(false);
		end
		if mapWindow.PopUp~=nil and not mapWindow.PopUp:IsPinned() then
			mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
			mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
			mapWindow.PopUp:SetVisible(false);
			mapWindow.PopUp=nil; -- dismiss the dialog
		end
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		HUDVisible=not HUDVisible;
		if HUDVisible then
			mapWindow:SetVisible(MapVis);
			minWindow:SetVisible(MinVis);
			quickWindow:SetVisible(QuickVis);
			overlayWindow:SetVisible(OverlayVis);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(BDDVis);
			end
			breadcrumbWindow:SetVisible(BreadcrumbVis);
			searchWindow:SetVisible(SearchVis);
			debugWindow:SetVisible(DebugVis)
			if mapWindow.PopUp~=nil then
				mapWindow.PopUp:SetVisible(PopUpVis)
			end
		else
			DebugVis=debugWindow:IsVisible()
			MapVis=mapWindow:IsVisible();
			MinVis=minWindow:IsVisible();
			QuickVis=quickWindow:IsVisible();
			OverlayVis=overlayWindow:IsVisible();
			BreadcrumbVis=breadcrumbWindow:IsVisible();
			SearchVis=searchWindow:IsVisible();
			if BDDLegend~=nil then
				BDDVis=BDDLegend:IsVisible();
				BDDLegend:SetVisible(false);
			end
			if mapWindow.PopUp~=nil then
				PopUpVis=mapWindow.PopUp:IsVisible()
				mapWindow.PopUp:SetVisible(false)
			else
				PopUpVis=false
			end
			debugWindow:SetVisible(false)
			mapWindow:SetVisible(false);
			minWindow:SetVisible(false); -- this is harmless if the "ShowIconWhenMinimized" option is turned off
			quickWindow:SetVisible(false);
			-- if turbine ever exposes the UI state, we can force the minimized icon not to display when the HUD is off
			if defAnnWindow~=nil then
				defAnnWindow:SetVisible(false);
			end
			mapWindow.Map.HoverWindow:SetVisible(false);
			overlayWindow:SetVisible(false);
			optionsWindow:SetVisible(false);
			breadcrumbWindow:SetVisible(false);
			searchWindow:SetVisible(false)
		end
	end
end

mapWindow.GetMinimumWidth=function()
	return mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth()+24;
end
mapWindow.GetMinimumHeight=function()
	local retval=297
	if Settings.lockAspect then
		retval=mapWindow:GetMinimumWidth()*3/4
	end
	return retval;
end
if mapWindow:GetHeight()<mapWindow:GetMinimumHeight() then mapWindow:SetHeight(mapWindow:GetMinimumHeight()) end
if mapWindow:GetWidth()<mapWindow:GetMinimumWidth() then
if debug then
Turbine.Shell.WriteLine("SetWidth:mapWindow:GetMinimumWidth():"..tostring(mapWindow:GetMinimumWidth()))
end
	mapWindow:SetWidth(mapWindow:GetMinimumWidth())
end

mapWindow.SizeChanged=function(sender)
	local height=mapWindow:GetHeight()
	local width=mapWindow:GetWidth()
	local newWidth=width
	local newHeight=height
	if debug then
		Turbine.Shell.WriteLine("setting size ("..tostring(width)..","..tostring(height)..")");
	end
	if debug then
		Turbine.Shell.WriteLine("mapWindow:GetMinimumWidth()="..tostring(mapWindow:GetMinimumWidth()));
		Turbine.Shell.WriteLine("mapWindow:GetMinimumHeight()="..tostring(mapWindow:GetMinimumHeight()));
	end
	if width<mapWindow:GetMinimumWidth() then newWidth=mapWindow:GetMinimumWidth() end;
	if height<mapWindow:GetMinimumHeight() then newHeight=mapWindow:GetMinimumHeight() end;
	-- enforce aspect if lockAspect is true
	if Settings.lockAspect then
			if debug then
				Turbine.Shell.WriteLine("checking aspect");
			end
		if newWidth~=mapWindow.OldWidth or newHeight~=mapWindow.OldHeight then
			-- check display aspect vs map default aspect
			local defaultAspect=4/3 -- map actual image is 1024x768
			local displayAspect=displayWidth/displayHeight
			if debug then
				Turbine.Shell.WriteLine("displayAspect:"..tostring(displayAspect));
			end
			if displayAspect>defaultAspect then
				-- display is wider so height is major bound
				if debug then
					Turbine.Shell.WriteLine("enforcing max width");
				end
				if newWidth/defaultAspect>displayHeight then newWidth=displayHeight*defaultAspect end
			else
				-- display is same or narrower so width is major bound
				if debug then
					Turbine.Shell.WriteLine("enforcing max height");
				end
				if newHeight*defaultAspect>displayWidth then newHeight=displayWidth/defaultAspect end
			end
			if newWidth~=mapWindow.OldWidth then
				if debug then
					Turbine.Shell.WriteLine("enforcing aspect height");
				end
				newHeight=newWidth/defaultAspect
			else
				if debug then
					Turbine.Shell.WriteLine("enforcing aspect width");
				end
				newWidth=newHeight*defaultAspect
			end
			mapWindow.OldWidth=mapWindow:GetWidth()
			mapWindow.OldHeight=mapWindow:GetHeight()
		end
	end

	if newWidth~=width or newHeight~=height then
		if debug then
			Turbine.Shell.WriteLine("newWidth:"..tostring(newWidth).." newHeight:"..tostring(newHeight));
		end
		Turbine.UI.Window.SetSize(mapWindow,newWidth,newHeight);
		width=newWidth
		height=newHeight
	end

	mapWindow.MovingIcon:SetPosition(width-21,height-21);
	mapWindow.SearchPanel:SetLeft(width-400);
	mapWindow.SearchPanel:SetHeight(height-50)
	mapWindow.FilterPanel:SetHeight(height-50);
	mapWindow.FilterPanel.ViewPane:SetHeight(mapWindow.FilterPanel:GetHeight()-mapWindow.FilterPanel.Separator1:GetTop()-3);
	mapWindow.FilterPanel.VScroll:SetMaximum(mapWindow.FilterPanel.ScrollPanel:GetHeight()-mapWindow.FilterPanel.ViewPane:GetHeight());
	mapWindow.FilterPanel.VScroll:SetHeight(mapWindow.FilterPanel.ViewPane:GetHeight());
	mapWindow.FilterPanel.VScroll:SetVisible(mapWindow.FilterPanel.ViewPane:GetHeight()<mapWindow.FilterPanel.ScrollPanel:GetHeight());
	mapWindow.ControlPanel:SetWidth(width);
	mapWindow.Map.IconList:SetHeight(mapWindow.SearchPanel:GetHeight()-46);
	mapWindow.Map.IconList.VScroll:SetHeight(mapWindow.Map.IconList:GetHeight());

	mapWindow.CloseButton:SetLeft(width-20);
	if mapWindow.Map ~=nil then
		mapWindow.Map:SetSize(width,height);
	end
	if mapWindow.LocationIcon~=nil then
		mapWindow.LocationIcon:SetPosition(mapWindow.LocationIcon.X*width/mapInfo[mapWindow.CurrentMapID][4]-14,mapWindow.LocationIcon.Y*height/mapInfo[mapWindow.CurrentMapID][5]-14)
	end

	if width<mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth()+mapWindow.OverlaySelect:GetWidth() then
		mapWindow.OverlaySelect:SetPosition(mapWindow.ControlPanel:GetLeft(),mapWindow.ControlPanel:GetTop()+mapWindow.ControlPanel:GetHeight()+2)
	else
		mapWindow.OverlaySelect:SetPosition(mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth(),mapWindow.MapSelect:GetTop())
	end
	-- need to resize overlays to map ACTUAL size, the client will then scale it to fit it's parent
	for k,v in ipairs(mapWindow.Map.Overlays) do
		v:SetSize(mapInfo[mapWindow.CurrentMapID][4],mapInfo[mapWindow.CurrentMapID][5]);
	end
if debug then Turbine.Shell.WriteLine("done with size change") end
end

mapWindow.MouseDown=function(sender,args)
	if (args.Y>mapWindow:GetHeight()-15) and (args.X>mapWindow:GetWidth()-15) then
		mapWindow.MoveX=args.X;
		mapWindow.MoveY=args.Y;
		mapWindow.MovingIcon:SetLeft(args.X-12);
		mapWindow.MovingIcon:SetTop(args.Y-12);
		mapWindow.MovingIcon:SetBackground(0x41007e20)
		mapWindow.MovingIcon:SetVisible(true);
	elseif (args.Y>mapWindow:GetHeight()-12) then
		mapWindow.MoveY=args.Y;
		mapWindow.MovingIcon:SetLeft(args.X-22);
		mapWindow.MovingIcon:SetTop(args.Y-12);
		mapWindow.MovingIcon:SetBackground(0x410081c0)
		mapWindow.MovingIcon:SetVisible(true);
	elseif (args.X>mapWindow:GetWidth()-12) then
		mapWindow.MoveX=args.X;
		mapWindow.MovingIcon:SetLeft(args.X-12);
		mapWindow.MovingIcon:SetTop(args.Y-22);
		mapWindow.MovingIcon:SetBackground(0x410081bf)
		mapWindow.MovingIcon:SetVisible(true);
	elseif (args.Y<15) then
		mapWindow.MoveX=args.X;
		mapWindow.MoveY=args.Y;
		mapWindow.MovingIcon:SetLeft(args.X-12);
		mapWindow.MovingIcon:SetTop(args.Y-12);
		mapWindow.MovingIcon:SetSize(32,32);
		mapWindow.MovingIcon:SetBackground(0x410000dd)
		mapWindow.MovingIcon:SetVisible(true);
	else
		mapWindow.MoveX=-1;
		mapWindow.MoveY=-1;
	end
	if mapWindow.PopUp~=nil then
		mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
		mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
		mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
		mapWindow.PopUp:SetVisible(false);
		mapWindow.PopUp=nil; -- dismiss the dialog
	end
end
mapWindow.MouseEnter=function()
	mapWindow.OverlaySelect:SetHeight(20);
	mapWindow.OverlaySelect:SetVerticalScrollBar(nil);
	mapWindow.OverlayVScroll:SetParent(nil);
	mapWindow.OverlayVScroll:SetVisible(false);
	mapWindow.OverlaySelect:SetSelectedIndex(1);
	mapWindow.OverlaySelect:SetBackColor(nil);
end

mapWindow.MouseMove=function(sender,args)
	if (mapWindow.MoveY>-1 and mapWindow.MoveY<15) then
		if (args.X~=mapWindow.MoveX or args.Y~= mapWindow.MoveY) then
			mapWindow.Moving=true;
			local newLeft=mapWindow:GetLeft()-(mapWindow.MoveX-args.X)
			local newTop=mapWindow:GetTop()-(mapWindow.MoveY-args.Y)
			if newLeft<0-mapWindow:GetWidth()+32 then newLeft=0-mapWindow:GetWidth()+32 end;
--			if newLeft>(displayWidth-mapWindow:GetWidth()) then newLeft=displayWidth-mapWindow:GetWidth() end;
			if newLeft>(displayWidth-10) then newLeft=displayWidth-10 end;
			if newTop<0 then newTop=0 end;
--			if newTop>(displayHeight-mapWindow:GetHeight()) then newTop=displayHeight-mapWindow:GetHeight() end;
			if newTop>(displayHeight-10) then newTop=displayHeight-10 end;
			mapWindow:SetPosition(newLeft,newTop);
			optionsCanvas.MapLeftValue:SetText(tostring(mapWindow:GetLeft()))
			optionsCanvas.MapTopValue:SetText(tostring(mapWindow:GetTop()))
		end
	else		
		if (mapWindow.MoveY>-1) then
			if args.Y~= mapWindow.MoveY then
				mapWindow.Resizing=true;
				local newHeight=mapWindow:GetHeight()-(mapWindow.MoveY-args.Y);
--				if newHeight<215 then newHeight=215 end;
				if newHeight<mapWindow.GetMinimumHeight() then newHeight=mapWindow.GetMinimumHeight() end;
				if newHeight>(displayHeight-mapWindow:GetTop()) then newHeight=displayHeight-mapWindow:GetTop() end;
				local newX=args.X-22;
				if newX<-13 then newX=-13 end
				if newX>(mapWindow:GetWidth()-18) then newX=mapWindow:GetWidth()-18 end
				mapWindow.MovingIcon:SetLeft(newX);
				mapWindow:SetHeight(newHeight);
				mapWindow.MoveY=args.Y;
				optionsCanvas.MapHeightValue:SetText(tostring(mapWindow:GetHeight()))
			end
		end
		if (mapWindow.MoveX>-1) then
			if args.X~= mapWindow.MoveX then
				mapWindow.Resizing=true;
				local newWidth=mapWindow:GetWidth()-(mapWindow.MoveX-args.X);
--				if newWidth<414 then newWidth=414 end;
				if newWidth<mapWindow.GetMinimumWidth() then newWidth=mapWindow.GetMinimumWidth() end;
				if newWidth>(displayWidth-mapWindow:GetLeft()) then newWidth=displayWidth-mapWindow:GetLeft() end;
				local newY=args.Y-22;
				if newY<-13 then newY=-13 end
				if newY>(mapWindow:GetHeight()-18) then newY=mapWindow:GetHeight()-18 end
				mapWindow.MovingIcon:SetTop(newY);
if debug then
Turbine.Shell.WriteLine("SetWidth:newWidth:"..tostring(newWidth))
end
				mapWindow:SetWidth(newWidth);
				mapWindow.MoveX=args.X;
				optionsCanvas.MapWidthValue:SetText(tostring(mapWindow:GetWidth()))
			end
		end
	end
	if not mapWindow.Moving and not mapWindow.Resizing then
		-- update location display
		if mapWindow.CurrentMapID==nil then
			if debug then
				Turbine.Shell.WriteLine("CurrentMapID is NULL in mapWindow.MouseMove()!");
			end
		else
			if mapInfo[mapWindow.CurrentMapID]==nil then
				if debug then
					Turbine.Shell.WriteLine("CurrentMapID="..tostring(mapWindow.CurrentMapID).." but mapInfo[mapWindow.CurrentMapID] is NULL in .MouseMove()!");
				end
			else
				if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
					--looks like we need to scale here
					local XScale=mapInfo[mapWindow.CurrentMapID][4]/mapWindow:GetWidth();
					local YScale=mapInfo[mapWindow.CurrentMapID][5]/mapWindow:GetHeight();
					local EW;
					local NS;
						if debug then
						EW=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*100)/100;
						NS=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*100)/100;
					else
						EW=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
						NS=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
					end
					if EW<0 then
						mapWindow.EWCoord:SetText(tostring(0-EW)..Resource[Settings.language][153]);
					else
						mapWindow.EWCoord:SetText(tostring(EW)..Resource[Settings.language][152]);
					end
					if NS<0 then
						mapWindow.NSCoord:SetText(tostring(0-NS)..Resource[Settings.language][151]);
					else
						mapWindow.NSCoord:SetText(tostring(NS)..Resource[Settings.language][150]);
					end
					mapWindow.XCoord:SetText(tostring(args.X))
					mapWindow.YCoord:SetText(tostring(args.Y))
				end
			end
		end
	end
end

mapWindow.MouseUp=function(sender,args)
	mapWindow.MovingIcon:SetVisible(false);
	mapWindow.MoveX=-1;
	mapWindow.MoveY=-1;
	mapWindow.Moving=false;
	mapWindow.Resizing=false;
end
mapWindow.MouseDoubleClick=function(sender,args)
	if not mapWindow.Moving and not mapWindow.Resizing and args.Button==1 and mapWindow.CurrentMapID~=nil and mapWindow.CurrentMapID~=2 then
		-- user double clicked on map, go straight to "Add Annotation"
		local XScale=mapInfo[mapWindow.CurrentMapID][4]/mapWindow:GetWidth();
		local YScale=mapInfo[mapWindow.CurrentMapID][5]/mapWindow:GetHeight();
		local NSCoord=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
		local EWCoord=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
		if EWCoord<0 then
			annotWindow.EWCoordText:SetText(tostring(0-EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(2)
		else
			annotWindow.EWCoordText:SetText(tostring(EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(1)
		end
		if NSCoord<0 then
			annotWindow.NSCoordText:SetText(tostring(0-NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(2)
		else
			annotWindow.NSCoordText:SetText(tostring(NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(1)
		end
		annotWindow.AnnotationList:SetSelectedIndex(1);
		annotWindow:EditAnnotation(0);
		annotWindow.TypeList:SetSelectedIndex(1);
		annotWindow.NameText:SetText("");
		annotWindow.DescriptionText:SetText("");
		annotWindow:SetVisible(true);
	end
end
mapWindow.MouseClick=function(sender,args)
	mapWindow.SearchPanel:SetVisible(false);
	mapWindow.FilterPanel:SetVisible(false);
	mapWindow.Map.IconSearch:SetWantsUpdates(false);
	if not mapWindow.Moving and not mapWindow.Resizing then
		if args.Button==1 then
			-- user left clicked on map, popup the "Add Annotation" option
			local XScale=mapInfo[mapWindow.CurrentMapID][4]/mapWindow:GetWidth();
			local YScale=mapInfo[mapWindow.CurrentMapID][5]/mapWindow:GetHeight();
			local NSCoord=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
			local EWCoord=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
			mapWindow.mouseNS=NSCoord
			mapWindow.mouseEW=EWCoord
			if EWCoord<0 then
				annotWindow.EWCoordText:SetText(tostring(0-EWCoord));
				annotWindow.EWButtons:SetSelectedChoice(2)
			else
				annotWindow.EWCoordText:SetText(tostring(EWCoord));
				annotWindow.EWButtons:SetSelectedChoice(1)
			end
			if NSCoord<0 then
				annotWindow.NSCoordText:SetText(tostring(0-NSCoord));
				annotWindow.NSButtons:SetSelectedChoice(2)
			else
				annotWindow.NSCoordText:SetText(tostring(NSCoord));
				annotWindow.NSButtons:SetSelectedChoice(1)
			end
			mapWindow.AddAnnotationMenu:ShowMenu();
		else
			-- right click, zoom out if possible
			if mapWindow.CurrentMapID~=nil and mapWindow.CurrentMapID~=2 then
				RefreshMap(mapInfo[mapWindow.CurrentMapID][10]);
			end
		end
	end
end
mapWindow.flashIndex=1;
mapWindow.flashTime=Turbine.Engine:GetGameTime()+.2;
-- set ZOrder so that the drop downs can cover other items, etc
mapWindow.Map:SetZOrder(1);
mapWindow.ControlPanel:SetZOrder(2);
if mapWindow.ControlPanel.OptionsButton~=nil then
	mapWindow.ControlPanel.OptionsButton:SetZOrder(5);
end
mapWindow.ControlPanel.AnnotationsButton:SetZOrder(7);
mapWindow.SearchButton:SetZOrder(8);
mapWindow.SearchButton2:SetZOrder(8);
if mapWindow.LocationButton ~=nil then
	mapWindow.LocationContainer:SetZOrder(9);
	mapWindow.LocationButton:SetZOrder(10);
end
mapWindow.FilterButton:SetZOrder(12);
mapWindow.MovingIcon:SetZOrder(15);
mapWindow.NSCoord:SetZOrder(17);
mapWindow.EWCoord:SetZOrder(20);
mapWindow.MapSelect:SetZOrder(23);
mapWindow.OverlaySelect:SetZOrder(23);
mapWindow.OverlayVScroll:SetZOrder(23);
mapWindow.CloseButton:SetZOrder(23);
mapWindow.SearchPanel:SetZOrder(mapWindow.Map:GetZOrder()+1);
mapWindow.FilterPanel:SetZOrder(mapWindow.Map:GetZOrder()+1);
mapWindow.FilterPanel.VScroll:SetZOrder(mapWindow.Map:GetZOrder()+1);

mapWindow:SetWantsKeyEvents(true);
mapWindow:SetWantsUpdates(true)

mapWindow.RemoveShellCommands=function(sender,args)
	Turbine.Shell.RemoveCommand(mapWindow.shellCmd)
end

mapWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand("MoorMap",mapWindow.shellCmd);

mapWindow.shellCmd.Execute = function(sender, cmd, args)
	if debug then
		Turbine.Shell.WriteLine("cmd:"..tostring(cmd).." args:"..tostring(args))
	end
	if (string.lower(cmd) == "moormap") then
		local pos1=string.find(args," ",0,true);
		local command;
		if pos1~=nil and pos1>0 then
			command=string.lower(string.sub(args,1,pos1-1));
		else
			command=string.lower(args);
		end
		if (command=="show") then
			minWindow:SetVisible(false);
			quickWindow:SetVisible(quickWindow.Displayed);
			mapWindow:SetVisible(true);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(BDDVis)
			end
		elseif (command=="hide") then
			mapWindow:SetVisible(false);
			minWindow:SetVisible(true);
			quickWindow:SetVisible(quickWindow.Displayed);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(false)
			end
		elseif (command=="toggle") then
			mapWindow:SetVisible(not mapWindow:IsVisible());
			minWindow:SetVisible(not mapWindow:IsVisible());
			quickWindow:SetVisible(quickWindow.Displayed);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(BDDVis and mapWindow:IsVisible())
			end

		elseif (command=="debug") then
			if string.lower(args)=="debug on" then
				debug=true;
				debugWindow:SetVisible(true);
			elseif string.lower(args)=="debug off" then
				debug=false;
				debugWindow:SetVisible(false);
			elseif string.lower(args)=="debug toggle" then
				debug=not debug;
				debugWindow:SetVisible(debug);
			else
				Turbine.Shell.WriteLine("debug is currently "..tostring(debug));
			end
		elseif (command=="adm") then
			if defAnnWindow==nil then
				import (importPath.."DefaultAnnotationMaker");
			end
			defAnnWindow:SetVisible(true);
		elseif pos1~=nil and pos1>0 and command=="target" and defAnnWindow~=nil and defAnnWindow.EWButtons~=nil then
			-- command used with annotation capture tool
			-- args are"region: area: NSCoord, EWCoord:Target"
			-- where "region: area: NSCoord, EWCoord" is generated by ;loc
			-- -- region Eregion=region1, Rhovanion=region2
			-- "Target" any non blank value other than ";target" is valid
			-- split up the args following "target"
			local argArray=string.split(string.sub(args,pos1+1),":");
			local region;
			local NSCoord;
			local EWCoord;
			local iconType=5;
			local target=";target";
			local tier=0;
			if argArray[1]~=nil then
				if string.lower(argArray[1])=="eriador" then
					region=1;
				elseif string.lower(argArray[1])=="rhovanion" then
					region=2;
				elseif string.lower(argArray[1])=="gondor" then
					region=3;
				elseif string.lower(argArray[1])=="mordor" then
					region=4;
				end
			end
			if region==nil then
				Turbine.Shell.WriteLine(Resource[1][165].." \""..argArray[1].."\". "..Resource[1][164]);
			else
				if argArray[3]~=nil then
					NSCoord=string.lower(string.trim(string.gsub(argArray[3], "^(.-),(.*)","%1")));
					EWCoord=string.lower(string.trim(string.gsub(argArray[3], "(.*),(.-)$", "%2")));
					if argArray[4]~=nil then
						target=string.trim(argArray[4]);
					end
					-- if target~=nil, look it up in nodeTier[#nodeTier+1] to see if we get a match on a crafting node
					if target~=nil then
						local tmpIndex;
						for tmpIndex=1,#nodeTier do
							if nodeTier[tmpIndex][1]==target then
								iconType=nodeTier[tmpIndex][2];
								tier=nodeTier[tmpIndex][3];
								break;
							end
						end
					end

					if string.sub(NSCoord,-1)=="n" then
						NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
					elseif string.sub(NSCoord,-1)=="s" then
						NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
					else
						NSCoord=nil;
					end
					if locale == "en" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					elseif locale == "fr" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="o" or string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					else
						if string.sub(EWCoord,-1)=="o" or string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					end

					if NSCoord~=nil and EWCoord~=nil then
						NSCoord=euroNormalize(NSCoord)
						EWCoord=euroNormalize(EWCoord)
					end
				end

				if NSCoord==nil or EWCoord==nil then
					Turbine.Shell.WriteLine(Resource[1][167].." \""..argArray[3].."\". "..Resource[1][164]);
				else
					if iconType==nil then
						Turbine.Shell.WriteLine(Resource[1][168].." \""..argArray[4].."\". "..Resource[1][164]);
					else
						if target==";target" then
							Turbine.Shell.WriteLine(Resource[1][169]..Resource[1][164]);
						else
							-- now send all of the data to the DefaultAnnotationMaker dialog
							defAnnWindow:SetTargetInfo(NSCoord,EWCoord,iconType,tier,target);
						end
					end
				end
			end

		elseif pos1~=nil and pos1>0 and command=="add" then
			-- args are"region: area: NSCoord, EWCoord:IconType:Language:Target"
			-- where "region: area: NSCoord, EWCoord" is generated by ;loc
			-- area and language are not currently used
			-- -- region Eriador=1, Rhovanion=2, Gondor=3, Mordor=4
			-- "IconType" is one of the predefined icon values, 5=POI, 11=NPC, 43=Ore Node, 44=Wood Node, 45=Scholar Node, 55=CPOI : null default=55
			-- "Language" is no longer used and can be null
			-- "Target" any non blank value other than ";target" is valid
			-- split up the args following "add"
			local argArray=string.split(string.sub(args,pos1+1),":");
			local region;
			local NSCoord;
			local EWCoord;
			local iconType=55;
			local lang="EN";
			local target=";target";
			local tier=0;
			if argArray[1]~=nil then
				if string.lower(argArray[1])=="eriador" then
					region=1;
				elseif string.lower(argArray[1])=="rhovanion" then
					region=2;
				elseif string.lower(argArray[1])=="gondor" then
					region=3;
				elseif string.lower(argArray[1])=="mordor" then
					region=4;
				end
			end
			if region==nil then
				Turbine.Shell.WriteLine(Resource[Settings.language][165].." \""..argArray[1].."\". "..Resource[Settings.language][164]);
			else
				if argArray[3]~=nil then
					NSCoord=string.lower(string.trim(string.gsub(argArray[3], "^(.-),(.*)","%1")));
					EWCoord=string.lower(string.trim(string.gsub(argArray[3], "(.*),(.-)$", "%2")));
					if argArray[4]~=nil and argArray[4]~="" then
						iconType=tonumber(argArray[4]);
					end
					if argArray[5]~=nil and argArray[5]~="" then
						lang=string.trim(argArray[5]);
					end
					if argArray[6]~=nil then
						target=string.trim(argArray[6]);
					end
					-- if target~=nil, look it up in nodeTier[#nodeTier+1] to see if we get a match on a crafting node
					if target~=nil then
						local tmpIndex;
						for tmpIndex=1,#nodeTier do
							if nodeTier[tmpIndex][1]==target and nodeTier[tmpIndex][4]==0 then
								iconType=nodeTier[tmpIndex][2];
								tier=nodeTier[tmpIndex][3];
								break;
							end
						end
					end
					if debug then
						Turbine.Shell.WriteLine("locale="..tostring(locale))
						Turbine.Shell.WriteLine("NSCoord:"..tostring(NSCoord)..", EWCoord:"..tostring(EWCoord))
					end

					if string.sub(NSCoord,-1)=="n" then
						NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
					elseif string.sub(NSCoord,-1)=="s" then
						NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
					else
						if tonumber(NSCoord)==nil then NSCoord=nil end
					end

					if locale=="en" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							-- assume EWCoord was give as a +/- number
							if tonumber(EWCoord)==nil then EWCord=nil end
						end
					elseif locale=="fr" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="o" or string.sub(EWCoord,-1)=="w" then
							-- SSG seems to have converted coordinates to english abbreviations at some point
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							if tonumber(EWCoord)==nil then EWCoord=nil end
						end
					elseif locale=="de" then
						if string.sub(EWCoord,-1)=="o" or string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							if tonumber(EWCoord)==nil then EWCoord=nil end
						end
					else
						EWCoord=nil;
					end
					if NSCoord~=nil and EWCoord~=nil then
						NSCoord=euroNormalize(NSCoord)
						EWCoord=euroNormalize(EWCoord)
					end
					if debug then
						Turbine.Shell.WriteLine("NSCoord:"..tostring(NSCoord))
						Turbine.Shell.WriteLine("EWCoord:"..tostring(EWCoord))
					end
				end
				if NSCoord==nil or EWCoord==nil then
					Turbine.Shell.WriteLine(Resource[Settings.language][167].." \""..argArray[3].."\". "..Resource[Settings.language][164]);
				else
					if iconType==nil then
						Turbine.Shell.WriteLine(Resource[Settings.language][168].." \""..argArray[4].."\". "..Resource[Settings.language][164]);
					else
						if target==";target" then
							Turbine.Shell.WriteLine(Resource[Settings.language][169]..Resource[Settings.language][164]);
						else
							-- ok. we have proof of concept. now we just need to resolve the correct map and then follow the same routine as the "ping" function below without "ExternalPing=true"
							if debug then
								Turbine.Shell.WriteLine("add annotation:"..target.." ("..tostring(iconType)..") at:");
								Turbine.Shell.WriteLine("region:"..region.." NS:"..NSCoord.." EW:"..EWCoord);
								Turbine.Shell.WriteLine("tier:"..tostring(tier));
							end
							local mapList=ResolveMap(region,NSCoord,EWCoord);
							if mapList==nil or #mapList==0 then
								Turbine.Shell.WriteLine(Resource[Settings.language][170]..Resource[Settings.language][164]);
							else
								local tmpIndex;
								local dupIndex;
								local dupFound;
								NSCoord=tonumber(NSCoord);
								EWCoord=tonumber(EWCoord);
								for tmpIndex=1,#mapList do
								-- check for preexisting duplicate at same map, same name, same coordinates
									dupFound=false;
									for dupIndex=1,#annotations do
										if annotations[dupIndex][1]==mapList[tmpIndex] and annotations[dupIndex][2]==NSCoord and annotations[dupIndex][3]==EWCoord and annotations[dupIndex][7]==target..": "..target then
											dupFound=true;
											break;
										end
									end
									if dupFound then
										Turbine.Shell.WriteLine(target..Resource[Settings.language][171]..tostring(Resource[Settings.language][mapInfo[mapList[tmpIndex]][2]])..".");
									else

										table.insert(annotations,{mapList[tmpIndex],NSCoord,EWCoord,iconType,0,nil,target..": "..target,tier,0,0,0});
										Turbine.Shell.WriteLine(target..Resource[Settings.language][172]..tostring(Resource[Settings.language][mapInfo[mapList[tmpIndex]][2]]));
										-- now add to TerrainMap data file via MMCust - note, duplicates will automatically be skipped in MMCust
										local hvxy=GetHVXYfromNSEW(region,NSCoord,EWCoord)
										local row=math.floor((hvxy.V-1)/4)*4+1
										local col=math.floor((hvxy.H-1)/4)*4+1
										local cmdStr="0MMCD_S_"..tostring(region).."_"..tostring(hvxy.H).."_"..tostring(hvxy.V).."_"..tostring(hvxy.X).."_"..tostring(hvxy.Y).."_"..tostring(iconType).."_"..string.encode(target).."_"..string.encode(target)
										local tmpCmd=Turbine.ShellCommand()
										Turbine.Shell.AddCommand(cmdStr,tmpCmd)
										table.insert(quickWindow.cmdList,tmpCmd)
										quickWindow:SetWantsUpdates(true)
										Turbine.PluginManager.LoadPlugin("MMCust")
									end
								end
								annotWindow.LoadAnnotationList(); -- refresh the maintenance window in case we modified an annotation on the current map
								mapWindow.NeedsRefresh=true;
								mapWindow:SetWantsUpdates(true);
							end
						end
					end
				end
			end
		elseif pos1~=nil and pos1>0 and (command=="ping" or command=="ping_r") then
			-- ping MapID:NSCoord:EWCoord:Name:Description
			-- split up the args following "ping"  
			local argArray=string.split(string.sub(args,pos1+1),":");
			if argArray[2]~=nil then
				argArray[2]=euroNormalize(argArray[2]);
			end
			if argArray[3]~=nil then
				argArray[3]=euroNormalize(argArray[3]);
			end
			if command=="ping_r" then
				-- argArray[1] is a region, not a map - resolve map from region
				local possibleMaps=ResolveMap(argArray[1],argArray[2],argArray[3],true)
				if possibleMaps==nil or possibleMaps[1]==nil then
					argArray[1]=nil
				else
					argArray[1]=possibleMaps[1]
				end
			end
if debug then
	Turbine.Shell.WriteLine("mapID:("..tostring(argArray[1]).."). ");
end
			if tonumber(argArray[1])==nil then
				Turbine.Shell.WriteLine(Resource[Settings.language][174]..tostring(argArray[1]).."). "..Resource[Settings.language][173]);
			elseif tonumber(argArray[2])==nil then
				Turbine.Shell.WriteLine(Resource[Settings.language][175]..tostring(argArray[2]).."). "..Resource[Settings.language][173]);
			elseif tonumber(argArray[3])==nil then
				Turbine.Shell.WriteLine(Resource[Settings.language][176]..tostring(argArray[3]).."). "..Resource[Settings.language][173]);
			elseif argArray[4]==nil then
				Turbine.Shell.WriteLine(Resource[Settings.language][177]..Resource[Settings.language][173]);
			elseif argArray[5]==nil then
				Turbine.Shell.WriteLine(Resource[Settings.language][178]..Resource[Settings.language][173]);
			else
				argArray[1]=math.floor(tonumber(argArray[1]));
				argArray[2]=tonumber(argArray[2]);
				argArray[3]=tonumber(argArray[3]);
				if argArray[1]>0 and argArray[1]<=#mapInfo then
					-- calculate x,y coordinates and verify they fall on the target map
					local X=math.floor(argArray[3]*mapInfo[argArray[1]][6]+mapInfo[argArray[1]][7]);
					local Y=math.floor(argArray[2]*mapInfo[argArray[1]][8]+mapInfo[argArray[1]][9]);
					if X<0 or X>mapInfo[argArray[1]][4] then
						Turbine.Shell.WriteLine(Resource[Settings.language][180]..tostring(argArray[3]).."). "..Resource[Settings.language][173]);
					elseif Y<0 or Y>mapInfo[argArray[1]][5] then
						Turbine.Shell.WriteLine(Resource[Settings.language][181]..tostring(argArray[2]).."). "..Resource[Settings.language][173]);
					else
if debug then
	Turbine.Shell.WriteLine("External Ping:")
	Table.Dump(argArray)
end
						if argArray[1]==mapWindow.CurrentMapID then
							if argArray[4]==nil or argArray[4]=="" then
								-- just activate a "ping" for it
								mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
								mapWindow.Map.Ping:SetPosition(math.floor((argArray[3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((argArray[2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
								mapWindow.Map.Ping.State=1;
								mapWindow.Map.Ping:SetVisible(true);
								mapWindow.Map.Ping:SetWantsUpdates(true);
								-- make sure map is visible
								minWindow:SetVisible(false);
								quickWindow:SetVisible(quickWindow.Displayed);
								mapWindow:SetVisible(true);
								if BDDLegend~=nil then
									BDDLegend:SetVisible(BDDVis)
								end
							else
								AddPing(argArray[2],argArray[3],argArray[4],argArray[5]);
							end
						else

							Settings.pingNS=argArray[2];
							Settings.pingEW=argArray[3];
							Settings.pingName=argArray[4];
							Settings.pingDesc=argArray[5];
							Settings.ExternalPing=true;
							mapWindow.PreserveMapID=true;
							RefreshMap(argArray[1]);
						end
					end
				else
					-- invalid map specified
					Turbine.Shell.WriteLine(Resource[Settings.language][179]..Resource[Settings.language][173]);
				end
			end
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /MoorMap show");
			Turbine.Shell.WriteLine("       Displays the MoorMap map.");
			Turbine.Shell.WriteLine("  /MoorMap hide");
			Turbine.Shell.WriteLine("       Hides the MoorMap map.");
			Turbine.Shell.WriteLine("  /MoorMap toggle");
			Turbine.Shell.WriteLine("       Toggles the MoorMap map (shows it if it was hidden, hides it if it was showing).");
			Turbine.Shell.WriteLine("  /MoorMap add Region: Area: NSCoord, EWCoord:Icon Type:Language:Name:Description");
			Turbine.Shell.WriteLine("       Adds a new custom annotation to MoorMap at the given coordinates - note, the annotation will be added to all maps BELOW regional maps that match the region/ns/ew coordinates based on the provided mapID. To add an annotation at the regional level the regional map must be the specified mapID. (to avoid clutter, custom annotations are not normally added to the regional maps)");
			Turbine.Shell.WriteLine("       This command enables external applications to add permanent custom annotations to MoorMap. Unlike pings, these annotations will persist when the map changes. For more details on how to implement this, please");
			Turbine.Shell.WriteLine("       view the Readme.txt file that was in the original zip file and should now be located in your Plugins\GaranStuff\MoorMap folder.");
			Turbine.Shell.WriteLine("  /MoorMap ping MapID:NSCoord:EWCoord:Name:Description");
			Turbine.Shell.WriteLine("       Locates the named temporary annotation on the indicated map and if it doesn't exist adds it then opens that map and puts a flashing Ping at the location.");
			Turbine.Shell.WriteLine("       This command enables external applications indicate locations on the map. Note, the annotations added this way are temporary and will only persist until the user changes maps or unloads the plugin. For more details on how to implement this, please");
			Turbine.Shell.WriteLine("       view the Readme.txt file that was in the original zip file and should now be located in your Plugins\GaranStuff\MoorMap folder.");
			Turbine.Shell.WriteLine("  /MoorMap ping_r Region:NSCoord:EWCoord:Name:Description");
			Turbine.Shell.WriteLine("       Locates the named temporary annotation using the Region and NS/EW coordinates to determine the 'best fit' map and if it doesn't exist adds it (temporarilly) then opens that map and puts a flashing Ping at the location.");
			Turbine.Shell.WriteLine("       This command enables external applications indicate locations on the map. Note, the annotations added this way are temporary and will only persist until the user changes maps or unloads the plugin. For more details on how to implement this, please");
			Turbine.Shell.WriteLine("       view the Readme.txt file that was in the original zip file and should now be located in your Plugins\GaranStuff\MoorMap folder.");
		end
	end
end
mapWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /MoorMap show\n       Displays the MoorMap map.\n  /MoorMap hide\n       Hides the MoorMap map.\n  /MoorMap toggle\n       Toggles the MoorMap map (shows it if it was hidden, hides it if it was showing).\n  /MoorMap add annotation_data\n       Adds a custom annotation (see readme.txt).\n  /MoorMap ping ping_data\n       Adds a ping by specific map coords (see readme.txt).\n  /MoorMap ping_r ping_data\n       Adds a ping by region and NS/EW coordinates (see readme.txt).");
end

mapWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return("MoorMap - usage: /MoorMap show | hide | toggle | add annotation_data | ping ping_data | ping_r ping_data | ");
end
mapWindow.Closing=function()
end

mapWindow.SetTrimColor=function()
end
mapWindow.SetBackColor=function()
	mapWindow.NSCoord:SetBackColor(Settings.backColor);
	mapWindow.EWCoord:SetBackColor(Settings.backColor);
end
mapWindow.SetListTextColor=function()
	mapWindow.MapSelect:SetTextColor(Settings.listTextColor);
	mapWindow.FilterPanel.TypeOreNodeTier:SetTextColor(Settings.listTextColor);
	mapWindow.FilterPanel.TypeWoodNodeTier:SetTextColor(Settings.listTextColor);
	mapWindow.FilterPanel.TypeScholarNodeTier:SetTextColor(Settings.listTextColor);
end
mapWindow.SetFontColor=function()
	mapWindow.NSCoord:SetForeColor(Settings.fontColor);
	mapWindow.EWCoord:SetForeColor(Settings.fontColor);
end
mapWindow.SetHeadingsColor=function()
end
mapWindow.SetLanguage=function()
	if mapStrings[Settings.language]==nil or type(mapStrings[Settings.language])~="table" then
		mapStrings[Settings.language]={};
	end
	mapWindow:SetText(Resource[Settings.language][2]);
	mapWindow.AddAnnotationMenu:GetItems():Get(1):SetText(Resource[Settings.language][82]);
	-- quickWindow.Quickslot:SetVisible(true);

	mapWindow.FilterPanel.Title:SetText(Resource[Settings.language][66]);
	mapWindow.FilterPanel.AllegianceCaption:SetText(Resource[Settings.language][67]..":");
	mapWindow.FilterPanel.AllegianceCreep:SetText(Resource[Settings.language][68]);
	mapWindow.FilterPanel.AllegianceFreep:SetText(Resource[Settings.language][69]);
	mapWindow.FilterPanel.AllegianceDelving:SetText(Resource[Settings.language][70]);
	mapWindow.FilterPanel.TypeCaption:SetText(Resource[Settings.language][74]..":");
	for k,v in pairs(mapWindow.FilterPanel.Filters) do
		v.CB:SetText(Resource[Settings.language][iconInfo[v.iconIndex][1]])
	end

	mapWindow.Map.SearchFilterCaption:SetText(Resource[Settings.language][65]..":");
	mapWindow.Map.IconCreepCB:SetText(Resource[Settings.language][68]);
	mapWindow.Map.IconFreepCB:SetText(Resource[Settings.language][69]);
	mapWindow.Map.IconDelvingCB:SetText(Resource[Settings.language][70]);
	mapWindow.FilterPanel.SelectAllButton:SetText(Resource[Settings.language][348]);
	mapWindow.FilterPanel.ClearAllButton:SetText(Resource[Settings.language][349]);
	mapWindow.FilterPanel.SetDefaultButton:SetText(Resource[Settings.language][350]);
	mapWindow.FilterPanel.SaveDefaultButton:SetText(Resource[Settings.language][351]);

	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(1):SetText(Resource[Settings.language][158]);
	for k=2,mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItemCount() do
		mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(k):SetText(Resource[Settings.language][159].." "..tostring(k-1));
	end
	-- reselect the selected entry to get the correct text to show
	mapWindow.FilterPanel.TypeOreNodeTier.ListData.SelectedIndexChanged()
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(1):SetText(Resource[Settings.language][158]);
	for k=2,mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItemCount() do
		mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(k):SetText(Resource[Settings.language][159].." "..tostring(k-1));
	end
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData.SelectedIndexChanged()
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(1):SetText(Resource[Settings.language][158]);
	for k=2,mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItemCount() do
		mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(k):SetText(Resource[Settings.language][159].." "..tostring(k-1));
	end
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData.SelectedIndexChanged()
	breadcrumbWindow:SetText(Resource[Settings.language][238]);
	breadcrumbWindow.ColorLabel:SetText(Resource[Settings.language][239]..":");

	local tmpMap=mapInfo[mapWindow.CurrentMapID][3]
	if Settings.language==2 and mapInfo[mapWindow.CurrentMapID][19]~=nil then
		tmpMap=mapInfo[mapWindow.CurrentMapID][19]
	elseif Settings.language==3 and mapInfo[mapWindow.CurrentMapID][18] ~= nil then
		tmpMap=mapInfo[mapWindow.CurrentMapID][18]
	elseif Settings.language==4 and mapInfo[mapWindow.CurrentMapID][20] ~= nil then
		tmpMap=mapInfo[mapWindow.CurrentMapID][20]
	end
	pcall(Turbine.UI.Control.SetBackground,mapWindow.Map,tmpMap);
	RefreshMap();
end
if debug then
	Turbine.Shell.WriteLine("in constructor, just prior to setting size mapWindow.CurrentMapID="..tostring(mapWindow.CurrentMapID))
end
if mapWindow.CurrentMapID==nil or mapInfo[mapWindow.CurrentMapID]==nil then
	-- this should never happen unless there was an error, such as the client crashed prior to an update or other unlikely and invalid condition
	mapWindow.CurrentMapID=1;
end
if debug then
Turbine.Shell.WriteLine("map size:"..tostring(mapInfo[mapWindow.CurrentMapID][4]).."x"..mapInfo[mapWindow.CurrentMapID][5]);
end
mapWindow.Map:SetSize(mapInfo[mapWindow.CurrentMapID][4],mapInfo[mapWindow.CurrentMapID][5]);
local tmpMap=mapInfo[mapWindow.CurrentMapID][3]
if Settings.language==2 and mapInfo[mapWindow.CurrentMapID][19]~=nil then
	tmpMap=mapInfo[mapWindow.CurrentMapID][19]
elseif Settings.language==3 and mapInfo[mapWindow.CurrentMapID][18] ~= nil then
	tmpMap=mapInfo[mapWindow.CurrentMapID][18]
elseif Settings.language==4 and mapInfo[mapWindow.CurrentMapID][20] ~= nil then
	tmpMap=mapInfo[mapWindow.CurrentMapID][20]
end
pcall(Turbine.UI.Control.SetBackground,mapWindow.Map,tmpMap);
mapWindow.Map:SetStretchMode(1);
mapWindow.Map:SetSize(mapWindow:GetSize());
mapWindow.CloseButton:SetLeft(mapWindow:GetWidth()-20);
mapWindow.Map.IconList:SetHeight(mapWindow.SearchPanel:GetHeight()-45);
mapWindow.Map.IconList.VScroll:SetHeight(mapWindow.Map.IconList:GetHeight());
mapWindow.Map.IconSearch:SetWantsUpdates(false);

-- overlay map info
overlayWindow.Name:SetText(Resource[Settings.language][mapInfo[mapWindow.CurrentMapID][2]]);
overlayWindow.MapW:SetText(mapInfo[mapWindow.CurrentMapID][4]);
overlayWindow.MapH:SetText(mapInfo[mapWindow.CurrentMapID][5]);

function AddPing(EWCoord,NSCoord,Name,Description)
	local tmpAnnotIndex;
	local tmpIndex;
	local tmpName=string.lower(tostring(Name));
	local tmpAnnotName;
	local pos;
	local found=false;
	for tmpIndex=1,#annotations do
		if annotations[tmpIndex][1]==mapWindow.CurrentMapID then
			if annotations[tmpIndex][6]~=nil then
				tmpAnnotName=mapStrings[Settings.language][annotations[tmpIndex][6]];
			else
				tmpAnnotName=annotations[tmpIndex][7];
			end
			if tmpAnnotName~=nil then
				pos=string.find(tmpAnnotName,":",1,true);
				if pos~=nil then
					tmpAnnotName=string.lower(string.sub(tmpAnnotName,1,pos-1));
				else
					tmpAnnotName=string.lower(tmpAnnotName);
				end
				if tmpName==tmpAnnotName then
					if math.abs(EWCoord-annotations[tmpIndex][2])<1 and math.abs(NSCoord-annotations[tmpIndex][3])<1 then
						-- same name and same basic area, treat as same annotation
						found=true;
						tmpAnnotIndex=tmpIndex;
						break;
					end
				end
			end
		end
	end
	if not found then
		-- need to insert criteria as a new annotation
		tmpAnnotIndex=#annotations+1
		annotations[tmpAnnotIndex]={mapWindow.CurrentMapID,EWCoord,NSCoord,5,1,nil,Name..": "..Description,0,0,0,0}
		RefreshMap();
		annotWindow.LoadAnnotationList();
	end
	if not mapWindow:IsVisible() then
		mapWindow:SetVisible(true);
		minWindow:SetVisible(false);
		quickWindow:SetVisible(quickWindow.Displayed);
		if BDDLegend~=nil then
			BDDLegend:SetVisible(BDDVis)
		end
	end
	-- and activate a "ping" for it
	mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
	mapWindow.Map.Ping:SetPosition(math.floor((annotations[tmpAnnotIndex][3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((annotations[tmpAnnotIndex][2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
	mapWindow.Map.Ping.State=1;
	mapWindow.Map.Ping:SetVisible(true);
	mapWindow.Map.Ping:SetWantsUpdates(true);
end
function RefreshBreadcrumbs()
	if Turbine.Engine:GetGameTime()>mapWindow.flashTime then
		mapWindow.flashTime=Turbine.Engine:GetGameTime()+.2;

		local tmpIndex;
		local tmpFlashIndex=mapWindow.flashIndex;
		for tmpIndex,icon in ipairs(mapWindow.Map.breadcrumbImage) do
			pcall(Turbine.UI.Control.SetBackground,icon,resourcePath.."Breadcrumb"..tostring(tmpFlashIndex)..".tga");
			tmpFlashIndex=tmpFlashIndex-1;
			if tmpFlashIndex<1 then tmpFlashIndex=5 end;
		end
		mapWindow.flashIndex=mapWindow.flashIndex+1;
		if mapWindow.flashIndex>5 then mapWindow.flashIndex=1 end;
	end
end

function RefreshMap(MapID)
if debug then Turbine.Shell.WriteLine("entering RefreshMap") end
	local tmpIndex;
	if MapID==nil then MapID=mapWindow.CurrentMapID end
	if debug then Turbine.Shell.WriteLine("mapWindow.CurrentMapID="..tostring(mapWindow.CurrentMapID)) end
	if mapWindow.Map.breadcrumbImage~=nil then
		local imageCount=#mapWindow.Map.breadcrumbImage
		if imageCount>0 then
			mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(false);
			mapWindow.Map.breadcrumbImage[1].Update=nil;
		end
		local tmpIndex;
		for tmpIndex=imageCount,1,-1 do
			mapWindow.Map.breadcrumbImage[tmpIndex]:SetVisible(false);
			mapWindow.Map.breadcrumbImage[tmpIndex]=nil;
		end
	end
	if MapID~=mapWindow.CurrentMapID then
		if MapID~=0 then
			-- we use MapID=0 to force a reload of the annotations
			mapWindow.CurrentMapID=MapID;
		end
		mapWindow.PreserveMapID=true;
		-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
		Turbine.PluginManager.LoadPlugin("MoorMapLoader");
	else
		-- strip asterisk and leading spaces from displayed value
		local txt=mapWindow.MapSelect.CurrentValue:GetText()
		if string.sub(txt,1,1)=='*' then txt=string.sub(txt,2) end
		mapWindow.MapSelect.CurrentValue:SetText(string.ltrim(txt))

		-- clear out the existing search list
		if debug then Turbine.Shell.WriteLine("clearing IconList") end
		while mapWindow.Map.IconList:GetItemCount()>0 do
			-- clear the event handler
			mapWindow.Map.IconList:GetItem(1).MouseClick=nil;
			mapWindow.Map.IconList:RemoveItemAt(1);
		end
		LoadMapsIns(); -- we load these first so that we can check them for annotations of type=8
		local XScale=mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4];
		local YScale=mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5];

		XScale=1; -- turns out, the parent in Stretchmode=1 automatically takes care of it's children :)
		YScale=1; -- I'm leaving the scaling variables in just in case I ever decide to display icons using the plugin window instead of the map control as parent

		local HFactor=mapInfo[mapWindow.CurrentMapID][6];
		local HOffset=mapInfo[mapWindow.CurrentMapID][7];
		local VFactor=mapInfo[mapWindow.CurrentMapID][8];
		local VOffset=mapInfo[mapWindow.CurrentMapID][9];
		local tmpIconIndex=0;
		local tmpDescription;
		local tmpShortDescription;
		local pos1;
		local tmpList={};
		local tmpVisible;

		for tmpIndex=1,#annotations do
			if annotations[tmpIndex][1]==mapWindow.CurrentMapID then
				tmpIconIndex=tmpIconIndex+1;
				-- check if we need a new control
				if tmpIconIndex>#mapWindow.Map.Icons then
					mapWindow.Map.Icons[tmpIconIndex]=Turbine.UI.Control();
					mapWindow.Map.Icons[tmpIconIndex]:SetParent(mapWindow.Map)
					mapWindow.Map.Icons[tmpIconIndex]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
				end
				mapWindow.Map.Icons[tmpIconIndex]:SetBackColor(Turbine.UI.Color(0,0,0,0));
				mapWindow.Map.Icons[tmpIconIndex]:SetBackColorBlendMode(8);
				mapWindow.Map.Icons[tmpIconIndex]:SetZOrder(100);
				if iconInfo[annotations[tmpIndex][4]]~=nil then
					mapWindow.Map.Icons[tmpIconIndex]:SetSize(iconInfo[annotations[tmpIndex][4]][2],iconInfo[annotations[tmpIndex][4]][3]);
					local tmpIcon=iconInfo[annotations[tmpIndex][4]][4]
					if tonumber(tmpIcon)~=nil and tonumber(tmpIcon)~=0 then
						mapWindow.Map.Icons[tmpIconIndex]:SetBackground(tmpIcon);
					else
						local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.Map.Icons[tmpIconIndex],resourcePath..tmpIcon);
					end
					mapWindow.Map.Icons[tmpIconIndex]:SetPosition(math.floor((annotations[tmpIndex][3]*HFactor+HOffset)*XScale)-iconInfo[annotations[tmpIndex][4]][2]/2,math.floor((annotations[tmpIndex][2]*VFactor+VOffset)*YScale)-iconInfo[annotations[tmpIndex][4]][3]/2);
				end
				-- need to test filters
				tmpVisible=true;
				if annotations[tmpIndex][5]==2 then
					if not mapWindow.FilterPanel.AllegianceCreep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][5]==3 then
					if not mapWindow.FilterPanel.AllegianceFreep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][5]==4 then
					if not mapWindow.FilterPanel.AllegianceDelving:IsChecked() then tmpVisible=false end
				end
				if annotations[tmpIndex][4]==8 or annotations[tmpIndex][4]==9 or annotations[tmpIndex][4]==10 or annotations[tmpIndex][4]==12 then
					local tmpFilter=mapWindow.FilterPanel.Filters["Map"]
					if not tmpFilter.CB:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==43 then
--					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[Settings.language][iconInfo[43][1]]]
					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[1][iconInfo[43][1]]] -- filters are based on English regardless of language in use
					if not (tmpFilter.CB:IsChecked() and (mapWindow.FilterPanel.TypeOreNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeOreNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==44 then
--					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[Settings.language][iconInfo[44][1]]]
					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[1][iconInfo[44][1]]] -- filters are based on English regardless of language in use
					if not (tmpFilter.CB:IsChecked() and (mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==45 then
--					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[Settings.language][iconInfo[45][1]]] -- filters are based on English regardless of language in use
					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[1][iconInfo[45][1]]] -- filters are based on English regardless of language in use
					if not (tmpFilter.CB:IsChecked() and (mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==51 or annotations[tmpIndex][4]==52 then
					local tmpFilter=mapWindow.FilterPanel.Filters["Stair"]
					if not tmpFilter.CB:IsChecked() then tmpVisible=false end
				else
					local tmpFilter=mapWindow.FilterPanel.Filters[Resource[Settings.language][iconInfo[annotations[tmpIndex][4]][1]]]
					if tmpFilter~=nil then
						if not tmpFilter.CB:IsChecked() then tmpVisible=false end
					end
				end
				mapWindow.Map.Icons[tmpIconIndex].FilterVisible=tmpVisible
				mapWindow.Map.Icons[tmpIconIndex]:SetVisible(tmpVisible);

				mapWindow.Map.Icons[tmpIconIndex].AnnotationIndex=tmpIndex;
				mapWindow.Map.Icons[tmpIconIndex].IconIndex=annotations[tmpIndex][4];
				tmpDescription=annotations[tmpIndex][7]; -- use custom text by default
				if tmpDescription==nil or tmpDescription=="" then
					if annotations[tmpIndex][6]~=nil then
						if mapStrings[Settings.language][annotations[tmpIndex][6]]~=nil then
							tmpDescription=mapStrings[Settings.language][annotations[tmpIndex][6]]; -- use translated text if found
						elseif mapStrings[1][annotations[tmpIndex][6]]~=nil then
							tmpDescription=mapStrings[1][annotations[tmpIndex][6]]; -- fall back to english if translated text not found
						end
					end
				end
				tmpShortDescription="";
				pos1=string.find (tmpDescription,":",0,true);
				if (pos1~=nil)then
					tmpShortDescription=string.sub(tmpDescription,1,pos1-1);
					tmpDescription=string.sub(tmpDescription,pos1+1);
				end
				mapWindow.Map.Icons[tmpIconIndex].Description=tmpDescription;
				mapWindow.Map.Icons[tmpIconIndex].ShortDescription=tmpShortDescription;
				tmpList[#tmpList+1]={tmpIndex,tmpShortDescription,1,tmpIconIndex};
				if annotations[tmpIndex][2]<0 then
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=tostring(0-math.floor(annotations[tmpIndex][2]*10)/10).."S, ";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2].."("..tostring(0-math.floor(annotations[tmpIndex][2]*10)/10).."S, ";
					end
				else
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=tostring(math.floor(annotations[tmpIndex][2]*10)/10).."N, ";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2].."("..tostring(math.floor(annotations[tmpIndex][2]*10)/10).."N, ";
					end
				end
				if annotations[tmpIndex][3]<0 then
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=mapWindow.Map.Icons[tmpIconIndex].MapCoord..tostring(0-math.floor(annotations[tmpIndex][3]*10)/10).."W";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2]..tostring(0-math.floor(annotations[tmpIndex][3]*10)/10).."W)";
					end
				else
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=mapWindow.Map.Icons[tmpIconIndex].MapCoord..tostring(math.floor(annotations[tmpIndex][3]*10)/10).."E";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2]..tostring(math.floor(annotations[tmpIndex][3]*10)/10).."E)";
					end
				end
				mapWindow.Map.Icons[tmpIconIndex].XYCoord=tostring(math.floor((annotations[tmpIndex][3]*HFactor+HOffset)*XScale))..", "..tostring(math.floor((annotations[tmpIndex][2]*VFactor+VOffset)*YScale));
				if annotations[tmpIndex][4]==8 or annotations[tmpIndex][4]==9 or annotations[tmpIndex][4]==10 or annotations[tmpIndex][4]==12 then
					tmpList[#tmpList][3]=2;
					-- check whether there is a MapPoint set for this point (character must have the map in their inventory)
					local mapFound=false;
					local tmpMPIndex;
					for tmpMPIndex=1,#mapWindow.Map.MapPoints.Item do
						if mapWindow.Map.MapPoints.Item[tmpMPIndex].V==annotations[tmpIndex][2] and mapWindow.Map.MapPoints.Item[tmpMPIndex].H==annotations[tmpIndex][3] then
							mapFound=true;
							break;
						end
					end
					if mapFound then
						mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(false)
						mapWindow.Map.Icons[tmpIconIndex].MouseEnter=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=nil;

					else
						-- do we want to use the "unearned" icon?
						mapWindow.Map.Icons[tmpIconIndex].IconIndex=13;
						local tmpIcon=iconInfo[13][4]
						if tonumber(tmpIcon)~=nil and tonumber(tmpIcon)~=0 then
							mapWindow.Map.Icons[tmpIconIndex]:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.Map.Icons[tmpIconIndex],resourcePath..tmpIcon);
						end

						mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
						mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
							local tmpIcon=iconInfo[sender.IconIndex][5]
							if tonumber(tmpIcon)~=nil then
								sender:SetBackground(tmpIcon);
							else
								local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
							end
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							local tmpIcon=iconInfo[sender.IconIndex][4]
							if tonumber(tmpIcon)~=nil then
								sender:SetBackground(tmpIcon);
							else
								local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
							end
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
							if width<100 then width=100 end
							mapWindow.Map.HoverWindow:SetWidth(width+10);							
							mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
							mapWindow.Map.HoverWindow.MapID=nil;
							mapWindow.Map.HoverWindow.Name.MouseClick=nil;
							if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
								mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
								local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
								sc:SetData("/way target "..sender.MapCoord);
								mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
								mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(Settings.EnableWaypoint);
							else
								mapWindow.Map.HoverWindow.Coord:SetText("");
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
							end
							mapWindow.Map.HoverWindow.Edit:SetVisible(false);
							mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
							mapWindow.Map.HoverWindow.Hide=false;
							mapWindow.Map.HoverWindow.HideCount=0;
							mapWindow.Map.HoverWindow:SetVisible(true);
							mapWindow.Map.HoverWindow:SetWantsUpdates(true);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
								mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
								mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil; -- dismiss the dialog
							end
							local text="<rgb=#FFFFFF>Location: "..tostring(sender.MapCoord).."</rgb>\n\n"..sender.Description.."\n";
							mapWindow.PopUp=PopUpDialog(sender.ShortDescription,text,4,"OK",nil,nil,true)
							mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
							if mapWindow.PopUpTop~=-1 then
								mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
							end
						end
					end


				elseif annotations[tmpIndex][4]==41 or annotations[tmpIndex][4]==51 or annotations[tmpIndex][4]==52 then
					tmpList[#tmpList][3]=2; -- map connector
					mapWindow.Map.Icons[tmpIconIndex].MapID=annotations[tmpIndex][8];
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						local tmpIcon=iconInfo[sender.IconIndex][5]
						if tonumber(tmpIcon)~=nil then
							sender:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
						end
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
						local tmpIcon=iconInfo[sender.IconIndex][4]
						if tonumber(tmpIcon)~=nil then
							sender:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
						end
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
						-- switch to the indicated map
						RefreshMap(sender.MapID);
					end
				elseif annotations[tmpIndex][4]==49 then
					tmpList[#tmpList][3]=2; -- interior location

					mapWindow.Map.Icons[tmpIconIndex].MapID=annotations[tmpIndex][8];
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						local tmpIcon=iconInfo[sender.IconIndex][5]
						if tonumber(tmpIcon)~=nil then
							sender:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
						end
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
						local tmpIcon=iconInfo[sender.IconIndex][4]
						if tonumber(tmpIcon)~=nil then
							sender:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
						end
					end
					if mapWindow.Map.Icons[tmpIconIndex].MapID~=nil and mapWindow.Map.Icons[tmpIconIndex].MapID>0 then
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							-- not really sure I like this functionality
							local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
							if width<100 then width=100 end
							mapWindow.Map.HoverWindow:SetWidth(width+10);							
							mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
							mapWindow.Map.HoverWindow.MapID=sender.MapID;
							mapWindow.Map.HoverWindow.Name.MouseClick=function(target)
								if mapWindow.Map.HoverWindow.MapID~=nil then
									RefreshMap(mapWindow.Map.HoverWindow.MapID);
									mapWindow.Map.HoverWindow:SetVisible(false);
								end
							end
							mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
							mapWindow.Map.HoverWindow.Waypoint:SetVisible(Settings.EnableWaypoint);
							local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
							sc:SetData("/way target "..sender.MapCoord);
							mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
							mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
							mapWindow.Map.HoverWindow.Edit:SetVisible(false);
							mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
							mapWindow.Map.HoverWindow.Hide=false;
							mapWindow.Map.HoverWindow.HideCount=0;
							mapWindow.Map.HoverWindow:SetVisible(true);
							mapWindow.Map.HoverWindow:SetWantsUpdates(true);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							-- switch to the indicated map
							RefreshMap(sender.MapID);
						end
					else
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
							if width<100 then width=100 end
							mapWindow.Map.HoverWindow:SetWidth(width+10);
							mapWindow.Map.HoverWindow.MapCoord=sender.MapCoord;
							mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
							mapWindow.Map.HoverWindow.ShortDescription=sender.ShortDescription;
							mapWindow.Map.HoverWindow.Description=sender.Description;
							mapWindow.Map.HoverWindow.Name.MouseClick=function(target)
								if mapWindow.PopUp~=nil then
									mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
									mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
									mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
									mapWindow.PopUp:SetVisible(false);
									mapWindow.PopUp=nil;
								end
								local text="<rgb=#FFFFFF>Location: "..tostring(mapWindow.Map.HoverWindow.MapCoord).."</rgb>\n\n"..mapWindow.Map.HoverWindow.Description.."\n";
								mapWindow.PopUp=PopUpDialog(mapWindow.Map.HoverWindow.ShortDescription,text,4,"OK",nil,nil,true)
								mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
								if mapWindow.PopUpTop~=-1 then
									mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
								end
								mapWindow.Map.HoverWindow:SetVisible(false);
							end
							mapWindow.Map.HoverWindow.MapID=nil;
							if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
								mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
								local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
								sc:SetData("/way target "..sender.MapCoord);
								mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
								mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(Settings.EnableWaypoint);
							else
								mapWindow.Map.HoverWindow.Coord:SetText("");
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
							end
							annotWindow:SelectAnnotation(sender.AnnotationIndex);
							if annotations[sender.AnnotationIndex][6]==nil then
								mapWindow.Map.HoverWindow.Edit:SetText(Resource[Settings.language][83]);
								mapWindow.Map.HoverWindow.Edit:SetVisible(true);
							else
								-- we no longer allow editing default annotations (creates conflicts with updates)
								mapWindow.Map.HoverWindow.Edit:SetVisible(false);
							end
							if debug then
								mapWindow.Map.HoverWindow.XY:SetText(sender.XYCoord);
							end
							mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
							mapWindow.Map.HoverWindow.Hide=false;
							mapWindow.Map.HoverWindow.HideCount=0;
							mapWindow.Map.HoverWindow:SetVisible(true);
							mapWindow.Map.HoverWindow:SetWantsUpdates(true);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
								mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
								mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil; -- dismiss the dialog
							end
							local text="<rgb=#FFFFFF>Location: "..tostring(sender.MapCoord).."</rgb>\n\n"..sender.Description.."\n";
							mapWindow.PopUp=PopUpDialog(sender.ShortDescription,text,4,"OK",nil,nil,true)
							mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
							if mapWindow.PopUpTop~=-1 then
								mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
							end
						end
					end
				else
					if annotations[tmpIndex][4]==11 or annotations[tmpIndex][4]==14 or annotations[tmpIndex][4]==15 or annotations[tmpIndex][4]==16 or annotations[tmpIndex][4]==20 or annotations[tmpIndex][4]==21 or annotations[tmpIndex][4]==25 or annotations[tmpIndex][4]==34 or annotations[tmpIndex][4]==35 or annotations[tmpIndex][4]==37 or annotations[tmpIndex][4]==38 or annotations[tmpIndex][4]==39 or annotations[tmpIndex][4]==40 then
						tmpList[#tmpList][3]=3; -- npc
					end
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						local tmpIcon=iconInfo[sender.IconIndex][5]
						if tonumber(tmpIcon)~=nil then
							sender:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
						end
					end
					if annotations[tmpIndex][4]==11 then
						-- can't use the backcolor mechanism because there is no way to reset the back color to undefined state for reuse
						-- color npc icons based on allegiance
						if annotations[tmpIndex][5]==2 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="NPC_red.tga"
						elseif annotations[tmpIndex][5]==3 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="NPC_blue.tga"
						elseif annotations[tmpIndex][5]==1 then -- netral
							mapWindow.Map.Icons[tmpIconIndex].Icon="NPC_yellow.tga"
						elseif annotations[tmpIndex][5]==4 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="NPC_violet.tga"
						else
							mapWindow.Map.Icons[tmpIconIndex].Icon="NPC.tga"
							mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
								local tmpIcon=iconInfo[sender.IconIndex][4]
								if tonumber(tmpIcon)~=nil then
									sender:SetBackground(tmpIcon);
								else
									local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
								end
							end
						end
						local tmpIcon=mapWindow.Map.Icons[tmpIconIndex].Icon
						if tonumber(tmpIcon)~=nil then
							sender:SetBackground(tmpIcon);
						else
							local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.Map.Icons[tmpIconIndex],resourcePath..tmpIcon);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							local tmpIcon=sender.Icon
							if tonumber(tmpIcon)~=nil then
								sender:SetBackground(tmpIcon);
							else
								local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
							end
						end

					else
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							local tmpIcon=iconInfo[sender.IconIndex][4]
							if tonumber(tmpIcon)~=nil then
								sender:SetBackground(tmpIcon);
							else
								local success,result=pcall(Turbine.UI.Control.SetBackground,sender,resourcePath..tmpIcon);
							end
						end
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
						local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
						if width<100 then width=100 end
						mapWindow.Map.HoverWindow:SetWidth(width+10);							
						mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
						mapWindow.Map.HoverWindow.ShortDescription=sender.ShortDescription;
						mapWindow.Map.HoverWindow.Description=sender.Description;
						mapWindow.Map.HoverWindow.MapCoord=sender.MapCoord;
						mapWindow.Map.HoverWindow.Name.MouseClick=function(target)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
								mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
								mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil;
							end
							local text="<rgb=#FFFFFF>Location: "..tostring(mapWindow.Map.HoverWindow.MapCoord).."</rgb>\n\n"..mapWindow.Map.HoverWindow.Description.."\n";
							mapWindow.PopUp=PopUpDialog(mapWindow.Map.HoverWindow.ShortDescription,text,4,"OK",nil,nil,true)
							mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
							if mapWindow.PopUpTop~=-1 then
								mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
							end
							mapWindow.Map.HoverWindow:SetVisible(false);
						end
						mapWindow.Map.HoverWindow.MapID=nil;
						if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
							mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
							local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
							sc:SetData("/way target "..sender.MapCoord);
							mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
							mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
							mapWindow.Map.HoverWindow.Waypoint:SetVisible(Settings.EnableWaypoint);
						else
							mapWindow.Map.HoverWindow.Coord:SetText("");
							mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
						end
						annotWindow:SelectAnnotation(sender.AnnotationIndex);
						if annotations[sender.AnnotationIndex][6]==nil then
							mapWindow.Map.HoverWindow.Edit:SetText(Resource[Settings.language][83]);
							mapWindow.Map.HoverWindow.Edit:SetVisible(true);
						else
							-- we no longer allow editing default annotations (creates conflicts with updates)
							mapWindow.Map.HoverWindow.Edit:SetVisible(false);
						end
						if debug then
							mapWindow.Map.HoverWindow.XY:SetText(sender.XYCoord);
						end
						mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
						mapWindow.Map.HoverWindow.Hide=false;
						mapWindow.Map.HoverWindow.HideCount=0;
						mapWindow.Map.HoverWindow:SetVisible(true);
						mapWindow.Map.HoverWindow:SetWantsUpdates(true);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
						if mapWindow.PopUp~=nil then
							mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
							mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
							mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
							mapWindow.PopUp:SetVisible(false);
							mapWindow.PopUp=nil; -- dismiss the dialog
						end
						local text="<rgb=#FFFFFF>Location: "..tostring(sender.MapCoord).."</rgb>\n\n"..sender.Description.."\n";
						mapWindow.PopUp=PopUpDialog(sender.ShortDescription,text,4,"OK",nil,nil,true)
						mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
						if mapWindow.PopUpTop~=-1 then
							mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
						end
					end
				end
			end
		end	
		local tmpLabel;
		mapWindow.MapSelect:SetZOrder(101+tmpIconIndex);
		-- sort list by col3 (type 1-3), then col2 (name)
		table.sort(tmpList,function(arg1,arg2) if arg1[3]<arg2[3] then return(true) else if arg1[3]==arg2[3] and arg1[2]<arg2[2] then return(true) end end end);
		local tmpType=0;
		for tmpIndex=1,#tmpList do
			if tmpList[tmpIndex][3]~=tmpType then
				-- insert headers
				tmpType=tmpList[tmpIndex][3];
				tmpLabel=Turbine.UI.Label()
				tmpLabel:SetSize(mapWindow.Map.IconList:GetWidth()-12,20);
				tmpLabel:SetBackColor(Turbine.UI.Color(.1,.1,.05));
				tmpLabel:SetForeColor(Settings.headingsColor);
				tmpLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
				tmpLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);
				tmpLabel:SetMultiline(false);
				tmpLabel.IconIndex=0;
				tmpLabel.AnnotationIndex=0;
				tmpLabel.NormalHeight=20;
				tmpLabel:SetText(Resource[Settings.language][73]);
				if tmpType==1 then
					tmpLabel:SetText(Resource[Settings.language][86])
				elseif tmpType==2 then
					tmpLabel:SetText(Resource[Settings.language][119])
				elseif tmpType==3 then
					tmpLabel:SetText(Resource[Settings.language][116])
				end
				mapWindow.Map.IconList:AddItem(tmpLabel);
			end
			tmpLabel=Turbine.UI.Label()
			tmpLabel:SetSize(mapWindow.Map.IconList:GetWidth()-12,18);
			tmpLabel:SetBackColor(mapWindow.Map.IconList:GetBackColor());
			tmpLabel:SetForeColor(Settings.listTextColor);
			tmpLabel:SetMultiline(false);
			tmpLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
			tmpLabel:SetFont(fontFace);
			tmpLabel.NormalHeight=18;
			tmpLabel:SetText(tmpList[tmpIndex][2])
			tmpLabel.IconIndex=tmpList[tmpIndex][4];
			tmpLabel.AnnotationIndex=tmpList[tmpIndex][1];
			if annotations[tmpLabel.AnnotationIndex][5]==2 then
				tmpLabel:SetForeColor(Turbine.UI.Color(1,0,0));
			elseif annotations[tmpLabel.AnnotationIndex][5]==3 then
				tmpLabel:SetForeColor(Turbine.UI.Color(.35,.35,1));
			elseif annotations[tmpLabel.AnnotationIndex][5]==4 then
				tmpLabel:SetForeColor(Turbine.UI.Color(.5,.35,.7));
			end
			local tmpDescription=annotations[tmpList[tmpIndex][1]][7]; -- use custom text by default
			if tmpDescription==nil or tmpDescription=="" then
				if annotations[tmpList[tmpIndex][1]][6]~=nil then
					if mapStrings[Settings.language][annotations[tmpList[tmpIndex][1]][6]]~=nil then
						tmpDescription=mapStrings[Settings.language][annotations[tmpList[tmpIndex][1]][6]]; -- use translated text if found
					elseif Resource[1][annotations[tmpList[tmpIndex][1]][6]]~=nil then
						tmpDescription=Resource[1][annotations[tmpList[tmpIndex][1]][6]]; -- fall back to english if translated text not found
					end
				end
			end
			local tmpShortDescription="";
			local pos1=string.find (tmpDescription,":",1,true);
			if (pos1~=nil)then
				tmpShortDescription=string.sub(tmpDescription,1,pos1-1);
				tmpDescription=string.sub(tmpDescription,pos1+1);
			end
			tmpLabel.Description=tmpDescription;
			tmpLabel.ShortDescription=tmpShortDescription;
			tmpLabel.MouseClick=function(sender,args)
				if args.Button==1 then
					mapWindow.SearchPanel:SetVisible(false);
					mapWindow.Map.IconSearch:SetWantsUpdates(false);
					mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
					mapWindow.Map.Ping:SetPosition(math.floor((annotations[sender.AnnotationIndex][3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((annotations[sender.AnnotationIndex][2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
					mapWindow.Map.Ping.State=1;
					mapWindow.Map.Ping:SetVisible(true);
					mapWindow.Map.Ping:SetWantsUpdates(true);
				else
					if mapWindow.PopUp~=nil then
						mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
						mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
						mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
						mapWindow.PopUp:SetVisible(false);
						mapWindow.PopUp=nil;
					end
					mapWindow.PopUp=PopUpDialog(sender.ShortDescription,sender.Description,4,"OK",nil,nil,true)
					mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
					if mapWindow.PopUpTop~=-1 then
						mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
					end
				end
			end
			mapWindow.Map.IconList:AddItem(tmpLabel);
		end

		-- for a refresh of the list
		mapWindow.Map.IconSearch.OldAllegianceDelving=not mapWindow.Map.IconDelvingCB:IsChecked();
		mapWindow.Map.IconSearch.Update();

		while #mapWindow.Map.Icons>tmpIconIndex do
			-- dispose of any unused controls that we already created
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseEnter=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseLeave=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseHover=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseClick=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons]:SetVisible(false);-- need to invalidated the area where this control was draw to force a refresh
			table.remove(mapWindow.Map.Icons,#mapWindow.Map.Icons);
		end
		if mapWindow.Breadcrumbs~=nil and #mapWindow.Breadcrumbs>0 then
			mapWindow.Map.breadcrumbImage={};
			for tmpIconIndex=1,#mapWindow.Breadcrumbs do
				-- create array of small controls that can "pulse" to show the path followed
				mapWindow.Map.breadcrumbImage[tmpIconIndex]=Turbine.UI.Control();
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetParent(mapWindow.Map);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetSize(5,5);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetPosition(math.floor((mapWindow.Breadcrumbs[tmpIconIndex][1]*HFactor+HOffset)*XScale-2.5),math.floor((mapWindow.Breadcrumbs[tmpIconIndex][2]*VFactor+VOffset)*YScale-2.5));
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColor(Settings.breadcrumbColor);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetZOrder(1000)
			end
			mapWindow.Map.breadcrumbImage[1].Update=function()
				RefreshBreadcrumbs();
			end
			mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(true);
		end
	end
end

AddMapItem=function(mapItem, V, H)
	local HFactor=mapInfo[mapWindow.CurrentMapID][6];
	local HOffset=mapInfo[mapWindow.CurrentMapID][7];
	local VFactor=mapInfo[mapWindow.CurrentMapID][8];
	local VOffset=mapInfo[mapWindow.CurrentMapID][9];

	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints+1]=Turbine.UI.Control();
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetPosition(math.floor(H*HFactor+HOffset)-9,math.floor(V*VFactor+VOffset)-9);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetSize(18,18);

	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]=Turbine.UI.Lotro.ItemControl();
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].V=V;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].H=H;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetPosition(-34,-34);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetSize(64,64);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetItem(mapItem);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetVisible(true);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=function(sender, args)
		if args.Button==2 then
			mapWindow:SetVisible(false);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(false)
			end
		end
	end
end
AddMapSkill=function(mapSkill, V, H)
	local HFactor=mapInfo[mapWindow.CurrentMapID][6];
	local HOffset=mapInfo[mapWindow.CurrentMapID][7];
	local VFactor=mapInfo[mapWindow.CurrentMapID][8];
	local VOffset=mapInfo[mapWindow.CurrentMapID][9];

	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints+1]=Turbine.UI.Control();
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetPosition(math.floor(H*HFactor+HOffset)-9,math.floor(V*VFactor+VOffset)-9);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetSize(18,18);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]=Turbine.UI.Lotro.Quickslot();
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].V=V;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].H=H;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetPosition(-34,-34);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetSize(64,64);
	local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, string.format("0x%x",mapSkill));
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetShortcut(sc);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetVisible(true);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=function(sender, args)
		if args.Button==2 then
			mapWindow:SetVisible(false);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(false)
			end
		end
	end
end
LoadMapsIns=function()
	if mapWindow.CurrentMapID==1 then
		-- replace the old Map items with the skills
		if localPlayer:GetAlignment()== Turbine.Gameplay.Alignment.MonsterPlayer then
-- currently no way to determine whether players have a specific skill...
--			AddMapSkill(0x70028BBC,-12.3,-20.9); -- crude Grams
			AddMapSkill(0x70028BC1,-12.3,-20.9); -- grams
			AddMapSkill(0x70028BB7,-16.1,-20.9); -- crude lugz
			AddMapSkill(0x70028BB6,-17.1,-18.6); -- crude ta
			AddMapSkill(0x70028BBE,-14.63,-15.78); -- crude tr
			AddMapSkill(0x70028BB3,-13.4,-12.8); -- crude isen
			AddMapSkill(0x70028BBF,-18.3,-18.6); -- crude grimwood
			AddMapSkill(0x70028BB2,-14.2,-21.0); -- poor lugz
			AddMapSkill(0x70028BB1,-16.0,-17.0); -- poor ta
--			AddMapSkill(0x70028BB4,-17.8,-15.3); -- poor tr
			AddMapSkill(0x70028BB4,-15.7,-14.22); -- poor tr changed with Ettens revamp
			AddMapSkill(0x70028BAF,-14.7,-14.5); -- poor isen
			AddMapSkill(0x70028BB9,-18.9,-17.9); -- poor grimwood
			AddMapSkill(0x70028BB5,-14.54,-19.07); -- good lugz
			AddMapSkill(0x70028BC2,-17.9,-18.1); -- good ta
--			AddMapSkill(0x70028BB0,-15.7,-14.2); -- good tr
			AddMapSkill(0x70028BB0,-17.85,-15.33); -- good tr changed with Ettens revamp
			AddMapSkill(0x70028BC0,-11.5,-19.1); -- good isen
			AddMapSkill(0x70028BBD,-20.3,-16.8); -- good grimwood
		end

		-- search through bags looking for matches to the map names
		local tmpBackpack=localPlayer:GetBackpack();
		local tmpBPIndex;
		local tmpItem;
		local tmpCrudeGV;
		local addCrudeGV=false;
		for tmpBPIndex=1,tmpBackpack:GetSize() do
			tmpItem=tmpBackpack:GetItem(tmpBPIndex);
			if tmpItem~=nil then
				if tmpItem:GetName()==Resource[Settings.language][104] then
					tmpCrudeGV=tmpItem;
				elseif tmpItem:GetName()==Resource[Settings.language][105] then
					addCrudeGV=false;
					AddMapItem(tmpItem,-20.9,-13.4);
				end
			end
		end
		if addCrudeGV and tmpCrudeGV~=nil then
			AddMapItem(tmpCrudeGV,-20.9,-13.4);
		end
	else
	-- remove the map points
		while #mapWindow.Map.MapPoints>0 do
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseClick=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseHover=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseEnter=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseLeave=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=nil;
			table.remove(mapWindow.Map.MapPoints.Item,#mapWindow.Map.MapPoints);
			table.remove(mapWindow.Map.MapPoints,#mapWindow.Map.MapPoints);

		end
	end
end

function mapWindow:SetEnabled(state)
	if mapWindow.ControlPanel.OptionsButton~=nil then
		mapWindow.ControlPanel.OptionsButton:SetMouseVisible(state);
	end
	mapWindow.ControlPanel.AnnotationsButton:SetMouseVisible(state);
end

function mapWindow:SetVisible(value)
	Turbine.UI.Lotro.Window.SetVisible( mapWindow, value );
	if BDDLegend~=nil then
		BDDLegend:SetVisible(BDDVis and value)
	end
end
mapWindow.ExportingCustom=false

function mapWindow:Update( sender, args )
	local tmpIndex;
	if (Plugins["MoorMap"] ~= nil) and (not mapWindow.Loaded) then
		if mapWindow.ExportingCustom then
			-- check for "0MMEC" command
			if Turbine.Shell.IsCommand("0MMEC") then
				-- terminate exporter
				Turbine.PluginManager.UnloadScriptState("MMExport")
				mapWindow.ExportingCustom=false
				Turbine.Shell.RemoveCommand(mapWindow.exportCmd)
				mapWindow.exportCmd=nil
			end
		else
			if debug then Turbine.Shell.WriteLine("mapWindow.Update initializing") end
			-- if synchmap~=nil then remove command
			if Settings.TerrainMapCompatability==nil then
				-- prompt for compatability and set Settings.TMSynchInitialized
				mapWindow:SetVisible(false)
				if promptPopUp==nil then
					-- show the prompt popup dialog
					promptPopUp=PopUpDialog(Resource[Settings.language][416],Resource[Settings.language][417],2,"Yes","No",nil)
					promptPopUp.Buttons[1].Click=function() Settings.TMSynchInitialized=false;Settings.TerrainMapCompatability=true;promptPopUp:SetVisible(false);promptPopUp=nil; InitShowState() end
					promptPopUp.Buttons[2].Click=function() Settings.TMSynchInitialized=true;Settings.TerrainMapCompatability=false;promptPopUp:SetVisible(false);promptPopUp=nil; InitShowState() end
				end
			else
				if Settings.TMSynchInitialized==false then
					-- TM custom files were never generated, create them now
					-- show a custom window
					if mapWindow.SynchMap==nil then
						exportDisplay=Turbine.UI.Lotro.Window();
						exportDisplay:SetSize(400,165);
						exportDisplay:SetPosition((Turbine.UI.Display:GetWidth() - exportDisplay:GetWidth())/2,(Turbine.UI.Display:GetHeight() - exportDisplay:GetHeight())/2)
						exportDisplay:SetText(Resource[Settings.language][411]);
						exportDisplay.Message=Turbine.UI.Label()
						exportDisplay.Message:SetSize(200,60)
						exportDisplay.Message:SetPosition((exportDisplay:GetWidth()-exportDisplay.Message:GetWidth())/2,40)
						exportDisplay.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
						exportDisplay.Message:SetText(Resource[Settings.language][413]);

						exportDisplay.Status=Resource[Settings.language][412];
						exportDisplay.StatusText=Turbine.UI.Label();
						exportDisplay.StatusText:SetParent(exportDisplay);
						exportDisplay.StatusText:SetSize(200,18);
						exportDisplay.StatusText:SetPosition((exportDisplay:GetWidth()-exportDisplay.StatusText:GetWidth())/2,105);
						exportDisplay.StatusText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
						exportDisplay.StatusText:SetText(exportDisplay.Status);

						exportDisplay.MapText=Turbine.UI.Label();
						exportDisplay.MapText:SetParent(exportDisplay);
						exportDisplay.MapText:SetSize(200,18);
						exportDisplay.MapText:SetPosition((exportDisplay:GetWidth()-exportDisplay.MapText:GetWidth())/2,60);
						exportDisplay.MapText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

						exportDisplay:SetZOrder(mapWindow:GetZOrder()+1);
						exportDisplay:SetVisible(true)
						mmExportStartTime=Turbine.Engine.GetLocalTime()
						mmExportMapStartTime=Turbine.Engine.GetLocalTime()
						mapWindow.SynchMap=1
					else
						mapWindow.SynchMap=mapWindow.SynchMap+1
					end

					if debug then Turbine.Shell.WriteLine("synching custom annots for map:"..tostring(mapWindow.SynchMap)) end
					if mapWindow.SynchMap<=#mapInfo then
						exportDisplay.MapText:SetText(Resource[Settings.language][mapInfo[mapWindow.SynchMap][2]]);
						mapWindow.exportCmd=Turbine.ShellCommand()
						-- create a command "0MMEM_#" to tell exporter which map to export
						Turbine.Shell.AddCommand("0MMEM_"..tostring(mapWindow.SynchMap).."_"..tostring(startTime),mapWindow.exportCmd)
						if debug and mmExportMapStartTime~=nil then
							-- print time for last map
							Turbine.Shell.WriteLine("Elapsed Time ("..tostring(Resource[Settings.language][mapInfo[mapWindow.SynchMap-1][2]]).."):"..tostring(Turbine.Engine.GetLocalTime()-mmExportMapStartTime))
						end
						mmExportMapStartTime=Turbine.Engine.GetLocalTime()

						Turbine.PluginManager.LoadPlugin("MMExport")
						mapWindow.ExportingCustom=true
					else
						if debug and mmExportMapStartTime~=nil then
							-- print time for last map
							Turbine.Shell.WriteLine("Elapsed Time ("..tostring(Resource[Settings.language][mapInfo[mapWindow.SynchMap-1][2]]).."):"..tostring(Turbine.Engine.GetLocalTime()-mmExportMapStartTime))
						end
						if debug then
							-- print time for last map
							Turbine.Shell.WriteLine("Synch Elapsed Time Total:"..tostring(Turbine.Engine.GetLocalTime()-mmExportStartTime))
						end
						mmExportStartTime=nil
						mmExportMapStartTime=nil
						exportDisplay:SetVisible(false)
						exportDisplay=nil
						Turbine.Shell.RemoveCommand(mapWindow.exportCmd)
						mapWindow.exportCmd=nil
						Settings.TMSynchInitialized=true
					end
				else
					mapWindow.Loaded=true;
					Turbine.PluginManager.UnloadScriptState("MoorMapLoader");
					if not Settings.refreshing then
						Turbine.Shell.WriteLine("MoorMap "..Plugins["MoorMap"]:GetVersion()..Resource[Settings.language][13]);
					end
					Plugins["MoorMap"].Unload = function(mapWindow,sender,args)
						UnloadPlugin();
					end
					-- check for Waypoint
					local tmpPlugins=Turbine.PluginManager.GetAvailablePlugins();
					local pluginIndex;
					for pluginIndex=1,#tmpPlugins do
						if tmpPlugins[pluginIndex].Name=="Waypoint" then
							WaypointInstalled=true;
							break;
						end
					end
					if WaypointInstalled then
						tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
						for pluginIndex=1,#tmpPlugins do
							if tmpPlugins[pluginIndex].Name=="Waypoint" then
								WaypointRunning=true;
								break;
							end
						end
							if (not WaypointRunning) and Settings.EnableWaypoint then
							Turbine.PluginManager.LoadPlugin("Waypoint");
							WaypointRunning=true;
						end
						optionsCanvas.WaypointCB:SetVisible(true);
						optionsCanvas.WaypointMsg:SetVisible(false);
					else
						optionsCanvas.WaypointCB:SetVisible(false);
						optionsCanvas.WaypointMsg:SetVisible(true);
					end
					if Settings.EnableWaypoint and WaypointRunning then
						mapWindow.Map.HoverWindow.Coord:SetForeColor(Turbine.UI.Color(.85,.75,.2));
					end
				end
			end
		end
	elseif Settings.showPlayerLoc~=nil and Settings.showPlayerLoc==true then
		Settings.showPlayerLoc=nil
		mapWindow.PlayerIconVisible=true;
		-- show the player icon at mapWindow.playerNS, mapWindow.playerEW
		local X=math.floor(mapWindow.playerEW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
		local Y=math.floor(mapWindow.playerNS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
		if debug then
			Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
		end
		mapWindow.LocationIcon.X=X;
		mapWindow.LocationIcon.Y=Y;
		-- need to adjust for the stretching
		X=X*mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4]-14
		Y=Y*mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5]-14
		mapWindow.LocationIcon:SetPosition(X,Y);
					-- and activate a "ping" for it
					mapWindow.Map.Ping:SetZOrder(mapWindow.LocationIcon:GetZOrder()+1);
					mapWindow.Map.Ping:SetPosition(math.floor(mapWindow.LocationIcon.X-11.5),math.floor(mapWindow.LocationIcon.Y-11.5));
					mapWindow.Map.Ping.State=1;
					mapWindow.Map.Ping:SetVisible(true);
					mapWindow.Map.Ping:SetWantsUpdates(true);
		if mapWindow:IsVisible() then
			mapWindow.LocationIcon:SetVisible(true);
			mapWindow.LocationIcon:SetRotation({x=0,y=0,z=0-(mapWindow.Heading-90)});
		end
		mapWindow.LocationIcon:SetZOrder(101+#mapWindow.Map.Icons);

	elseif Settings.ExternalPing then
		Settings.ExternalPing=false;
		if Settings.pingName==nil or Settings.pingName=="" then
			-- just activate a "ping" for it
			mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
			mapWindow.Map.Ping:SetPosition(math.floor((Settings.pingEW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((Settings.pingNS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
			mapWindow.Map.Ping.State=1;
			mapWindow.Map.Ping:SetVisible(true);
			mapWindow.Map.Ping:SetWantsUpdates(true);
		else
			-- otherwise add a temporary annotation
			AddPing(Settings.pingNS,Settings.pingEW,Settings.pingName,Settings.pingDesc);
		end
	else
		-- we've satisfied all update needs, turn off the updates
		mapWindow:SetWantsUpdates(false);
		if mapWindow.NeedsRefresh then
			mapWindow.NeedsRefresh=false;
			RefreshMap();
		end
	end
end
mapWindow:LoadBreadcrumbs();
mapWindow:SetZOrder(mapWindow:GetZOrder()+1);
minWindow=MinimizedWindow();
if Settings.showIconWhenMinimized then
	if minWindow:GetUseMiniIcon() then
		minWindow:SetSize(16,16);
	else
		minWindow:SetSize(32,32);
	end
else
	minWindow:SetSize(0,0);
end

CreateMapList();
RefreshMap();
InitShowState=function()
	if Settings.loadMinimized and (not Settings.refreshing) then
		minWindow:SetVisible(true);
	else
		mapWindow:SetVisible(true);
	end
end
InitShowState()
quickWindow:SetVisible(quickWindow.Displayed);

mapWindow:LoadOverlays();

breadcrumbWindow=Turbine.UI.Lotro.Window();
breadcrumbWindow:SetSize(440,200);
breadcrumbWindow:SetPosition((Turbine.UI.Display:GetWidth()-breadcrumbWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-breadcrumbWindow:GetHeight())/2);
breadcrumbWindow:SetText(Resource[Settings.language][238]);
breadcrumbWindow.ColorLabel=Turbine.UI.Label();
breadcrumbWindow.ColorLabel:SetParent(breadcrumbWindow);
breadcrumbWindow.ColorLabel:SetSize(140,20);
breadcrumbWindow.ColorLabel:SetPosition(5,50);
breadcrumbWindow.ColorLabel:SetForeColor(Settings.fontColor)
breadcrumbWindow.ColorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18);
breadcrumbWindow.ColorLabel:SetText(Resource[Settings.language][239]..":");
breadcrumbWindow.Color=ColorPicker();
breadcrumbWindow.Color:SetParent(breadcrumbWindow);
breadcrumbWindow.Color:SetPosition(breadcrumbWindow.ColorLabel:GetLeft()+breadcrumbWindow.ColorLabel:GetWidth()+5,breadcrumbWindow.ColorLabel:GetTop()-5);
breadcrumbWindow.Color:SetTrimColor(Settings.trimColor);
breadcrumbWindow.Color:SetColor(Settings.breadcrumbColor);
breadcrumbWindow.Color.ColorChanged=function()
	Settings.breadcrumbColor=breadcrumbWindow.Color:GetColor();
	if mapWindow~=nil and mapWindow.Map.breadcrumbImage~=nil then
		for index,image in ipairs(mapWindow.Map.breadcrumbImage) do
			image:SetBackColor(Settings.breadcrumbColor);
		end
	end
end
breadcrumbWindow.ClearLabel=Turbine.UI.Label();
breadcrumbWindow.ClearLabel:SetParent(breadcrumbWindow);
breadcrumbWindow.ClearLabel:SetSize(140,20);
breadcrumbWindow.ClearLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18);
breadcrumbWindow.ClearLabel:SetPosition(5,75);
breadcrumbWindow.ClearLabel:SetForeColor(Settings.fontColor)
breadcrumbWindow.ClearLabel:SetText(Resource[Settings.language][240]..":");
breadcrumbWindow.ClearButton=Turbine.UI.Lotro.Button();
breadcrumbWindow.ClearButton:SetParent(breadcrumbWindow);
breadcrumbWindow.ClearButton:SetSize(100,20);
breadcrumbWindow.ClearButton:SetFont(Turbine.UI.Lotro.Font.Verdana18);
breadcrumbWindow.ClearButton:SetPosition(breadcrumbWindow.ClearLabel:GetLeft()+breadcrumbWindow.ClearLabel:GetWidth()+5,breadcrumbWindow.ClearLabel:GetTop());
breadcrumbWindow.ClearButton:SetText(Resource[Settings.language][241]);
breadcrumbWindow.ClearButton.Click=function()
	if mapWindow.Map.breadcrumbImage~=nil then
		local imageCount=#mapWindow.Map.breadcrumbImage
		if imageCount>0 then
			mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(false);
			mapWindow.Map.breadcrumbImage[1].Update=nil;
		end
		local tmpIndex;
		for tmpIndex=imageCount,1,-1 do
			mapWindow.Map.breadcrumbImage[tmpIndex]:SetVisible(false);
			mapWindow.Map.breadcrumbImage[tmpIndex]=nil;
			mapWindow.Breadcrumbs[tmpIndex]=nil;
		end
	end
end
breadcrumbWindow.SetFontColor=function()
	breadcrumbWindow.ColorLabel:SetForeColor(Settings.fontColor)
	breadcrumbWindow.ClearLabel:SetForeColor(Settings.fontColor)
end
annotWindow:LoadAnnotationList();
import (importPath.."OptionsPanel");

annotWindow:SetZOrder(mapWindow:GetZOrder()+1);
overlayWindow:SetZOrder(annotWindow:GetZOrder()+1);
breadcrumbWindow:SetZOrder(overlayWindow:GetZOrder()+1);
debugWindow:SetZOrder(breadcrumbWindow:GetZOrder()+1);
if debug then debugWindow:SetVisible(true) end
popOL();
overlayWindow.refreshOLList();
overlayWindow:SetLanguage();

if dataLoadError then
	-- warn the user and give them the opportunity to exit without saving
end

--Table.Dump(_G)
--testdialog=PopUpDialog("test1","just testing with a really long message to see how multiple lines are handled. let's see how it handles 3 lines. and now, the coup-de-gras, let's give it 4 lines :)",3,"abcdefghi","just testing","hmmmm")
--testdialog=PopUpDialog("test1","just testing",3,"abcdefghi","just testing","hmmmm")
--testdialog.Buttons[2].Click=function(sender)
--	Turbine.Shell.WriteLine("button 2 pressed");
--	sender:GetParent():SetVisible(false);
--end

drawGrid=function()
	-- this function is currently only for debugging purposes to determine how sectional maps line up
	if GridLine==nil then
		GridLine={}
		GridLabel={}
	else
		-- remove the prior grid
		for k,v in GridLine do
			v:SetVisible(false);
			GridLine[k]=nil;
			GridLabel[k]:SetVisible(false);
			GridLabel[k]=nil;
		end
	end
	if mapWindow.CurrentMapID~=nil then
		local north=mapInfo[mapWindow.CurrentMapID][13]
		local south=mapInfo[mapWindow.CurrentMapID][15]
		local west=mapInfo[mapWindow.CurrentMapID][14]
		local east=mapInfo[mapWindow.CurrentMapID][16]
		-- determine the most suitable scale
		local delta=north-south;
		if delta>=50 then
			delta=10
		elseif delta>=20 then
			delta=5
		elseif delta>=5 then
			delta=1
		elseif delta>=2 then
			delta=.5
		else
			delta=.1
		end
		-- now find the min ns coord that falls on the map
		NS=math.floor(south/delta)*delta-delta
		EW=math.floor(west/delta)*delta-delta
		-- now generate grid lines for NS
		local gridIndex=1;

		while NS<=north+delta and gridIndex<100 do
			local Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
			--get the y coordinate for this NS value
			-- draw a line from (0,y) to (displayWidth,y)
			GridLine[gridIndex]=Turbine.UI.Control();
			GridLine[gridIndex]:SetParent(mapWindow.Map);
			GridLine[gridIndex]:SetSize(mapWindow.Map:GetHeight()-100,1);
			GridLine[gridIndex]:SetPosition(100,Y);
			GridLine[gridIndex]:SetBackColor(Turbine.UI.Color.White);
			GridLabel[gridIndex]=Turbine.UI.Label();
			GridLabel[gridIndex]:SetParent(mapWindow.Map);
			GridLabel[gridIndex]:SetSize(100,20);
			GridLabel[gridIndex]:SetPosition(0,Y-10)
			GridLine[gridIndex]:SetMouseVisible(false);
			GridLabel[gridIndex]:SetMouseVisible(false);
			if NS>=0 then
				GridLabel[gridIndex]:SetText(tostring(NS).." N")
			else
				GridLabel[gridIndex]:SetText(tostring(0-NS).." S")
			end
			gridIndex=gridIndex+1;
			NS=NS+delta
		end

		-- now generate grid lines for EW
		while EW<=east+delta and gridIndex<200 do
			local X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
			GridLine[gridIndex]=Turbine.UI.Control();
			GridLine[gridIndex]:SetParent(mapWindow.Map);
			GridLine[gridIndex]:SetSize(1,mapWindow.Map:GetHeight()-80);
			GridLine[gridIndex]:SetPosition(X,80);
			GridLine[gridIndex]:SetBackColor(Turbine.UI.Color.White);
			GridLabel[gridIndex]=Turbine.UI.Label();
			GridLabel[gridIndex]:SetParent(mapWindow.Map);
			GridLabel[gridIndex]:SetSize(80,20);
			GridLabel[gridIndex]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
			GridLabel[gridIndex]:SetPosition(X-40,40)
			GridLine[gridIndex]:SetMouseVisible(false);
			GridLabel[gridIndex]:SetMouseVisible(false);
			if EW>=0 then
				GridLabel[gridIndex]:SetText(tostring(EW).." E")
			else
				GridLabel[gridIndex]:SetText(tostring(0-EW).." W")
			end
			gridIndex=gridIndex+1;
			EW=EW+delta
		end
	end
end
if debug then
	Turbine.Shell.WriteLine("finished processing main.lua");
end